TIA_BASE_READ_ADDRESS = $30

    processor 6502
    include "vcs.h"

UP_DIR      = %0001
DOWN_DIR    = %0010
LEFT_DIR    = %0100
RIGHT_DIR   = %1000

HORZ_DIR    = LEFT_DIR|RIGHT_DIR


weird       = $80
frameCntLo  = $81
frameCntHi  = $82
;---------------------------------------
scoreLst    = $83
scoreHiLst  = scoreLst
scoreMidLst = scoreLst+2
scoreLoLst  = scoreLst+4
;---------------------------------------
livesLst    = $89
livesP0     = livesLst
livesP1     = livesLst+1

player      = $8c
otherPlayer = $8d

scene       = $8f

time        = $99

xPos        = $a6

audVolLst   = $d0
audVol0     = audVolLst
audVol1     = audVolLst+1

screen      = $d6

otherScene  = $d8
otherScreen = $d9
otherTime   = $da




    ORG $1000
    RORG $f000

Lf000:
    lda    Lfff9            ; 4
    nop                     ; 2
    nop                     ; 2
    nop                     ; 2
    nop                     ; 2
    nop                     ; 2
    nop                     ; 2
    nop                     ; 2
    jmp    Lf740            ; 3

START:
    nop                     ; 2
    nop                     ; 2
    nop                     ; 2
    nop                     ; 2
    cld                     ; 2
    ldx    #$00             ; 2
    txa                     ; 2
Lf015:
    sta    $00,x            ; 4
    txs                     ; 2
    inx                     ; 2
    bne    Lf015            ; 2
    jsr    Lfd17            ; 6
    jsr    Lfcfc            ; 6
Lf021:
    lda    #$b2             ; 2
    sta    TIM64T           ; 4
    inc    frameCntLo       ; 5
    bne    Lf02c            ; 2
    inc    frameCntHi       ; 5
Lf02c:
    lda    SWCHB            ; 4
    lsr                     ; 2
    bcc    .reset           ; 2
    lda    $8b              ; 3
    beq    Lf03a            ; 2
    and    #$10             ; 2
    beq    Lf03e            ; 2
Lf03a:
    lda    INPT4            ; 3
    bpl    .reset           ; 2
Lf03e:
    lda    $8b              ; 3
    beq    Lf053            ; 2
    lda    SWCHB            ; 4
    and    #$02             ; 2
    bne    Lf080            ; 2
    sta    $8b              ; 3
    lda    #$ff             ; 2
    sta    $d4              ; 3
    lda    #$01             ; 2
    sta    $d5              ; 3
Lf053:
    lda    SWCHB            ; 4
    and    #$02             ; 2
    bne    Lf06a            ; 2
    lda    $d4              ; 3
    bmi    Lf06f            ; 2
Lf05e:
    lda    #$3c             ; 2
    sta    $d5              ; 3
    lda    $8e              ; 3
    eor    #$01             ; 2
    sta    $8e              ; 3
    lda    #$ff             ; 2
Lf06a:
    sta    $d4              ; 3
Lf06c:
    jmp    Lf188            ; 3

Lf06f:
    dec    $d5              ; 5
    beq    Lf05e            ; 2
    bne    Lf06c            ; 3

.reset:
    jsr    InitGame         ; 6
    lda    #$64             ; 2
    jsr    Lfe5f            ; 6
    jsr    Lfcfc            ; 6
Lf080:
    lda    $8b              ; 3
    tay                     ; 2
    and    #$2c             ; 2
    cmp    #$20             ; 2
    bcs    Lf0ae            ; 2
    cmp    #$04             ; 2
    beq    Lf0ba            ; 2
    cmp    #$08             ; 2
    beq    Lf0e2            ; 2
    tya                     ; 2
    and    #$10             ; 2
    beq    Lf099            ; 2
    jmp    Lf169            ; 3

Lf099:
    tya                     ; 2
    and    #$03             ; 2
    cmp    #$01             ; 2
    bne    Lf0a3            ; 2
    jmp    Lf12c            ; 3

Lf0a3:
    cmp    #$02             ; 2
    beq    Lf10a            ; 2+1
    cmp    #$03             ; 2
    bne    Lf0b7            ; 2
    jmp    Lf11e            ; 3

Lf0ae:
    dec    $d7              ; 5
    bne    Lf0b7            ; 2
    tya                     ; 2
    and    #$df             ; 2
    sta    $8b              ; 3
Lf0b7:
    jmp    Lf188            ; 3

Lf0ba:
    dec    $d7              ; 5
    bne    Lf0c8            ; 2
    lda    #$48             ; 2
    sta    $8b              ; 3
    lda    #$00             ; 2
    sta    $d7              ; 3
    beq    Lf0b7            ; 3

Lf0c8:
    lda    $a8              ; 3
    and    #$40             ; 2
    bne    Lf0b7            ; 2
    lda    $a8              ; 3
    ora    #$40             ; 2
    sta    $a8              ; 3
    lda    $a9              ; 3
    and    #$7c             ; 2
    ora    #$02             ; 2
    sta    $a9              ; 3
    lda    #$10             ; 2
    sta    $aa              ; 3
    bne    Lf0b7            ; 3

Lf0e2:
    lda    time             ; 3
    beq    Lf0f7            ; 2
    dec    $d7              ; 5
    bpl    Lf0b7            ; 2
    dec    time             ; 5
    lda    #$50             ; 2
    jsr    Lff0d            ; 6
    lda    #$05             ; 2
    sta    $d7              ; 3
    bne    Lf0b7            ; 3

Lf0f7:
    lda    #$00             ; 2
    ldy    #$20             ; 2
    jsr    Lff0f            ; 6
    lda    #$ff             ; 2
    ldx    player           ; 3
    sta    $e5,x            ; 4
    lda    #61              ; 2
    sta    time             ; 3
    bne    Lf144            ; 3

Lf10a:
    dec    $d7              ; 5
    beq    Lf130            ; 2
    lda    frameCntLo       ; 3
    and    #$0f             ; 2
    bne    Lf0b7            ; 2+1
    lda    $a7              ; 3
    cmp    #$05             ; 2
    beq    Lf0b7            ; 2+1
    dec    $a7              ; 5
    bne    Lf0b7            ; 2+1
Lf11e:
    lda    $a7              ; 3
    cmp    #$07             ; 2
    beq    Lf128            ; 2
    dec    $a7              ; 5
    bne    Lf188            ; 2
Lf128:
    lda    #$41             ; 2
    sta    $8b              ; 3
Lf12c:
    dec    $d7              ; 5
    bne    Lf188            ; 2
Lf130:
    ldx    player           ; 3
    lda    livesLst,x       ; 6     dec!!!
    beq    Lf14c            ; 2
    lda    $8e              ; 3
    beq    Lf144            ; 2
    jsr    SwapPlayers      ; 6
    lda    livesLst,x       ; 4
    bne    Lf144            ; 2
    jsr    SwapPlayers      ; 6
Lf144:
    lda    #$19             ; 2
    jsr    Lfe5f            ; 6
    jmp    Lf188            ; 3

Lf14c:
    lda    $8e              ; 3
    beq    Lf15a            ; 2
    jsr    SwapPlayers      ; 6
    lda    livesLst,x       ; 4
    bne    Lf144            ; 2
    jsr    SwapPlayers      ; 6
Lf15a:
    lda    #$2e             ; 2
    ldx    #$76             ; 2
    jsr    StartAudio       ; 6
    lda    #$01             ; 2
    sta    frameCntHi       ; 3
Lf165:
    lda    #$50             ; 2
    bne    Lf186            ; 2
Lf169:
    lda    frameCntHi       ; 3
    and    #$03             ; 2
    bne    Lf165            ; 2
    lda    frameCntLo       ; 3
    bne    Lf184            ; 2
    lda    $8e              ; 3
    beq    Lf184            ; 2
    jsr    SwapPlayers      ; 6
    jsr    Lfe74            ; 6
    lda    #$10             ; 2
    sta    $8b              ; 3
    jmp    Lf650            ; 3

Lf184:
    lda    #$10             ; 2
Lf186:
    sta    $8b              ; 3
Lf188:
    ldx    #$fe             ; 2
    stx    $a1              ; 3
    inx                     ; 2
    stx    $a3              ; 3
    stx    $b3              ; 3
    inx                     ; 2
    stx    $a2              ; 3
    stx    PF0              ; 3
    lda    #$15             ; 2
    sta    $a4              ; 3
    lda    $8b              ; 3
    and    #$20             ; 2
    beq    Lf1a3            ; 2
    jmp    Lf650            ; 3

Lf1a3:
    stx    $ba              ; 3
    dex                     ; 2
    stx    $b8              ; 3
    stx    $b9              ; 3
    lda    $ef              ; 3
    beq    Lf1b1            ; 2
    jmp    Lf2c5            ; 3

Lf1b1:
    lda    $ed              ; 3
    beq    Lf1b8            ; 2
    jmp    Lf2e5            ; 3

Lf1b8:
    lda    $ee              ; 3
    and    #$04             ; 2
    beq    Lf237            ; 2+1
    lda    $c6              ; 3
    cmp    #$38             ; 2
    bcs    Lf1ce            ; 2
    lda    #$37             ; 2
    sta    $c6              ; 3
    lda    #$01             ; 2
    sta    $cf              ; 3
    bne    Lf1d6            ; 2
Lf1ce:
    cmp    #$50             ; 2
    bcc    Lf1d6            ; 2
    lda    #$ff             ; 2
    sta    $cf              ; 3
Lf1d6:
    lda    $8b              ; 3
    bpl    Lf210            ; 2+1
    lda    $c6              ; 3
    cmp    #$4a             ; 2
    bcs    Lf1ec            ; 2
    cmp    #$3d             ; 2
    bcc    Lf1ec            ; 2
    lda    frameCntLo       ; 3
    and    #$07             ; 2
    cmp    #$02             ; 2
    beq    Lf1f2            ; 2
Lf1ec:
    lda    frameCntLo       ; 3
    and    #$03             ; 2
    bne    Lf210            ; 2+1
Lf1f2:
    lda    $c6              ; 3
    clc                     ; 2
    adc    $cf              ; 3
    sta    $c6              ; 3
    clc                     ; 2
    adc    #$02             ; 2
    ldx    #$0b             ; 2
    jsr    Lff3e            ; 6
    bcc    Lf210            ; 2
    lda    $a8              ; 3
    and    #$60             ; 2
    bne    Lf210            ; 2
    clc                     ; 2
    lda    $cf              ; 3
    adc    xPos             ; 3
    sta    xPos             ; 3
Lf210:
    ldx    #$00             ; 2
    beq    Lf242            ; 2
Lf214:
    lda    Lf49d,x          ; 4
Lf217:
    sta    $c7              ; 3
    lda    Lf4a1,x          ; 4
    sta    $c4              ; 3
    lda    Lf4a5,x          ; 4
    sta    $c1              ; 3
    lda    Lf4a9,x          ; 4
    sta    $c0              ; 3
    lda    Lf4ad,x          ; 4
    sta    $c2              ; 3
    lda    Lf4b1,x          ; 4
    sta    $c5              ; 3
    lda    #$00             ; 2
    sta    $b9              ; 3
    rts                     ; 6

Lf237:
    lda    $ee              ; 3
    and    #$01             ; 2
    beq    Lf245            ; 2
    tax                     ; 2
    lda    #$39             ; 2
    sta    $c6              ; 3
Lf242:
    jsr    Lf214            ; 6
Lf245:
    lda    $ee              ; 3
    and    #$18             ; 2
    beq    Lf2b9            ; 2
    ldx    #$00             ; 2
    and    #$10             ; 2
    beq    Lf263            ; 2
    lda    $ce              ; 3
    bne    Lf25d            ; 2
    lda    #$08             ; 2
    sta    $cc              ; 3
    lda    #$ff             ; 2
    sta    $ce              ; 3
Lf25d:
    lda    frameCntLo       ; 3
    and    #$01             ; 2
    tax                     ; 2
    inx                     ; 2
Lf263:
    lda    Lf2bc,x          ; 4
    sta    $c6              ; 3
    lda    Lf2bf,x          ; 4
    pha                     ; 3
    lda    Lf2c2,x          ; 4
    dex                     ; 2
    bpl    Lf273            ; 2
    inx                     ; 2
Lf273:
    and    frameCntLo       ; 3
    bne    Lf2a5            ; 2
    lda    $cc,x            ; 4
    cmp    #$03             ; 2
    bcs    Lf281            ; 2
    lda    #$01             ; 2
    bne    Lf287            ; 2
Lf281:
    cmp    #$08             ; 2
    bcc    Lf289            ; 2
    lda    #$ff             ; 2
Lf287:
    sta    $ce,x            ; 4
Lf289:
    lda    $cc,x            ; 4
    clc                     ; 2
    adc    $ce,x            ; 4
    sta    $cc,x            ; 4
    lda    $a8              ; 3
    and    #$08             ; 2
    beq    Lf2a5            ; 2
    lda    $8b              ; 3
    bpl    Lf2a5            ; 2
    cpx    $cb              ; 3
    bne    Lf2a5            ; 2
    clc                     ; 2
    lda    $a7              ; 3
    adc    $ce,x            ; 4
    sta    $a7              ; 3
Lf2a5:
    lda    $cc,x            ; 4
    ldx    #$02             ; 2
    jsr    Lf217            ; 6
    pla                     ; 4
    sta    $c5              ; 3
    ldx    #$76             ; 2
    lda    frameCntLo       ; 3
    and    #$08             ; 2
    bne    Lf2b9            ; 2
    stx    $c0              ; 3
Lf2b9:
    jmp    Lf4b5            ; 3

Lf2bc:
    .byte %00111001 ; $39 ; |  XXX  X| $f2bc
    .byte %00111001 ; $39 ; |  XXX  X| $f2bd
    .byte %01001001 ; $49 ; | X  X  X| $f2be
Lf2bf:
    .byte %00000011 ; $03 ; |      XX| $f2bf
    .byte %00000010 ; $02 ; |      X | $f2c0
    .byte %00000000 ; $00 ; |        | $f2c1
Lf2c2:
    .byte %00001111 ; $0f ; |    XXXX| $f2c2
    .byte %00001110 ; $0e ; |    XXX | $f2c3
    .byte %00001110 ; $0e ; |    XXX | $f2c4

Lf2c5:
    and    #$04             ; 2
    beq    Lf2b9            ; 2
    lda    #$fe             ; 2
    sta    $b1              ; 3
    lda    #$84             ; 2
    sta    $b0              ; 3
    lda    #$14             ; 2
    sta    $b2              ; 3
    lda    #$34             ; 2
    sta    $b4              ; 3
    lda    #$39             ; 2
    sta    $b6              ; 3
    lda    #$2c             ; 2
    sta    $b8              ; 3
    lda    #$03             ; 2
    sta    $b5              ; 3
Lf2e5:
    lda    $ed              ; 3
    and    #$01             ; 2
    beq    Lf34e            ; 2+1
    lda    frameCntLo       ; 3
    and    #$01             ; 2
    tax                     ; 2
    dec    $bb,x            ; 6
    bpl    Lf322            ; 2+1
    lda    Lf470,x          ; 4
    sta    $bb,x            ; 4
    dec    $bd,x            ; 6
    bpl    Lf309            ; 2+1
    lda    #$06             ; 2
    sta    $bd,x            ; 4
    lda    $e0,x            ; 4
    and    #$08             ; 2
    eor    #$08             ; 2
    sta    $e0,x            ; 4
Lf309:
    lda    $a8              ; 3
    and    #$20             ; 2
    beq    Lf322            ; 2
    cpx    $bf              ; 3
    bne    Lf322            ; 2
    lda    $e0,x            ; 4
    and    #$08             ; 2
    ora    $bd,x            ; 4
    tay                     ; 2
    lda    Lf48a,y          ; 4
    clc                     ; 2
    adc    xPos             ; 3
    sta    xPos             ; 3
Lf322:
    ldy    $bd,x            ; 4
    lda    Lf47c,y          ; 4
    sta    $b1              ; 3
    lda    Lf483,y          ; 4
    sta    $b0              ; 3
    lda    Lf499,x          ; 4
    sta    $b6              ; 3
    lda    $e0,x            ; 4
    sta    $ba              ; 3
    bne    Lf33e            ; 2
    lda    Lf49b,x          ; 4
    sta    $b6              ; 3
Lf33e:
    lda    #$aa             ; 2
    sta    $b2              ; 3
    lda    #$22             ; 2
    sta    $b4              ; 3
    lda    #$22             ; 2
    sta    $b8              ; 3
    lda    #$05             ; 2
    sta    $b5              ; 3
Lf34e:
    lda    $ed              ; 3
    and    #$04             ; 2
    bne    Lf357            ; 2
    jmp    Lf3f6            ; 3

Lf357:
    lda    $bc              ; 3
    bmi    Lf35f            ; 2
    lda    #$02             ; 2
    bne    Lf379            ; 2
Lf35f:
    and    #$07             ; 2
    beq    Lf385            ; 2
    cmp    #$01             ; 2
    beq    Lf3b6            ; 2
    cmp    #$02             ; 2
    beq    Lf397            ; 2
Lf36b:
    ldx    #$03             ; 2
    dec    $be              ; 5
    lda    $be              ; 3
    sta    $b8              ; 3
    cmp    #$0f             ; 2
    bcs    Lf3c4            ; 2
    lda    #$1e             ; 2
Lf379:
    sta    $bd              ; 3
    lda    #$80             ; 2
    sta    $bc              ; 3
    lda    #$30             ; 2
    sta    $be              ; 3
    sta    $bf              ; 3
Lf385:
    lda    #$ff             ; 2
    sta    $b8              ; 3
    ldx    #$00             ; 2
    dec    $bd              ; 5
    bne    Lf3c4            ; 2
    inc    $bc              ; 5
    lda    #$64             ; 2
    sta    $bd              ; 3
    bne    Lf3b6            ; 2
Lf397:
    ldx    #$02             ; 2
    lda    frameCntLo       ; 3
    and    #$01             ; 2
    beq    Lf3a0            ; 2
    inx                     ; 2
Lf3a0:
    dec    $be              ; 5
    lda    $bc,x            ; 4
    sta    $b8              ; 3
    cmp    #$0f             ; 2
    bcs    Lf3c4            ; 2
    lda    #$83             ; 2
    sta    $bc              ; 3
    lda    $bf              ; 3
    sta    $be              ; 3
    sta    $b8              ; 3
    bne    Lf36b            ; 2
Lf3b6:
    lda    $be              ; 3
    sta    $b8              ; 3
    ldx    #$01             ; 2
    dec    $bd              ; 5
    bne    Lf3c4            ; 2
    lda    #$82             ; 2
    sta    $bc              ; 3
Lf3c4:
    ldy    Lf474,x          ; 4
    lda    $ee              ; 3
    and    #$01             ; 2
    beq    Lf3d2            ; 2
    tya                     ; 2
    clc                     ; 2
    adc    #$08             ; 2
    tay                     ; 2
Lf3d2:
    sty    $b6              ; 3
    lda    Lf478,x          ; 4
    sta    $b5              ; 3
    lda    frameCntLo       ; 3
    lsr                     ; 2
    lsr                     ; 2
    lsr                     ; 2
    and    #$01             ; 2
    tax                     ; 2
    lda    Lf472,x          ; 4
    sta    $b1              ; 3
    lda    #$f3             ; 2
    sta    $b0              ; 3
    lda    #$14             ; 2
    sta    $b2              ; 3
    lda    #$00             ; 2
    sta    $ba              ; 3
    lda    #$0a             ; 2
    sta    $b4              ; 3
Lf3f6:
    lda    $ed              ; 3
    and    #$0a             ; 2
    beq    Lf46b            ; 2+1
    ldx    #$14             ; 2
    and    #$08             ; 2
    beq    Lf409            ; 2
    lda    frameCntHi       ; 3
    lsr                     ; 2
    bcs    Lf409            ; 2
    ldx    #$09             ; 2
Lf409:
    stx    $e9              ; 3
    lda    $bc              ; 3
    bpl    Lf41f            ; 2
    and    #$07             ; 2
    beq    Lf42f            ; 2
    cmp    #$01             ; 2
    beq    Lf440            ; 2
    dec    $b6              ; 5
    lda    $b6              ; 3
    cmp    #$05             ; 2
    bcs    Lf44a            ; 2
Lf41f:
    lda    #$34             ; 2
    sta    $be              ; 3
    lda    #$90             ; 2
    sta    $b6              ; 3
    lda    #$64             ; 2
    sta    $bd              ; 3
    lda    #$80             ; 2
    sta    $bc              ; 3
Lf42f:
    lda    #$ff             ; 2
    sta    $b8              ; 3
    dec    $bd              ; 5
    bne    Lf46b            ; 2
    inc    $bc              ; 5
    ldy    #$04             ; 2
    lda    #$1d             ; 2
    jsr    Lfd23            ; 6
Lf440:
    dec    $be              ; 5
    lda    $be              ; 3
    cmp    $e9              ; 3
    bcs    Lf44a            ; 2
    inc    $bc              ; 5
Lf44a:
    lda    $be              ; 3
    sta    $b8              ; 3
    lda    #$f2             ; 2
    sta    $b1              ; 3
    lda    frameCntLo       ; 3
    lsr                     ; 2
    lsr                     ; 2
    lsr                     ; 2
    and    #$01             ; 2
    tax                     ; 2
    lda    Lf46e,x          ; 4
    sta    $b0              ; 3
    lda    #$69             ; 2
    sta    $b2              ; 3
    lda    #$0a             ; 2
    sta    $b4              ; 3
    lda    #$00             ; 2
    sta    $b5              ; 3
Lf46b:
    jmp    Lf1b8            ; 3

Lf46e:
    .byte %11101010 ; $ea ; |XXX X X | $f46e
    .byte %11110100 ; $f4 ; |XXXX X  | $f46f
Lf470:
    .byte %00000011 ; $03 ; |      XX| $f470
    .byte %00000100 ; $04 ; |     X  | $f471
Lf472:
    .byte %11111001 ; $f9 ; |XXXXX  X| $f472
    .byte %11111010 ; $fa ; |XXXXX X | $f473
Lf474:
    .byte %00111000 ; $38 ; |  XXX   | $f474
    .byte %00111000 ; $38 ; |  XXX   | $f475
    .byte %00111000 ; $38 ; |  XXX   | $f476
    .byte %01001000 ; $48 ; | X  X   | $f477
Lf478:
    .byte %00000000 ; $00 ; |        | $f478
    .byte %00000011 ; $03 ; |      XX| $f479
    .byte %00000000 ; $00 ; |        | $f47a
    .byte %00000001 ; $01 ; |       X| $f47b
Lf47c:
    .byte %11110010 ; $f2 ; |XXXX  X | $f47c
    .byte %11110010 ; $f2 ; |XXXX  X | $f47d
    .byte %11110010 ; $f2 ; |XXXX  X | $f47e
    .byte %11110010 ; $f2 ; |XXXX  X | $f47f
    .byte %11110010 ; $f2 ; |XXXX  X | $f480
    .byte %11110010 ; $f2 ; |XXXX  X | $f481
    .byte %11111110 ; $fe ; |XXXXXXX | $f482
Lf483:
    .byte %01111110 ; $7e ; | XXXXXX | $f483
    .byte %10100010 ; $a2 ; |X X   X | $f484
    .byte %11000110 ; $c6 ; |XX   XX | $f485
    .byte %11000110 ; $c6 ; |XX   XX | $f486
    .byte %10100010 ; $a2 ; |X X   X | $f487
    .byte %01111110 ; $7e ; | XXXXXX | $f488
    .byte %11000100 ; $c4 ; |XX   X  | $f489
Lf48a:
    .byte %11111100 ; $fc ; |XXXXXX  | $f48a
    .byte %11111100 ; $fc ; |XXXXXX  | $f48b
    .byte %00000000 ; $00 ; |        | $f48c
    .byte %00000100 ; $04 ; |     X  | $f48d
    .byte %00000100 ; $04 ; |     X  | $f48e
    .byte %00000110 ; $06 ; |     XX | $f48f
    .byte %00000110 ; $06 ; |     XX | $f490
    .byte %00000000 ; $00 ; |        | $f491
    .byte %00000100 ; $04 ; |     X  | $f492
    .byte %00000100 ; $04 ; |     X  | $f493
    .byte %00000000 ; $00 ; |        | $f494
    .byte %11111100 ; $fc ; |XXXXXX  | $f495
    .byte %11111100 ; $fc ; |XXXXXX  | $f496
    .byte %11111010 ; $fa ; |XXXXX X | $f497
    .byte %11111010 ; $fa ; |XXXXX X | $f498
Lf499:
    .byte %00101011 ; $2b ; |  X X XX| $f499
    .byte %01010010 ; $52 ; | X X  X | $f49a
Lf49b:
    .byte %00111001 ; $39 ; |  XXX  X| $f49b
    .byte %01100000 ; $60 ; | XX     | $f49c
Lf49d:
    .byte %00000100 ; $04 ; |     X  | $f49d
    .byte %00000101 ; $05 ; |     X X| $f49e
    .byte %00000101 ; $05 ; |     X X| $f49f
    .byte %00000100 ; $04 ; |     X  | $f4a0
Lf4a1:
    .byte %00001010 ; $0a ; |    X X | $f4a1
    .byte %00001010 ; $0a ; |    X X | $f4a2
    .byte %00010000 ; $10 ; |   X    | $f4a3
    .byte %00001000 ; $08 ; |    X   | $f4a4
Lf4a5:
    .byte %11111110 ; $fe ; |XXXXXXX | $f4a5
    .byte %11110010 ; $f2 ; |XXXX  X | $f4a6
    .byte %11111111 ; $ff ; |XXXXXXXX| $f4a7
    .byte %00000000 ; $00 ; |        | $f4a8
Lf4a9:
    .byte %10111010 ; $ba ; |X XXX X | $f4a9
    .byte %01110100 ; $74 ; | XXX X  | $f4aa
    .byte %10000111 ; $87 ; |X    XXX| $f4ab
    .byte %00000000 ; $00 ; |        | $f4ac
Lf4ad:
    .byte %01010110 ; $56 ; | X X XX | $f4ad
    .byte %01011110 ; $5e ; | X XXXX | $f4ae
    .byte %10011000 ; $98 ; |X  XX   | $f4af
    .byte %11010100 ; $d4 ; |XX X X  | $f4b0
Lf4b1:
    .byte %00000101 ; $05 ; |     X X| $f4b1
    .byte %00000011 ; $03 ; |      XX| $f4b2
    .byte %00000011 ; $03 ; |      XX| $f4b3
    .byte %00000000 ; $00 ; |        | $f4b4

Lf4b5:
    ldy    #$01             ; 2
    lda    $ee              ; 3
    and    #$20             ; 2
    bne    Lf4c4            ; 2
    dey                     ; 2
    lda    $ef              ; 3
    and    #$02             ; 2
    beq    Lf4d6            ; 2
Lf4c4:
    sty    $e9              ; 3
    lda    $ca              ; 3
    bmi    Lf4ce            ; 2
    lda    #$02             ; 2
    bne    Lf52a            ; 2+1
Lf4ce:
    and    #$40             ; 2
    bne    Lf4e4            ; 2
    dec    $cb              ; 5
    beq    Lf4d9            ; 2
Lf4d6:
    jmp    Lf56d            ; 3

Lf4d9:
    lda    $ca              ; 3
    ora    #$40             ; 2
    sta    $ca              ; 3
    lda    Lf634,y          ; 4
    sta    $cb              ; 3
Lf4e4:
    dec    $cb              ; 5
    bne    Lf504            ; 2+1
    lda    frameCntLo       ; 3
    and    #$f8             ; 2
    sta    frameCntLo       ; 3
    lda    $ca              ; 3
    eor    #$08             ; 2
    sta    $ca              ; 3
    ldx    Lf634,y          ; 4
    stx    $cb              ; 3
    and    #$08             ; 2
    bne    Lf504            ; 2+1
    ldy    #$04             ; 2
    lda    #$25             ; 2
    jsr    Lfd23            ; 6
Lf504:
    lda    frameCntLo       ; 3
    and    #$03             ; 2
    tay                     ; 2
    ora    $ca              ; 3
    and    #$0f             ; 2
    tax                     ; 2
    clc                     ; 2
    lda    Lfc0a,x          ; 4
    adc    $c8              ; 3
    sta    $c8              ; 3
    lda    frameCntLo       ; 3
    and    #$0f             ; 2
    beq    Lf548            ; 2
    clc                     ; 2
    lda    Lfc12,y          ; 4
    adc    $b6              ; 3
    sta    $b6              ; 3
    cmp    #$02             ; 2
    bcs    Lf548            ; 2
    lda    #$32             ; 2
Lf52a:
    sta    $cb              ; 3
    lda    frameCntHi       ; 3
    and    #$0f             ; 2
    adc    #$83             ; 2
    sta    $b6              ; 3
    lda    #$05             ; 2
    sta    $c8              ; 3
    ldy    $e9              ; 3
    lda    Lf632,y          ; 4
    sta    $ca              ; 3
    ldx    #$ff             ; 2
    stx    $b8              ; 3
    inx                     ; 2
    stx    $e3              ; 3
    beq    Lf56d            ; 2
Lf548:
    lda    #$e2             ; 2
    sta    $b2              ; 3
    lda    #$08             ; 2
    sta    $b4              ; 3
    lda    #$f6             ; 2
    sta    $b1              ; 3
    lda    $c8              ; 3
    sta    $b8              ; 3
    lda    frameCntLo       ; 3
    and    #$0f             ; 2
    bne    Lf566            ; 2
    dec    $cc              ; 5
    bpl    Lf566            ; 2
    lda    #$02             ; 2
    sta    $cc              ; 3
Lf566:
    ldy    $cc              ; 3
    lda    Lf636,y          ; 4
    sta    $b0              ; 3
Lf56d:
    lda    $ef              ; 3
    and    #$08             ; 2
    beq    Lf598            ; 2
    ldx    $bc              ; 3
    beq    Lf5c1            ; 2
    cpx    #$01             ; 2
    beq    Lf5e2            ; 2
    lda    frameCntLo       ; 3
    and    #$03             ; 2
    beq    Lf5ef            ; 2
    lda    $be              ; 3
    adc    Lf59b,x          ; 4
    sta    $be              ; 3
    cmp    Lf59f,x          ; 4
    bne    Lf5ef            ; 2
    inc    $bc              ; 5
    lda    $bc              ; 3
    and    #$03             ; 2
    sta    $bc              ; 3
    tax                     ; 2
    bne    Lf5ef            ; 2
Lf598:
    jmp    Lf606            ; 3

Lf59b:
    .byte %00000000 ; $00 ; |        | $f59b
    .byte %00000000 ; $00 ; |        | $f59c
    .byte %00000000 ; $00 ; |        | $f59d
    .byte %11111110 ; $fe ; |XXXXXXX | $f59e
Lf59f:
    .byte %00000000 ; $00 ; |        | $f59f
    .byte %00000000 ; $00 ; |        | $f5a0
    .byte %00011001 ; $19 ; |   XX  X| $f5a1
    .byte %00000011 ; $03 ; |      XX| $f5a2
Lf5a3:
    .byte %00000000 ; $00 ; |        | $f5a3
    .byte %11111100 ; $fc ; |XXXXXX  | $f5a4
    .byte %11111011 ; $fb ; |XXXXX XX| $f5a5
    .byte %11111110 ; $fe ; |XXXXXXX | $f5a6
Lf5a7:
    .byte %00000000 ; $00 ; |        | $f5a7
    .byte %11111000 ; $f8 ; |XXXXX   | $f5a8
    .byte %11110111 ; $f7 ; |XXXX XXX| $f5a9
    .byte %11110101 ; $f5 ; |XXXX X X| $f5aa
Lf5ab:
    .byte %00000000 ; $00 ; |        | $f5ab
    .byte %00000100 ; $04 ; |     X  | $f5ac
    .byte %00001000 ; $08 ; |    X   | $f5ad
    .byte %00001000 ; $08 ; |    X   | $f5ae
Lf5af:
    .byte %00000000 ; $00 ; |        | $f5af
    .byte %00000011 ; $03 ; |      XX| $f5b0
    .byte %00000011 ; $03 ; |      XX| $f5b1
    .byte %00000001 ; $01 ; |       X| $f5b2
    .byte %00000001 ; $01 ; |       X| $f5b3
    .byte %00000000 ; $00 ; |        | $f5b4
    .byte %00000001 ; $01 ; |       X| $f5b5
    .byte %00000001 ; $01 ; |       X| $f5b6
Lf5b7:
    .byte %00101010 ; $2a ; |  X X X | $f5b7
    .byte %00101010 ; $2a ; |  X X X | $f5b8
    .byte %00111010 ; $3a ; |  XXX X | $f5b9
Lf5ba:
    .byte %01001010 ; $4a ; | X  X X | $f5ba
    .byte %01001010 ; $4a ; | X  X X | $f5bb
    .byte %00101010 ; $2a ; |  X X X | $f5bc
    .byte %00111010 ; $3a ; |  XXX X | $f5bd
    .byte %01001010 ; $4a ; | X  X X | $f5be
    .byte %00001000 ; $08 ; |    X   | $f5bf
    .byte %00000000 ; $00 ; |        | $f5c0

Lf5c1:
    lda    #$01             ; 2
    sta    $be              ; 3
    lda    frameCntHi       ; 3
    and    #$07             ; 2
    tax                     ; 2
    ldy    $f8              ; 3
    lda    Lf5af,x          ; 4
    sta    $b5              ; 3
    clc                     ; 2
    lda    Lf5b7,x          ; 4
    adc    Lf5ba,y          ; 4
    sta    $b6              ; 3
    lda    #$32             ; 2
    sta    $bd              ; 3
    inc    $bc              ; 5
    ldx    $bc              ; 3
Lf5e2:
    dec    $bd              ; 5
    bne    Lf5ef            ; 2
    inc    $bc              ; 5
    ldy    #$04             ; 2
    lda    #$32             ; 2
    jsr    Lfd23            ; 6
Lf5ef:
    lda    Lf5a3,x          ; 4
    sta    $b1              ; 3
    lda    Lf5a7,x          ; 4
    sta    $b0              ; 3
    lda    #$cb             ; 2
    sta    $b2              ; 3
    lda    Lf5ab,x          ; 4
    sta    $b4              ; 3
    lda    $be              ; 3
    sta    $b8              ; 3
Lf606:
    lda    $ee              ; 3
    and    #$02             ; 2
    beq    Lf650            ; 2
    ldx    #$03             ; 2
    jsr    Lf214            ; 6
    lda    frameCntLo       ; 3
    lsr                     ; 2
    lsr                     ; 2
    lsr                     ; 2
    and    #$03             ; 2
    tax                     ; 2
    lda    Lf62e,x          ; 4
    sta    $c0              ; 3
    lda    Lf62a,x          ; 4
    sta    $c1              ; 3
    lda    #$77             ; 2
    sta    $c6              ; 3
    jmp    Lf650            ; 3

Lf62a:
    .byte %11111001 ; $f9 ; |XXXXX  X| $f62a
    .byte %11111110 ; $fe ; |XXXXXXX | $f62b
    .byte %11111001 ; $f9 ; |XXXXX  X| $f62c
    .byte %11110110 ; $f6 ; |XXXX XX | $f62d
Lf62e:
    .byte %10110111 ; $b7 ; |X XX XXX| $f62e
    .byte %11101001 ; $e9 ; |XXX X  X| $f62f
    .byte %10110111 ; $b7 ; |X XX XXX| $f630
    .byte %11011010 ; $da ; |XX XX X | $f631
Lf632:
    .byte %10000000 ; $80 ; |X       | $f632
    .byte %10000100 ; $84 ; |X    X  | $f633
Lf634:
    .byte %00010010 ; $12 ; |   X  X | $f634
    .byte %00001111 ; $0f ; |    XXXX| $f635
Lf636:
    .byte %11110110 ; $f6 ; |XXXX XX | $f636
    .byte %11101101 ; $ed ; |XXX XX X| $f637
    .byte %11100100 ; $e4 ; |XXX  X  | $f638
Lf639:
    .byte %00000000 ; $00 ; |        | $f639
    .byte %00000001 ; $01 ; |       X| $f63a
    .byte %11111111 ; $ff ; |XXXXXXXX| $f63b
Lf63c:
    .byte %11111111 ; $ff ; |XXXXXXXX| $f63c
    .byte %11111101 ; $fd ; |XXXXXX X| $f63d
Lf63e:
    .byte %11101101 ; $ed ; |XXX XX X| $f63e
    .byte %11110111 ; $f7 ; |XXXX XXX| $f63f
Lf640:
    .byte %00000111 ; $07 ; |     XXX| $f640
    .byte %00001111 ; $0f ; |    XXXX| $f641
    .byte %00000111 ; $07 ; |     XXX| $f642
    .byte %00000111 ; $07 ; |     XXX| $f643
    .byte %00000000 ; $00 ; |        | $f644
    .byte %00001111 ; $0f ; |    XXXX| $f645
    .byte %00000111 ; $07 ; |     XXX| $f646
    .byte %00000000 ; $00 ; |        | $f647
Lf648:
    .byte %00100011 ; $23 ; |  X   XX| $f648
    .byte %00010100 ; $14 ; |   X X  | $f649
    .byte %00100110 ; $26 ; |  X  XX | $f64a
    .byte %00100000 ; $20 ; |  X     | $f64b
    .byte %00011000 ; $18 ; |   XX   | $f64c
    .byte %00010100 ; $14 ; |   X X  | $f64d
    .byte %00100000 ; $20 ; |  X     | $f64e
    .byte %00011000 ; $18 ; |   XX   | $f64f

Lf650:
    lda    $ef              ; 3
    and    #$01             ; 2
    beq    Lf6cf            ; 2
    ldy    $bc              ; 3
    beq    Lf681            ; 2
    clc                     ; 2
    lda    $bf              ; 3
    adc    Lf639,y          ; 4
    sta    $bf              ; 3
    cmp    #$04             ; 2
    beq    Lf681            ; 2
    cmp    $bd              ; 3
    bne    Lf66c            ; 2
    inc    $bc              ; 5
Lf66c:
    lda    frameCntLo       ; 3
    and    #$07             ; 2
    clc                     ; 2
    adc    $be              ; 3
    tax                     ; 2
    lda    $b6              ; 3
    sec                     ; 2
    sbc    Lfbf8,x          ; 4
    sbc    Lfbf8,x          ; 4
    sta    $b6              ; 3
    bne    Lf6ab            ; 2
Lf681:
    lda    #$00             ; 2
    sta    $bc              ; 3
    lda    #$77             ; 2
    sta    $b6              ; 3
    lda    #$04             ; 2
    sta    $bf              ; 3
    lda    frameCntLo       ; 3
    and    #$7f             ; 2
    bne    Lf6cf            ; 2
    ldy    #$04             ; 2
    lda    #$29             ; 2
    jsr    Lfd23            ; 6
    lda    frameCntHi       ; 3
    and    #$07             ; 2
    tax                     ; 2
    lda    Lf640,x          ; 4
    sta    $be              ; 3
    lda    Lf648,x          ; 4
    sta    $bd              ; 3
    inc    $bc              ; 5
Lf6ab:
    lda    frameCntLo       ; 3
    lsr                     ; 2
    bcc    Lf6cf            ; 2
    lsr                     ; 2
    lsr                     ; 2
    and    #$01             ; 2
    tax                     ; 2
    lda    Lf63c,x          ; 4
    sta    $b1              ; 3
    lda    Lf63e,x          ; 4
    sta    $b0              ; 3
    lda    #$d9             ; 2
    sta    $b2              ; 3
    lda    #$08             ; 2
    sta    $b4              ; 3
    lda    $bf              ; 3
    sta    $b8              ; 3
    lda    #$ff             ; 2
    sta    $b9              ; 3
Lf6cf:
    jsr    Lfeb0            ; 6
    jsr    Lfc43            ; 6
    ldx    #$aa             ; 2
    stx    $f7              ; 3
    stx    $f8              ; 3
    stx    $f9              ; 3
    lda    $8b              ; 3
    beq    Lf6f8            ; 2
    and    #$40             ; 2
    beq    Lf703            ; 2+1
    ldx    player           ; 3
    lda    scoreHiLst,x     ; 4
    sta    $f7              ; 3
    lda    scoreMidLst,x    ; 4
    sta    $f8              ; 3
    lda    scoreLoLst,x     ; 4
    sta    $f9              ; 3
    jmp    Lf703            ; 3

Lf6f6:
    .byte %10101011 ; $ab ; |X X X XX| $f6f6
    .byte %10111011 ; $bb ; |X XXX XX| $f6f7

Lf6f8:
    ldx    $8e              ; 3
    lda    Lf6f6,x          ; 4
    sta    $f9              ; 3
    nop                     ; 2
    nop                     ; 2
    nop                     ; 2
    nop                     ; 2
Lf703:
    ldx    #$00             ; 2
    lda    $f7              ; 3
    jsr    Lffb6            ; 6
    lda    $f8              ; 3
    jsr    Lffb6            ; 6
    lda    $f9              ; 3
    jsr    Lffb6            ; 6
    lda    #$1e             ; 2
    sta    COLUP0           ; 3
    sta    COLUP1           ; 3
    ldy    #$0b             ; 2
    dex                     ; 2
Lf71d:
    lda    #$f8             ; 2
    sta.wy $00f2,y          ; 5
    dey                     ; 2
    lda    $ec,x            ; 4
    sta.wy $00f2,y          ; 5
    dex                     ; 2
    dey                     ; 2
    bpl    Lf71d            ; 2
    inx                     ; 2
    ldy    #$50             ; 2
Lf72f:
    lda    $f2,x            ; 4
    cmp    #$00             ; 2
    bne    Lf73d            ; 2
    sty    $f2,x            ; 4
    inx                     ; 2
    inx                     ; 2
    cpx    #$0a             ; 2
    bne    Lf72f            ; 2
Lf73d:
    jmp    Lf000            ; 3

Lf740:
    lda    $8b              ; 3
    bmi    Lf747            ; 2
    jmp    CheckJoystick    ; 3

Lf747:
    ldx    player           ; 3
    lda    scene            ; 3
    and    #$0f             ; 2
    bne    Lf759            ; 2
    lda    xPos             ; 3
    cmp    #$6e             ; 2
    bcc    Lf789            ; 2
    lda    $e5,x            ; 4
    beq    Lf77e            ; 2
Lf759:
    lda    xPos             ; 3
    cmp    #$91             ; 2
    bcc    Lf789            ; 2
    lda    #$00             ; 2
    sta    $e5,x            ; 4
    sed                     ; 2
    clc                     ; 2
    lda    scene            ; 3
    adc    #$01             ; 2
    sta    scene            ; 3
    cld                     ; 2
    inc    screen           ; 5
    lda    screen           ; 3
    cmp    #$1f             ; 2
    bne    Lf778            ; 2
    lda    #$0b             ; 2
    sta    screen           ; 3
Lf778:
    jsr    Lfe5d            ; 6
    jmp    CheckJoystick    ; 3

Lf77e:
    lda    #$44             ; 2
    sta    $8b              ; 3
    lda    #$c8             ; 2
    sta    $d7              ; 3
    jsr    Lfcfc            ; 6
Lf789:
    ldy    $f8              ; 3
    ldx    Lf7c0,y          ; 4
    beq    Lf7ff            ; 2
    lda    Lf7c8,y          ; 4
    jsr    Lff3e            ; 6
    bcc    Lf7ea            ; 2
    lda    $a8              ; 3
    and    #$68             ; 2
    bne    Lf7ff            ; 2
    lda    $ee              ; 3
    and    #$04             ; 2
    beq    Lf7b7            ; 2
    lda    $c6              ; 3
    ldx    #$0b             ; 2
    jsr    Lff3b            ; 6
    bcc    Lf7b7            ; 2
    lda    #$02             ; 2
    ldy    #$07             ; 2
    jsr    Lffc7            ; 6
    jmp    Lf7ff            ; 3

Lf7b7:
    lda    #$96             ; 2
    sta    $d7              ; 3
    lda    #$42             ; 2
    jmp    Lf932            ; 3

Lf7c0:
    .byte $0a ; |    X X | $f7c0
    .byte $00 ; |        | $f7c1
    .byte $00 ; |        | $f7c2
    .byte $00 ; |        | $f7c3
    .byte $00 ; |        | $f7c4
    .byte $08 ; |    X   | $f7c5
    .byte $09 ; |    X  X| $f7c6
    .byte $00 ; |        | $f7c7
Lf7c8:
    .byte $35 ; |  XX X X| $f7c8
    .byte $00 ; |        | $f7c9
    .byte $00 ; |        | $f7ca
    .byte $00 ; |        | $f7cb
    .byte $00 ; |        | $f7cc
    .byte $34 ; |  XX X  | $f7cd
    .byte $2b ; |  X X XX| $f7ce
XPosTbl:
    .byte $00 ; $f7cf
    .byte $58
    .byte $48
    .byte $38
Lf7d3:
    .byte $00 ; |        | $f7d3
    .byte $0d ; |    XX X| $f7d4
    .byte $0f ; |    XXXX| $f7d5
    .byte $11 ; |   X   X| $f7d6
    .byte $0f ; |    XXXX| $f7d7
    .byte $0d ; |    XX X| $f7d8
Lf7d9:
    .byte $14 ; |   X X  | $f7d9
    .byte $18 ; |   XX   | $f7da
    .byte $1c ; |   XXX  | $f7db
    .byte $1c ; |   XXX  | $f7dc
    .byte $18 ; |   XX   | $f7dd
    .byte $14 ; |   X X  | $f7de
    .byte $0e ; |    XXX | $f7df
    .byte $00 ; |        | $f7e0
    .byte $08 ; |    X   | $f7e1
    .byte $04 ; |     X  | $f7e2
    .byte $00 ; |        | $f7e3
    .byte $00 ; |        | $f7e4
    .byte $04 ; |     X  | $f7e5
    .byte $08 ; |    X   | $f7e6
    .byte $0e ; |    XXX | $f7e7
Lf7e8:
    .byte $2b ; |  X X XX| $f7e8
    .byte $52 ; | X X  X | $f7e9

Lf7ea:
    cpx    #$0a             ; 2
    beq    Lf7ff            ; 2
    tya                     ; 2
    cmp    Lff75,x          ; 4
    beq    Lf7ff            ; 2
    lda    $a8              ; 3
    and    #$68             ; 2
    bne    Lf7ff            ; 2
    lda    #$01             ; 2
    jsr    Lffc7            ; 6
Lf7ff:
    lda    $ee              ; 3
    and    #$08             ; 2
    beq    Lf84f            ; 2
    ldx    #$0e             ; 2
    lda    #$3b             ; 2
    jsr    Lff3e            ; 6
    bcs    Lf81d            ; 2
    lda    $a8              ; 3
    and    #$08             ; 2
    beq    Lf84f            ; 2
    lda    $a8              ; 3
    and    #$40             ; 2
    bne    Lf84f            ; 2
Lf81a:
    jmp    Lf922            ; 3

Lf81d:
    lda    #$02             ; 2
    jsr    Lffc7            ; 6
    ldx    #$00             ; 2
    lda    $ee              ; 3
    and    #$10             ; 2
    beq    Lf82f            ; 2
    ldx    Lfbf8,y          ; 4
    stx    $cb              ; 3
Lf82f:
    lda    $a8              ; 3
    and    #$08             ; 2
    bne    Lf84f            ; 2
    lda    $cc,x            ; 4
    clc                     ; 2
    adc    #$08             ; 2
    sec                     ; 2
    sbc    $a7              ; 3
    beq    Lf847            ; 2
    bmi    Lf84f            ; 2
    cmp    #$01             ; 2
    bne    Lf81a            ; 2
    inc    $a7              ; 5
Lf847:
    lda    $a8              ; 3
    and    #$bf             ; 2
    ora    #$08             ; 2
    sta    $a8              ; 3
Lf84f:
    lda    $ed              ; 3
    and    #$01             ; 2
    beq    Lf8ac            ; 2
    lda    $a8              ; 3
    and    #$60             ; 2
    bne    Lf85f            ; 2
    lda    #$ff             ; 2
    sta    $bf              ; 3
Lf85f:
    lda    $a8              ; 3
    and    #$40             ; 2
    beq    Lf8ac            ; 2
    lda    $a7              ; 3
    cmp    #$15             ; 2
    bcc    Lf8ac            ; 2
    ldx    #$00             ; 2
    lda    xPos             ; 3
    cmp    #$50             ; 2
    bcc    Lf874            ; 2
    inx                     ; 2
Lf874:
    lda    $e0,x            ; 4
    and    #$08             ; 2
    ora    $bd,x            ; 4
    tay                     ; 2
    lda    Lf7d9,y          ; 4
    clc                     ; 2
    adc    Lf7e8,x          ; 4
    sta    $ea              ; 3
    stx    $eb              ; 3
    ldx    #$0d             ; 2
    jsr    Lff3e            ; 6
    bcc    Lf8ac            ; 2
    lda    $eb              ; 3
    cmp    $bf              ; 3
    beq    Lf8ac            ; 2
    sta    $bf              ; 3
    lda    $a8              ; 3
    and    #$bf             ; 2
    ora    #$20             ; 2
    sta    $a8              ; 3
    lda    #$17             ; 2
    sta    $a7              ; 3
    lda    $ea              ; 3
    sta    xPos             ; 3
    ldy    $bf              ; 3
    lda    #$02             ; 2
    jsr    Lffc7            ; 6
Lf8ac:
    lda    $f8              ; 3
    cmp    #$03             ; 2
    beq    Lf8f3            ; 2
    cmp    #$04             ; 2
    beq    Lf8b9            ; 2
    jmp    Lf94a            ; 3

Lf8b9:
    ldx    #$03             ; 2
    lda    #$38             ; 2
Lf8bd:
    jsr    Lff3e            ; 6
    bcs    Lf8f9            ; 2
    cpy    #$00             ; 2
    beq    Lf8d4            ; 2
    tya                     ; 2
    cmp    Lff75,x          ; 4
    beq    Lf8d4            ; 2
    lda    $a8              ; 3
    and    #$40             ; 2
    beq    Lf922            ; 2+1
    bne    Lf8ec            ; 3

Lf8d4:
    lda    $f8              ; 3
    cmp    #$03             ; 2
    bne    Lf8e6            ; 2
    lda    $a7              ; 3
    cmp    #$09             ; 2
    beq    Lf8e6            ; 2
    lda    $a8              ; 3
    and    #$40             ; 2
    beq    Lf922            ; 2+1
Lf8e6:
    lda    $a8              ; 3
    and    #$ef             ; 2
    sta    $a8              ; 3
Lf8ec:
    lda    #$09             ; 2
    sta    $f0              ; 3
    jmp    Lf94a            ; 3

Lf8f3:
    ldx    #$0c             ; 2
    lda    #$2c             ; 2
    bne    Lf8bd            ; 2
Lf8f9:
    lda    #$01             ; 2
    jsr    Lffc7            ; 6
    lda    Lf7d3,y          ; 4
    sta    $f0              ; 3
    cpx    #$0c             ; 2
    beq    Lf91c            ; 2
    lda    $a8              ; 3
    ora    #$10             ; 2
    sta    $a8              ; 3
    lda    $a9              ; 3
    and    #$03             ; 2
    cmp    #$02             ; 2
    bne    Lf91a            ; 2
    lda    XPosTbl,y        ; 4
    sta    xPos             ; 3
Lf91a:
    lda    #$0b             ; 2
Lf91c:
    cmp    $a7              ; 3
    beq    Lf94a            ; 2
    bcc    Lf94a            ; 2
Lf922:
    lda    $a8              ; 3
    and    #$af             ; 2
    sta    $a8              ; 3
    lda    #$96             ; 2
    sta    $d7              ; 3
    lda    #$58             ; 2
    sta    $a0              ; 3
    lda    #$43             ; 2
Lf932:
    pha                     ; 3
    jsr    StopAudio        ; 6
    ldy    #$01             ; 2
    lda    #$13             ; 2
    jsr    Lfd23            ; 6
    lda    #$05             ; 2
    ldx    #$00             ; 2
    jsr    Lfd38            ; 6
    pla                     ; 4
    sta    $8b              ; 3
    jmp    CheckJoystick    ; 3

Lf94a:
    lda    $ed              ; 3
    and    #$04             ; 2
    beq    Lf96b            ; 2
    lda    $b5              ; 3
    clc                     ; 2
    adc    #$0f             ; 2
    tax                     ; 2
    lda    $b6              ; 3
    jsr    Lff3b            ; 6
    bcc    Lf96b            ; 2
    lda    frameCntLo       ; 3
    and    #$01             ; 2
    bne    Lf96b            ; 2
    lda    $be              ; 3
    sbc    #$07             ; 2
    cmp    $a7              ; 3
    bcc    Lf922            ; 2
Lf96b:
    lda    $ed              ; 3
    and    #$0a             ; 2
    beq    Lf983            ; 2
    ldx    #$00             ; 2
    lda    $b6              ; 3
    jsr    Lff3e            ; 6
    bcc    Lf983            ; 2
    lda    $be              ; 3
    ldx    #$05             ; 2
    jsr    Lff9b            ; 6
Lf981:
    bcs    Lf922            ; 2
Lf983:
    lda    $ee              ; 3
    and    #$20             ; 2
    bne    Lf98f            ; 2
    lda    $ef              ; 3
    and    #$02             ; 2
    beq    Lf9ac            ; 2
Lf98f:
    ldx    #$00             ; 2
    lda    $b6              ; 3
    jsr    Lff3e            ; 6
    bcc    Lf9ac            ; 2
    lda    $b8              ; 3
    ldx    #$03             ; 2
    jsr    Lff9b            ; 6
    bcs    Lf981            ; 2
    cpy    #$01             ; 2
    bne    Lf9ac            ; 2
    lda    #$ff             ; 2
    ldy    #$06             ; 2
    jsr    Lffc7            ; 6
Lf9ac:
    lda    $ef              ; 3
    and    #$08             ; 2
    beq    Lf9c8            ; 2
    lda    $b5              ; 3
    clc                     ; 2
    adc    #$0f             ; 2
    tax                     ; 2
    lda    $b6              ; 3
    jsr    Lff3b            ; 6
    bcc    Lf9c8            ; 2
    lda    $be              ; 3
    ldx    #$03             ; 2
    jsr    Lff9b            ; 6
    bcs    Lf981            ; 2
Lf9c8:
    lda    $ee              ; 3
    and    #$02             ; 2
    beq    Lf9e2            ; 2
    ldx    #$0f             ; 2
    lda    $c6              ; 3
    beq    Lf9e2            ; 2
    jsr    Lff3b            ; 6
    bcc    Lf9e2            ; 2
    lda    #$04             ; 2
    ldx    #$03             ; 2
    jsr    Lff9b            ; 6
    bcs    Lf981            ; 2
Lf9e2:
    lda    $ef              ; 3
    lsr                     ; 2
    bcc    CheckJoystick    ; 2
    ldx    #$0f             ; 2
    lda    $b6              ; 3
    jsr    Lff3b            ; 6
    bcc    CheckJoystick    ; 2
    lda    $bf              ; 3
    ldx    #$03             ; 2
    jsr    Lff9b            ; 6
    bcs    Lf981            ; 2

CheckJoystick SUBROUTINE
.button     = $f6
.joystick   = $f7
    ldy    SWCHA            ; 4
    ldx    player           ; 3
    bne    Lfa08            ; 2+1
    lda    SWCHA            ; 4
    lsr                     ; 2
    lsr                     ; 2
    lsr                     ; 2
    lsr                     ; 2
    tay                     ; 2
Lfa08:
    tya                     ; 2
    eor    #$ff             ; 2
    and    #$0f             ; 2
    sta    .joystick        ; 3
    lda    $8b              ; 3
    and    #$20             ; 2
    bne    Lfa20            ; 2
    lda    $8b              ; 3
    bmi    Lfa23            ; 2
    and    #$0c             ; 2
    beq    Lfa20            ; 2
Lfa1d:
    jmp    Lfacf            ; 3

Lfa20:
    jmp    VSync            ; 3

Lfa23:
    lda    INPT4,x          ; 4
    sta    .button          ; 3
    lda    .joystick        ; 3
    and    #$0f             ; 2
    cmp    #UP_DIR          ; 2
    beq    Lfa33            ; 2
    lda    .button          ; 3
    bmi    Lfa1d            ; 2
Lfa33:
    lda    $a9              ; 3
    and    #$08             ; 2
    beq    Lfa3c            ; 2
    jmp    Lfad5            ; 3

Lfa3c:
    lda    $a9              ; 3
    ora    #$08             ; 2
    sta    $a9              ; 3
    lda    $a8              ; 3
    and    #$10             ; 2
    bne    Lfa9d            ; 2
    lda    $a8              ; 3
    and    #$40             ; 2
    beq    Lfa51            ; 2
    jmp    Lfade            ; 3

Lfa51:
    ldx    #$02             ; 2
    lda    .joystick        ; 3
    and    #UP_DIR          ; 2
    bne    Lfa5a            ; 2
    dex                     ; 2
Lfa5a:
    lda    $a8              ; 3
    and    #$f7             ; 2
    ora    #$40             ; 2
    sta    $a8              ; 3
    inc    $a7              ; 5
    txa                     ; 2
    ora    #$08             ; 2
    sta    $a9              ; 3
    lda    #$10             ; 2
    sta    $aa              ; 3
    lda    $a8              ; 3
    and    #$20             ; 2
    beq    Lfa8f            ; 2
    lda    $a8              ; 3
    and    #$d7             ; 2
    sta    $a8              ; 3
    lda    Lfc1a,x          ; 4
    sta    $aa              ; 3
    bmi    Lfa89            ; 2
    lda    $a9              ; 3
    ora    #$03             ; 2
    sta    $a9              ; 3
    jmp    Lfa8f            ; 3

Lfa89:
    lda    $a9              ; 3
    ora    #$80             ; 2
    sta    $a9              ; 3
Lfa8f:
    lda    #$00             ; 2
    sta    $a0              ; 3
    ldy    #$05             ; 2
    lda    #$00             ; 2
    jsr    Lfd23            ; 6
    jmp    Lfade            ; 3

Lfa9d:
    lda    $a9              ; 3
    bpl    Lfacc            ; 2
    lda    $a7              ; 3
    cmp    #$0e             ; 2
    bcs    Lfacf            ; 2
    lda    $a9              ; 3
    and    #$7c             ; 2
    sta    $a9              ; 3
    lda    .joystick        ; 3
    and    #UP_DIR          ; 2
    beq    Lfa51            ; 2
    lda    $9c              ; 3
    ora    #$80             ; 2
    sta    $9c              ; 3
    lda    #$00             ; 2
    sta    $a0              ; 3
    lda    #$0a             ; 2
    sta    $a9              ; 3
    lda    #$2a             ; 2
Lfac3:
    sta    $aa              ; 3
    ldy    #$05             ; 2
    lda    #$18             ; 2
    jsr    Lfd23            ; 6
Lfacc:
    jmp    Lfade            ; 3

Lfacf:
    lda    $a9              ; 3
    and    #$f7             ; 2
    sta    $a9              ; 3
Lfad5:
    lda    $a8              ; 3
    and    #$40             ; 2
    bne    Lfade            ; 2
    jmp    Lfb88            ; 3

Lfade:
    lda    #$fb             ; 2
    sta    $ea              ; 3
    lda    $a9              ; 3
    and    #$03             ; 2
    tax                     ; 2
    lda    Lfbf0,x          ; 4
    sta    $e9              ; 3
    lda    frameCntLo       ; 3
    and    #$07             ; 2
    tay                     ; 2
    lda    ($e9),y          ; 5
    beq    Lfaff            ; 2
    inc    $a7              ; 5
    lda    $a9              ; 3
    bpl    Lfaff            ; 2
    dec    $a7              ; 5
    dec    $a7              ; 5
Lfaff:
    dec    $aa              ; 5
    bne    Lfb20            ; 2
    lda    $a9              ; 3
    ora    #$80             ; 2
    and    Lfc1d,x          ; 4
    sta    $a9              ; 3
    and    #$03             ; 2
    cmp    #$03             ; 2
    bne    Lfb18            ; 2
    lda    $a9              ; 3
    and    #$fd             ; 2
    sta    $a9              ; 3
Lfb18:
    lda    $9c              ; 3
    and    #$7f             ; 2
    sta    $9c              ; 3
    dec    $aa              ; 5
Lfb20:
    lda    Lfbf4,x          ; 4
    sta    $e9              ; 3
    lda    ($e9),y          ; 5
    beq    Lfb37            ; 2
    inc    xPos             ; 5
    lda    $a8              ; 3
    bpl    Lfb37            ; 2
    dec    xPos             ; 5
    dec    xPos             ; 5
    bne    Lfb37            ; 2
    inc    xPos             ; 5
Lfb37:
    lda    $f8              ; 3
    cmp    #$03             ; 2
    beq    Lfb66            ; 2
    lda    $a8              ; 3
    and    #$10             ; 2
    beq    Lfb6f            ; 2
    ldy    #$42             ; 2
    lda    $a7              ; 3
    cmp    #$14             ; 2
    bcc    Lfb4d            ; 2
    ldy    #$00             ; 2
Lfb4d:
    sty    $a0              ; 3
    lda    $a7              ; 3
    cmp    #$0c             ; 2
    bne    Lfb85            ; 2
    lda    $a9              ; 3
    bpl    Lfb85            ; 2
    lda    $a9              ; 3
    and    #$7c             ; 2
    ora    #$02             ; 2
    sta    $a9              ; 3
    lda    #$14             ; 2
    jmp    Lfac3            ; 3

Lfb66:
    lda    $a7              ; 3
    cmp    $f0              ; 3
    beq    Lfb75            ; 2
    jmp    Lfb85            ; 3

Lfb6f:
    lda    $a7              ; 3
    cmp    #$09             ; 2
    bne    Lfb85            ; 2
Lfb75:
    lda    $a9              ; 3
    and    #$08             ; 2
    sta    $a9              ; 3
    lda    $a8              ; 3
    and    #$bf             ; 2
    sta    $a8              ; 3
    lda    #$42             ; 2
    sta    $a0              ; 3
Lfb85:
    jmp    Lfbc8            ; 3

Lfb88:
    lda    $8b              ; 3
    bpl    Lfb85            ; 2
    lda    $a8              ; 3
    and    #$20             ; 2
    bne    Lfb85            ; 2
    ldy    #$42             ; 2
    lda    .joystick        ; 3
    and    #HORZ_DIR        ; 2
    beq    .skipHorz        ; 2
    lda    frameCntLo       ; 3
    and    #$03             ; 2
    beq    Lfbb0            ; 2
    inc    xPos             ; 5
    lda    .joystick        ; 3
    and    #RIGHT_DIR       ; 2
    bne    Lfbb0            ; 2
    dec    xPos             ; 5
    dec    xPos             ; 5
    bne    Lfbb0            ; 2
    inc    xPos             ; 5
Lfbb0:
    ldx    $ab              ; 3
    lda    frameCntLo       ; 3
    and    #$07             ; 2
    bne    Lfbc3            ; 2
    ldx    $ab              ; 3
    inx                     ; 2
    cpx    #$03             ; 2
    bne    Lfbc1            ; 2
    ldx    #$00             ; 2
Lfbc1:
    stx    $ab              ; 3
Lfbc3:
    ldy    Lfbed,x          ; 4
.skipHorz:
    sty    $a0              ; 3
Lfbc8:
    lda    .joystick        ; 3
    and    #HORZ_DIR        ; 2
    beq    Lfbe0            ; 2
    ldy    #$80             ; 2
    and    #LEFT_DIR        ; 2
    bne    Lfbd6            ; 2
    ldy    #$00             ; 2
Lfbd6:
    sty    $e9              ; 3
    lda    $a8              ; 3
    and    #$7f             ; 2
    ora    $e9              ; 3
    sta    $a8              ; 3
Lfbe0:
    ldy    #$08             ; 2
    lda    $a8              ; 3
    bmi    Lfbe8            ; 2
    ldy    #$00             ; 2
Lfbe8:
    sty    $a5              ; 3
    jmp    VSync            ; 3

Lfbed:
    .byte %00000000 ; $00 ; |        | $fbed
    .byte %00010110 ; $16 ; |   X XX | $fbee
    .byte %00101100 ; $2c ; |  X XX  | $fbef
Lfbf0:
    .byte %00000111 ; $07 ; |     XXX| $fbf0
    .byte %00000110 ; $06 ; |     XX | $fbf1
    .byte %00000110 ; $06 ; |     XX | $fbf2
    .byte %11111000 ; $f8 ; |XXXXX   | $fbf3
Lfbf4:
    .byte %11111111 ; $ff ; |XXXXXXXX| $fbf4
    .byte %11111000 ; $f8 ; |XXXXX   | $fbf5
    .byte %11111111 ; $ff ; |XXXXXXXX| $fbf6
    .byte %00000110 ; $06 ; |     XX | $fbf7
Lfbf8:
    .byte %00000001 ; $01 ; |       X| $fbf8
    .byte %00000000 ; $00 ; |        | $fbf9
    .byte %00000001 ; $01 ; |       X| $fbfa
    .byte %00000000 ; $00 ; |        | $fbfb
    .byte %00000001 ; $01 ; |       X| $fbfc
    .byte %00000000 ; $00 ; |        | $fbfd
    .byte %00000001 ; $01 ; |       X| $fbfe
    .byte %00000000 ; $00 ; |        | $fbff
    .byte %00000000 ; $00 ; |        | $fc00
    .byte %00000000 ; $00 ; |        | $fc01
    .byte %00000000 ; $00 ; |        | $fc02
    .byte %00000000 ; $00 ; |        | $fc03
    .byte %00000000 ; $00 ; |        | $fc04
    .byte %00000000 ; $00 ; |        | $fc05
    .byte %00000000 ; $00 ; |        | $fc06
    .byte %00000001 ; $01 ; |       X| $fc07
    .byte %00000001 ; $01 ; |       X| $fc08
    .byte %00000001 ; $01 ; |       X| $fc09
Lfc0a:
    .byte %00000001 ; $01 ; |       X| $fc0a
    .byte %00000001 ; $01 ; |       X| $fc0b
    .byte %00000001 ; $01 ; |       X| $fc0c
    .byte %00000001 ; $01 ; |       X| $fc0d
    .byte %00000001 ; $01 ; |       X| $fc0e
    .byte %00000000 ; $00 ; |        | $fc0f
    .byte %00000000 ; $00 ; |        | $fc10
    .byte %00000000 ; $00 ; |        | $fc11
Lfc12:
    .byte %11111111 ; $ff ; |XXXXXXXX| $fc12
    .byte %11111111 ; $ff ; |XXXXXXXX| $fc13
    .byte %11111111 ; $ff ; |XXXXXXXX| $fc14
    .byte %11111111 ; $ff ; |XXXXXXXX| $fc15
    .byte %11111111 ; $ff ; |XXXXXXXX| $fc16
    .byte %00000000 ; $00 ; |        | $fc17
    .byte %00000000 ; $00 ; |        | $fc18
    .byte %00000000 ; $00 ; |        | $fc19
Lfc1a:
    .byte %00001010 ; $0a ; |    X X | $fc1a
    .byte %00001010 ; $0a ; |    X X | $fc1b
    .byte %11111111 ; $ff ; |XXXXXXXX| $fc1c
Lfc1d:
    .byte %11111111 ; $ff ; |XXXXXXXX| $fc1d
    .byte %11111111 ; $ff ; |XXXXXXXX| $fc1e
    .byte %11111100 ; $fc ; |XXXXXX  | $fc1f
    .byte %11111111 ; $ff ; |XXXXXXXX| $fc20

VSync SUBROUTINE
    lda    INTIM            ; 4
    bmi    VSync            ; 2
    sta    WSYNC            ; 3
    lda    #$02             ; 2
    sta    WSYNC            ; 3
    sta    VBLANK           ; 3
    sta    WSYNC            ; 3
    sta    WSYNC            ; 3
    sta    WSYNC            ; 3
    sta    VSYNC            ; 3
    sta    WSYNC            ; 3
    sta    WSYNC            ; 3
    lda    #$00             ; 2
    sta    WSYNC            ; 3
    sta    VSYNC            ; 3
    jmp    Lf021            ; 3

Lfc43:
    lda    audVol0          ; 3
    cmp    #$ff             ; 2
    bne    Lfc4d            ; 2
    cmp    $d1              ; 3
    beq    Lfca6            ; 2
Lfc4d:
    ldx    #$01             ; 2
Lfc4f:
    ldy    $d2,x            ; 4
    lda    audVolLst,x      ; 4
    cmp    #$ff             ; 2
    beq    Lfca3            ; 2
    cmp    #$00             ; 2
    bne    Lfc77            ; 2
    lda    Lfd4a,y          ; 4
    cmp    #$ff             ; 2
    bne    Lfc6a            ; 2
    sta    audVolLst,x      ; 4
    lda    #$00             ; 2
    sta    AUDV0,x          ; 4
    beq    Lfca3            ; 3

Lfc6a:
    lsr                     ; 2
    lsr                     ; 2
    lsr                     ; 2
    lsr                     ; 2
    lsr                     ; 2
    tay                     ; 2
    lda    Lfd43,y          ; 4
    sta    audVolLst,x      ; 4
    ldy    $d2,x            ; 4
Lfc77:
    dec    audVolLst,x      ; 6
    bne    Lfc7d            ; 2
    inc    $d2,x            ; 6
Lfc7d:
    lda    $db,x            ; 4
    bpl    Lfca3            ; 2
    lda    Lfd4a,y          ; 4
    and    #$e0             ; 2
    bne    Lfc8f            ; 2
    lda    audVolLst,x      ; 4
    clc                     ; 2
    adc    #$04             ; 2
    bne    Lfc97            ; 2
Lfc8f:
    lda    #$09             ; 2
    cmp    audVolLst,x      ; 4
    bcc    Lfc97            ; 2
    lda    audVolLst,x      ; 4
Lfc97:
    sta    AUDV0,x          ; 4
    lda    AudC0Tbl,x       ; 4
    sta    AUDC0,x          ; 4
    lda    Lfd4a,y          ; 4
    sta    AUDF0,x          ; 4
Lfca3:
    dex                     ; 2
    bpl    Lfc4f            ; 2
Lfca6:
    ldx    #$01             ; 2
Lfca8:
    lda    $db,x            ; 4
    bmi    Lfce2            ; 2
    bne    Lfcdc            ; 2
    ldy    $dd,x            ; 4
    lda    Lfdd9,y          ; 4
    bpl    Lfcbd            ; 2
    sta    $db,x            ; 4
    lda    #$00             ; 2
    sta    AUDV0,x          ; 4
    beq    Lfce2            ; 3

Lfcbd:
    sta    AUDF0,x          ; 4
    rol                     ; 2
    rol                     ; 2
    rol                     ; 2
    rol                     ; 2
    and    #$03             ; 2
    tay                     ; 2
    lda    Lfdd5,y          ; 4
    sta    AUDC0,x          ; 4
    ldy    $dd,x            ; 4
    lda    Lfe21,y          ; 4
    sta    AUDV0,x          ; 4
    lsr                     ; 2
    lsr                     ; 2
    lsr                     ; 2
    lsr                     ; 2
    tay                     ; 2
    lda    Lfe15,y          ; 4
    sta    $db,x            ; 4
Lfcdc:
    dec    $db,x            ; 6
    bne    Lfce2            ; 2
    inc    $dd,x            ; 6
Lfce2:
    dex                     ; 2
    bpl    Lfca8            ; 2
    lda    $8b              ; 3
    bpl    Lfcfb            ; 2
    lda    audVol0          ; 3
    bpl    Lfcfb            ; 2
    lda    $d1              ; 3
    bpl    Lfcfb            ; 2
    lda    #$17             ; 2
    ldx    #$55             ; 2
    jsr    StartAudio       ; 6
    jmp    Lfc43            ; 3

Lfcfb:
    rts                     ; 6

Lfcfc:
    lda    #$00             ; 2
    ldx    #$43             ; 2
StartAudio SUBROUTINE
    sta    $d2              ; 3
    stx    $d3              ; 3
    lda    #$00             ; 2
    sta    audVol0          ; 3
    sta    $d1              ; 3
    rts                     ; 6

StopAudio SUBROUTINE
    ldx    #$ff             ; 2
    stx    audVol0          ; 3
    stx    $d1              ; 3
    inx                     ; 2
    stx    AUDV0            ; 3
    stx    AUDV1            ; 3
    rts                     ; 6

Lfd17:
    ldx    #$ff             ; 2
    stx    $db              ; 3
    stx    $dc              ; 3
    inx                     ; 2
    stx    AUDV0            ; 3
    stx    AUDV1            ; 3
    rts                     ; 6

Lfd23:
    pha                     ; 3
    lda    $8b              ; 3
    bpl    Lfd35            ; 2
    bmi    Lfd2b            ; 2
Lfd2a:
    pha                     ; 3
Lfd2b:
    ldx    #$01             ; 2
    lda    $db,x            ; 4
    bmi    Lfd37            ; 2
    cpy    $e2              ; 3
    bcc    Lfd37            ; 2
Lfd35:
    pla                     ; 4
    rts                     ; 6

Lfd37:
    pla                     ; 4
Lfd38:
    sty    $e2              ; 3
    sta    $dd,x            ; 4
    lda    #$00             ; 2
    sta    $db,x            ; 4
    rts                     ; 6

AudC0Tbl:
    .byte $04 ; $fd41
    .byte $0c
Lfd43:
    .byte $05 ; $fd43
    .byte $0a
    .byte $0f
    .byte $14
    .byte $19
    .byte $28
    .byte $5a
Lfd4a:
    .byte $3a ; $fd4a
    .byte $11
    .byte $11
    .byte $3a
    .byte $11
    .byte $11
    .byte $34
    .byte $11
    .byte $11
    .byte $14
    .byte $14
    .byte $31
    .byte $31
    .byte $13
    .byte $13
    .byte $14
    .byte $14
    .byte $17
    .byte $17
    .byte $7a
    .byte $7a
    .byte $a0
    .byte $ff
    .byte $20
    .byte $7b
    .byte $37
    .byte $51
    .byte $0f
    .byte $31
    .byte $37
    .byte $20
    .byte $7b
    .byte $37
    .byte $b1
    .byte $20
    .byte $7a
    .byte $34
    .byte $4f
    .byte $0d
    .byte $2f
    .byte $34
    .byte $20
    .byte $7a
    .byte $34
    .byte $af
    .byte $ff
    .byte $77
    .byte $38
    .byte $94
    .byte $17
    .byte $57
    .byte $18
    .byte $78
    .byte $3b
    .byte $97
    .byte $18
    .byte $58
    .byte $1b
    .byte $5b
    .byte $1d
    .byte $5b
    .byte $17
    .byte $78
    .byte $3f
    .byte $d7
    .byte $c0
    .byte $ff
    .byte $31
    .byte $0d
    .byte $0d
    .byte $31
    .byte $0d
    .byte $0d
    .byte $31
    .byte $0d
    .byte $0d
    .byte $31
    .byte $2d
    .byte $32
    .byte $2f
    .byte $77
    .byte $31
    .byte $37
    .byte $71
    .byte $ff
    .byte $37
    .byte $2f
    .byte $38
    .byte $2f
    .byte $3b
    .byte $2f
    .byte $38
    .byte $2f
    .byte $37
    .byte $2f
    .byte $38
    .byte $2f
    .byte $3b
    .byte $2f
    .byte $3f
    .byte $2f
    .byte $34
    .byte $2d
    .byte $35
    .byte $2d
    .byte $37
    .byte $2d
    .byte $35
    .byte $2d
    .byte $34
    .byte $2d
    .byte $35
    .byte $2d
    .byte $37
    .byte $2d
    .byte $38
    .byte $2d
    .byte $ff
    .byte $7f
    .byte $74
    .byte $7f
    .byte $74
    .byte $72
    .byte $78
    .byte $72
    .byte $78
    .byte $57
    .byte $18
    .byte $57
    .byte $15
    .byte $74
    .byte $34
    .byte $9f
    .byte $15
    .byte $54
    .byte $10
    .byte $6f
    .byte $7f
    .byte $ff
Lfdd5:
    .byte $04 ; $fdd5
    .byte $08
    .byte $0c
    .byte $0e
Lfdd9:
    .byte $1b ; $fdd9
    .byte $15
    .byte $11
    .byte $00
    .byte $ff
    .byte $1d
    .byte $17
    .byte $13
    .byte $17
    .byte $1a
    .byte $15
    .byte $11
    .byte $15
    .byte $17
    .byte $13
    .byte $0f
    .byte $13
    .byte $0e
    .byte $ff
    .byte $4f
    .byte $4e
    .byte $4c
    .byte $53
    .byte $ff
    .byte $5c
    .byte $51
    .byte $5e
    .byte $5c
    .byte $ff
    .byte $62
    .byte $62
    .byte $62
    .byte $62
    .byte $62
    .byte $62
    .byte $62
    .byte $ff
    .byte $57
    .byte $51
    .byte $4f
    .byte $ff
    .byte $3a
    .byte $3b
    .byte $24
    .byte $22
    .byte $ff
    .byte $4d
    .byte $49
    .byte $47
    .byte $ff
    .byte $10
    .byte $00
    .byte $0f
    .byte $00
    .byte $11
    .byte $00
    .byte $0d
    .byte $00
    .byte $0b
    .byte $ff
Lfe15:
    .byte $01 ; $fe15
    .byte $02
    .byte $03
    .byte $04
    .byte $06
    .byte $08
    .byte $09
    .byte $0c
    .byte $0f
    .byte $19
    .byte $1e
    .byte $20
Lfe21:
    .byte $2c ; $fe21
    .byte $38
    .byte $25
    .byte $20
    .byte $ff
    .byte $7c
    .byte $3c
    .byte $5c
    .byte $5c
    .byte $7c
    .byte $3c
    .byte $5c
    .byte $5c
    .byte $7c
    .byte $3c
    .byte $5c
    .byte $5c
    .byte $bc
    .byte $ff
    .byte $bc
    .byte $bc
    .byte $bc
    .byte $bc
    .byte $ff
    .byte $1f
    .byte $1d
    .byte $48
    .byte $73
    .byte $ff
    .byte $ab
    .byte $8c
    .byte $ab
    .byte $8c
    .byte $8d
    .byte $9e
    .byte $8f
    .byte $ff
    .byte $3d
    .byte $2c
    .byte $48
    .byte $ff
    .byte $1f
    .byte $52
    .byte $3f
    .byte $18
    .byte $ff
    .byte $28
    .byte $38
    .byte $48
    .byte $ff
    .byte $0c
    .byte $00
    .byte $1c
    .byte $00
    .byte $1c
    .byte $00
    .byte $1d
    .byte $00
    .byte $1b
    .byte $ff

Lfe5d:
    lda    #$06             ; 2
Lfe5f:
    sta    $d7              ; 3
    lda    #$e0             ; 2
    sta    $8b              ; 3
    lda    #$09             ; 2
    sta    xPos             ; 3
    sta    $a7              ; 3
    lda    $a8              ; 3
    and    #$b7             ; 2
    sta    $a8              ; 3
    jsr    Lfd17            ; 6
Lfe74:
    ldx    #$1f             ; 2
    lda    #$00             ; 2
    sta    $9c              ; 3
    sta    $a9              ; 3
    sta    $e3              ; 3
Lfe7e:
    sta    $b0,x            ; 4
    dex                     ; 2
    bpl    Lfe7e            ; 2
    rts                     ; 6

InitGame SUBROUTINE
    lda    #$03             ; 2
    sta    livesP0          ; 3
    sta    livesP1          ; 3
    sta    $e5              ; 3
    sta    $e6              ; 3
    ldx    #0               ; 2
    stx    player           ; 3
    stx    scene            ; 3
    stx    screen           ; 3
    stx    otherScene       ; 3
    stx    otherScreen      ; 3
    stx    scoreLst         ; 3
    stx    scoreLst+1       ; 3
    stx    scoreLst+2       ; 3
    stx    scoreLst+3       ; 3
    stx    scoreLst+4       ; 3
    stx    scoreLst+5       ; 3
    inx                     ; 2
    stx    otherPlayer      ; 3
    lda    #60              ; 2
    sta    time             ; 3
    sta    otherTime        ; 3
    rts                     ; 6

Lfeb0:
    lda    $ee              ; 3
    and    #$01             ; 2
    beq    Lfed3            ; 2
    lda    $9c              ; 3
    beq    Lfedb            ; 2
    bpl    Lfeeb            ; 2
    and    #$01             ; 2
    beq    Lfeeb            ; 2
    cmp    $aa              ; 3
    bne    Lfeeb            ; 2
    lda    xPos             ; 3
    cmp    $9a              ; 3
    bne    Lfeeb            ; 2
    inc    $9c              ; 5
    lda    #$00             ; 2
    ldy    #$02             ; 2
    jsr    Lff0f            ; 6
Lfed3:
    lda    #$00             ; 2
    beq    Lfee9            ; 2
Lfed7:
    sec                     ; 2
    cli                     ; 2
    sec                     ; 2
    cli                     ; 2
Lfedb:
    lda    frameCntLo       ; 3
    and    #$03             ; 2
    tax                     ; 2
    lda    Lfed7,x          ; 4
    sta    $9a              ; 3
    inc    $9c              ; 5
    lda    #$ff             ; 2
Lfee9:
    sta    $9b              ; 3
Lfeeb:
    rts                     ; 6

SwapPlayers SUBROUTINE
    ldy    scene            ; 3
    lda    otherScene       ; 3
    sta    scene            ; 3
    sty    otherScene       ; 3
    ldy    screen           ; 3
    lda    otherScreen      ; 3
    sta    screen           ; 3
    sty    otherScreen      ; 3
    ldy    time             ; 3
    lda    otherTime        ; 3
    sta    time             ; 3
    sty    otherTime        ; 3
    ldy    player           ; 3
    ldx    otherPlayer      ; 3
    stx    player           ; 3
    sty    otherPlayer      ; 3
    rts                     ; 6

Lff0d:
    ldy    #$00             ; 2
Lff0f:
    sta    $e9              ; 3
    ldx    player           ; 3
    clc                     ; 2
    sed                     ; 2
    lda    $e9              ; 3
    adc    scoreLoLst,x     ; 4
    sta    scoreLoLst,x     ; 4
    tya                     ; 2
    adc    scoreMidLst,x    ; 4
    sta    scoreMidLst,x    ; 4
    bcc    Lff32            ; 2
    lda    #$00             ; 2
    adc    scoreHiLst,x     ; 4
    sta    scoreHiLst,x     ; 4
    inc    livesLst,x       ; 6
    lda    livesLst,x       ; 4
    cmp    #$08             ; 2
    bcc    Lff32            ; 2
    dec    livesLst,x       ; 6
Lff32:
    cld                     ; 2
    ldy    #$01             ; 2
    lda    #$2e             ; 2
    jsr    Lfd2a            ; 6
    rts                     ; 6

Lff3b:
    clc                     ; 2
    adc    #$03             ; 2
Lff3e:
    ldy    Lff75,x          ; 4
Lff41:
    sta    $e9              ; 3
    lda    xPos             ; 3
    cmp    $e9              ; 3
    bcs    Lff4e            ; 2
    adc    #$07             ; 2
    cmp    $e9              ; 3
    rts                     ; 6

Lff4e:
    lda    $e9              ; 3
    adc    Lff62,x          ; 4
    cmp    xPos             ; 3
    bcc    Lff58            ; 2
    rts                     ; 6

Lff58:
    dey                     ; 2
    bne    Lff5c            ; 2
    rts                     ; 6

Lff5c:
    adc    Lff88,x          ; 4
    jmp    Lff41            ; 3

Lff62:
    .byte %00000111 ; $07 ; |     XXX| $ff62
    .byte %00000111 ; $07 ; |     XXX| $ff63
    .byte %00000111 ; $07 ; |     XXX| $ff64
    .byte %00000111 ; $07 ; |     XXX| $ff65
    .byte %00000111 ; $07 ; |     XXX| $ff66
    .byte %00001111 ; $0f ; |    XXXX| $ff67
    .byte %00000111 ; $07 ; |     XXX| $ff68
    .byte %00011111 ; $1f ; |   XXXXX| $ff69
    .byte %00000001 ; $01 ; |       X| $ff6a
    .byte %00000001 ; $01 ; |       X| $ff6b
    .byte %00101100 ; $2c ; |  X XX  | $ff6c
    .byte %00001011 ; $0b ; |    X XX| $ff6d
    .byte %00000001 ; $01 ; |       X| $ff6e
    .byte %00000001 ; $01 ; |       X| $ff6f
    .byte %00000001 ; $01 ; |       X| $ff70
    .byte %00000001 ; $01 ; |       X| $ff71
    .byte %00000001 ; $01 ; |       X| $ff72
    .byte %00000001 ; $01 ; |       X| $ff73
    .byte %00000001 ; $01 ; |       X| $ff74
Lff75:
    .byte %00000001 ; $01 ; |       X| $ff75
    .byte %00000010 ; $02 ; |      X | $ff76
    .byte %00000010 ; $02 ; |      X | $ff77
    .byte %00000011 ; $03 ; |      XX| $ff78
    .byte %00000010 ; $02 ; |      X | $ff79
    .byte %00000001 ; $01 ; |       X| $ff7a
    .byte %00000011 ; $03 ; |      XX| $ff7b
    .byte %00000001 ; $01 ; |       X| $ff7c
    .byte %00000100 ; $04 ; |     X  | $ff7d
    .byte %00000101 ; $05 ; |     X X| $ff7e
    .byte %00000001 ; $01 ; |       X| $ff7f
    .byte %00000001 ; $01 ; |       X| $ff80
    .byte %00000101 ; $05 ; |     X X| $ff81
    .byte %00000001 ; $01 ; |       X| $ff82
    .byte %00000011 ; $03 ; |      XX| $ff83
    .byte %00000001 ; $01 ; |       X| $ff84
    .byte %00000010 ; $02 ; |      X | $ff85
    .byte %00000010 ; $02 ; |      X | $ff86
    .byte %00000011 ; $03 ; |      XX| $ff87
Lff88:
    .byte %00000000 ; $00 ; |        | $ff88
    .byte %00001000 ; $08 ; |    X   | $ff89
    .byte %00011000 ; $18 ; |   XX   | $ff8a
    .byte %00001000 ; $08 ; |    X   | $ff8b
    .byte %00111000 ; $38 ; |  XXX   | $ff8c
    .byte %00000000 ; $00 ; |        | $ff8d
    .byte %00011000 ; $18 ; |   XX   | $ff8e
    .byte %00000000 ; $00 ; |        | $ff8f
    .byte %00001110 ; $0e ; |    XXX | $ff90
    .byte %00001110 ; $0e ; |    XXX | $ff91
    .byte %00001110 ; $0e ; |    XXX | $ff92
    .byte %00000000 ; $00 ; |        | $ff93
    .byte %00001110 ; $0e ; |    XXX | $ff94
    .byte %00000000 ; $00 ; |        | $ff95
    .byte %00001110 ; $0e ; |    XXX | $ff96
    .byte %00000000 ; $00 ; |        | $ff97
    .byte %00001110 ; $0e ; |    XXX | $ff98
    .byte %00011110 ; $1e ; |   XXXX | $ff99
    .byte %00001110 ; $0e ; |    XXX | $ff9a

Lff9b:
    stx    $e9              ; 3
    cmp    $a7              ; 3
    bcc    Lffa9            ; 2
    sbc    $a7              ; 3
    cmp    $e9              ; 3
    bcc    Lffb4            ; 2
Lffa7:
    clc                     ; 2
    rts                     ; 6

Lffa9:
    sec                     ; 2
    sbc    $a7              ; 3
    eor    #$ff             ; 2
    adc    #$01             ; 2
    cmp    #$08             ; 2
    bcs    Lffa7            ; 2
Lffb4:
    sec                     ; 2
    rts                     ; 6

Lffb6 SUBROUTINE
    tay                     ; 2
    and    #$f0             ; 2
    lsr                     ; 2
    sta    $ec,x            ; 4
    inx                     ; 2
    tya                     ; 2
    and    #$0f             ; 2
    asl                     ; 2
    asl                     ; 2
    asl                     ; 2
    sta    $ec,x            ; 4
    inx                     ; 2
    rts                     ; 6

Lffc7:
    sta    $eb              ; 3
    lda    $e3              ; 3
    and    Lffed,y          ; 4
    bne    Lffec            ; 2
    lda    $e3              ; 3
    ora    Lffed,y          ; 4
    sta    $e3              ; 3
    tya                     ; 2
    pha                     ; 3
    txa                     ; 2
    pha                     ; 3
    lda    #$00             ; 2
    ldy    $eb              ; 3
    bpl    Lffe5            ; 2
    ldy    #$00             ; 2
    lda    #$50             ; 2
Lffe5:
    jsr    Lff0f            ; 6
    pla                     ; 4
    tax                     ; 2
    pla                     ; 4
    tay                     ; 2
Lffec:
    rts                     ; 6

Lffed:
    .byte %00000001 ; $01 ; |       X| $ffed
    .byte %00000010 ; $02 ; |      X | $ffee
    .byte %00000100 ; $04 ; |     X  | $ffef
    .byte %00001000 ; $08 ; |    X   | $fff0
    .byte %00010000 ; $10 ; |   X    | $fff1
    .byte %00100000 ; $20 ; |  X     | $fff2
    .byte %01000000 ; $40 ; | X      | $fff3
    .byte %10000000 ; $80 ; |X       | $fff4
    .byte %00001000 ; $08 ; |    X   | $fff5
    .byte %11111111 ; $ff ; |XXXXXXXX| $fff6
    .byte %11111111 ; $ff ; |XXXXXXXX| $fff7
    .byte %11111111 ; $ff ; |XXXXXXXX| $fff8
Lfff9:
    .byte %11111111 ; $ff ; |XXXXXXXX| $fff9
Lfffa:
    .byte $ff,$ff,$0d,$f0,$0d,$f0




;VBLANK  =  $01
;WSYNC   =  $02
;NUSIZ0  =  $04
;NUSIZ1  =  $05
;COLUP0  =  $06
;COLUP1  =  $07
;COLUPF  =  $08
;COLUBK  =  $09
;CTRLPF  =  $0a
;REFP0   =  $0b
;REFP1   =  $0c
;PF0     =  $0d
;PF1     =  $0e
;PF2     =  $0f
;RESP0   =  $10
;RESP1   =  $11
;RESBL   =  $14
;GRP0    =  $1b
;GRP1    =  $1c
;ENABL   =  $1f
;HMP0    =  $20
;HMP1    =  $21
;HMBL    =  $24
;VDELP0  =  $25
;VDELP1  =  $26
;HMOVE   =  $2a
;HMCLR   =  $2b
;INTIM   =  $0284
;TIM64T  =  $0296

    ORG $2000
    RORG $f000

Lf000:
    nop                     ; 2
    nop                     ; 2
    nop                     ; 2
    jmp    Lf010            ; 3

Lf006:
    nop                     ; 2
    lda    Lfff8            ; 4
    jmp    $e000            ; 3

START:
    lda    Lfff8            ; 4
Lf010:
    lda    #$38             ; 2
    sta    $90              ; 3
Lf014:
    lda    INTIM            ; 4
    bmi    Lf014            ; 2
    lda    #$40             ; 2
    sta    WSYNC            ; 3
    sta    VBLANK           ; 3
    lda    #$ff             ; 2
    sta    TIM64T           ; 4
    lda    $8b              ; 3
    and    #$20             ; 2
    beq    Lf02d            ; 2
    jmp    BlankScreen      ; 3

Lf02d:
    jsr    Lf61c            ; 6
    lda    $8b              ; 3
    and    #$40             ; 2
    bne    Lf039            ; 2
    jmp    DrawTitle        ; 3

Lf039:
    lda    time             ; 3
    tay                     ; 2
    lsr                     ; 2
    lsr                     ; 2
    and    #$07             ; 2
    tax                     ; 2
    cpy    #$20             ; 2
    bcc    Lf082            ; 2
    lda    #$ff             ; 2
    sta    PF1              ; 3
    lda    Lf051,x          ; 4
    sta    PF2              ; 3
    jmp    Lf08b            ; 3

Lf051:
    .byte %00000000 ; $00 ; |        | $f051
    .byte %00000001 ; $01 ; |       X| $f052
    .byte %00000011 ; $03 ; |      XX| $f053
    .byte %00000111 ; $07 ; |     XXX| $f054
    .byte %00001111 ; $0f ; |    XXXX| $f055
    .byte %00011111 ; $1f ; |   XXXXX| $f056
    .byte %00111111 ; $3f ; |  XXXXXX| $f057
    .byte %01111111 ; $7f ; | XXXXXXX| $f058
    .byte %11111111 ; $ff ; |XXXXXXXX| $f059
Lf05a:
    .byte %00000000 ; $00 ; |        | $f05a
    .byte %10000000 ; $80 ; |X       | $f05b
    .byte %11000000 ; $c0 ; |XX      | $f05c
    .byte %11100000 ; $e0 ; |XXX     | $f05d
    .byte %11110000 ; $f0 ; |XXXX    | $f05e
    .byte %11111000 ; $f8 ; |XXXXX   | $f05f
    .byte %11111100 ; $fc ; |XXXXXX  | $f060
    .byte %11111110 ; $fe ; |XXXXXXX | $f061
    .byte %11111111 ; $ff ; |XXXXXXXX| $f062

Lf063:
    .byte <Player1
    .byte <Player2
Player1:                                    ; 1P
    .byte %11101000 ; |XXX X   | $f065
    .byte %01001000 ; | X  X   |
    .byte %01001110 ; | X  XXX |
    .byte %11001010 ; |XX  X X |
    .byte %01001110 ; | X  XXX |
Player2:
    .byte %11101000 ; |XXX X   | $f06a      : 2P
    .byte %10001000 ; |X   X   |
    .byte %01001110 ; | X  XXX |
    .byte %00101010 ; |  X X X |
    .byte %11101110 ; |XXX XXX |
Lf06f:                                      ; TIME
    .byte %00100101 ; |  X  X X| $f06f
    .byte %00100101 ; |  X  X X|
    .byte %00100101 ; |  X  X X|
    .byte %00100101 ; |  X  X X|
    .byte %01110101 ; | XXX X X|
Lf074:
    .byte %00101110 ; |  X XXX | $f074
    .byte %00101000 ; |  X X   |
    .byte %00101100 ; |  X XX  |
    .byte %11101000 ; |XXX X   |
    .byte %00101110 ; |  X XXX |
BallWidthTbl:
    .byte %00000000 ; $f079
    .byte %00010000
    .byte %00010000
    .byte %00100000
Lf07d:
    .byte %11111100 ; $fc ; |XXXXXX  | $f07d
    .byte %01111000 ; $78 ; | XXXX   | $f07e
    .byte %00110000 ; $30 ; |  XX    | $f07f
    .byte %00010000 ; $10 ; |   X    | $f080
    .byte %00000000 ; $00 ; |        | $f081

Lf082:
    lda    #$00             ; 2
    sta    PF2              ; 3
    lda    Lf05a,x          ; 4
    sta    PF1              ; 3
Lf08b:
    sta    WSYNC            ; 3
    lda    #$02             ; 2
    sta    ENABL            ; 3
    lda    #$20             ; 2
    sta    CTRLPF           ; 3
    cpy    #$04             ; 2
    bcs    Lf0a6            ; 2
    lda    BallWidthTbl,y   ; 4
    sta    CTRLPF           ; 3
    cpy    #$00             ; 2
    bne    Lf0a4            ; 2
    sty    ENABL            ; 3
Lf0a4:
    ldy    #$04             ; 2
Lf0a6:
    sta    WSYNC            ; 3
    lda    #$40             ; 2
    sta    HMP0             ; 3
    lda    #$20             ; 2
    sta    HMP1             ; 3
    lda    time             ; 3
    nop                     ; 2
    lda    #$04             ; 2
    sta    NUSIZ0           ; 3
    lda    #$00             ; 2
    sta    NUSIZ1           ; 3
    nop                     ; 2
    sta    RESP0            ; 3
    tya                     ; 2
    tax                     ; 2
    lda    Lf85d,x          ; 4
    sta    HMBL             ; 3
    and    #$0f             ; 2
    tay                     ; 2
    sta    RESP1            ; 3
Lf0ca:
    dey                     ; 2
    bne    Lf0ca            ; 2
    sta    RESBL            ; 3
    sta    WSYNC            ; 3
    sta    HMOVE            ; 3
    lda    #$1e             ; 2
    sta    COLUP0           ; 3
    lda    #$76             ; 2
    sta    COLUP1           ; 3
    lda    #$f0             ; 2
    sta    $f3              ; 3
    lda    player           ; 3
    and    #$01             ; 2
    tax                     ; 2
    lda    Lf063,x          ; 4
    sta    $f2              ; 3
    ldy    #$04             ; 2
Lf0eb:
    sta    WSYNC            ; 3
    lda    #$00             ; 2
    sta    COLUPF           ; 3
    lda    ($f2),y          ; 5
    sta    GRP0             ; 3
    lda    #$1e             ; 2
    sta    COLUP0           ; 3
    lda    Lf06f,y          ; 4
    sta    GRP1             ; 3
    nop                     ; 2
    nop                     ; 2
    nop                     ; 2
    nop                     ; 2
    nop                     ; 2
    ldx    #$76             ; 2
    lda    Lf074,y          ; 4
    sta    GRP0             ; 3
    stx    COLUP0           ; 3
    lda    #$36             ; 2
    sta    COLUPF           ; 3
    dey                     ; 2
    bpl    Lf0eb            ; 2+1
    sta    WSYNC            ; 3
    sta    HMCLR            ; 3
    iny                     ; 2
    sty    GRP0             ; 3
    sty    GRP1             ; 3
    sty    GRP0             ; 3
    sty    COLUPF           ; 3
    sty    ENABL            ; 3
    lda    $a7              ; 3
    sec                     ; 2
    sbc    #$09             ; 2
    bmi    Lf131            ; 2
    lsr                     ; 2
    ldy    #$04             ; 2
    cmp    #$04             ; 2
    bcs    Lf131            ; 2
    tay                     ; 2
Lf131:
    lda    Lf07d,y          ; 4
    sta    $f4              ; 3
    sta    WSYNC            ; 3
    lda    $9b              ; 3
    bne    Lf140            ; 2
    lda    $b6              ; 3
    sta    $9a              ; 3
Lf140:
    lda    #$01             ; 2
    sta    CTRLPF           ; 3
    sta    WSYNC            ; 3
    lda    weird            ; 3
    ldx    xPos             ; 3
    lda    HMTbl,x          ; 4
    sta    HMP0             ; 3
    and    #$0f             ; 2
    tay                     ; 2
Lf152:
    dey                     ; 2
    bne    Lf152            ; 2
    sta    RESP0            ; 3
    sta    WSYNC            ; 3
    lda    weird            ; 3
    ldx    $9a              ; 3
    lda    HMTbl,x          ; 4
    sta    HMP1             ; 3
    and    #$0f             ; 2
    tay                     ; 2
Lf165:
    dey                     ; 2
    bne    Lf165            ; 2
    sta    RESP1            ; 3
    sta    WSYNC            ; 3
    sta    HMOVE            ; 3
    lda    #$1e             ; 2
    sta    COLUP1           ; 3
    lda    $a5              ; 3
    sta    REFP0            ; 3
    lda    #$00             ; 2
    sta    $92              ; 3
    sta    $93              ; 3
    sta    NUSIZ1           ; 3
    sta    NUSIZ0           ; 3
    ldx    #$0a             ; 2
    sta    HMCLR            ; 3
Lf184:
    sta    WSYNC            ; 3
    sta    GRP1             ; 3
    ldy    $91              ; 3
    lda    Lf900,y          ; 4
    sta    COLUPF           ; 3
    lda    Lfb00,y          ; 4
    sta    PF0              ; 3
    lda    Lfc00,y          ; 4
    sta    PF1              ; 3
    lda    Lfd00,y          ; 4
    sta    PF2              ; 3
    dec    $91              ; 5
    dex                     ; 2
    bmi    Lf1ba            ; 2
    lda    Lf1ef,x          ; 4
    and    $9b              ; 3
    sta    WSYNC            ; 3
    sta    GRP1             ; 3
    lda    COLUBGTbl,y      ; 4
    sta    COLUBK           ; 3
    dex                     ; 2
    lda    Lf1ef,x          ; 4
    and    $9b              ; 3
    jmp    Lf184            ; 3

Lf1ba:
    lda    $ba              ; 3
    sta    REFP1            ; 3
    lda    $b5              ; 3
    sta    NUSIZ1           ; 3
    lda    COLUBGTbl,y      ; 4
    dey                     ; 2
    ldx    $9b              ; 3
    beq    Lf1e4            ; 2
    sta    WSYNC            ; 3
    sta    COLUBK           ; 3
    ldx    $b6              ; 3
    lda    HMTbl,x          ; 4
    sta    HMP1             ; 3
    and    #$0f             ; 2
    tax                     ; 2
Lf1d8:
    dex                     ; 2
    bne    Lf1d8            ; 2
    sta    RESP1            ; 3
    sta    WSYNC            ; 3
    sta    HMOVE            ; 3
    jmp    Lf350            ; 3

Lf1e4:
    sta    WSYNC            ; 3
    sta    COLUBK           ; 3
    sta    WSYNC            ; 3
    lda    weird            ; 3
    jmp    Lf350            ; 3

Lf1ef:
    .byte %00000000 ; |        | $f1ef
    .byte %01111100 ; | XXXXX  | $f1f0
    .byte %11111100 ; |XXXXXX  | $f1f1
    .byte %11111110 ; |XXXXXXX | $f1f2
    .byte %11111110 ; |XXXXXXX | $f1f3
    .byte %01110110 ; | XXX XX | $f1f4
    .byte %01101100 ; | XX XX  | $f1f5
    .byte %00010001 ; |   X   X| $f1f6
    .byte %00011110 ; |   XXXX | $f1f7
    .byte %00000000 ; |        | $f1f8
    .byte %00000000 ; |        | $f1f9
    .byte %00000000 ; |        | $f1fa
    .byte %00000000 ; |        | $f1fb
    .byte %00000000 ; |        | $f1fc
    .byte %00000000 ; |        | $f1fd
    .byte %00000000 ; |        | $f1fe
    .byte %00000000 ; |        | $f1ff
    .byte %00000000 ; |        | $f200

    .byte %00000000 ; |        | $f201  CABBAGE TM
    .byte %00000111 ; |     XXX| $f202
    .byte %00000100 ; |     X  | $f203
    .byte %00000100 ; |     X  | $f204
    .byte %00000100 ; |     X  | $f205
    .byte %00000100 ; |     X  | $f206
    .byte %00000100 ; |     X  | $f207
    .byte %00000111 ; |     XXX| $f208
    .byte %00000000 ; |        | $f209
    .byte %10100101 ; |X X  X X| $f20a
    .byte %00100101 ; |  X  X X| $f20b
    .byte %00100101 ; |  X  X X| $f20c
    .byte %00111101 ; |  XXXX X| $f20d
    .byte %00100101 ; |  X  X X| $f20e
    .byte %00100101 ; |  X  X X| $f20f
    .byte %10111101 ; |X XXXX X| $f210
    .byte %00000000 ; |        | $f211
    .byte %11101111 ; |XXX XXXX| $f212
    .byte %00101001 ; |  X X  X| $f213
    .byte %00101001 ; |  X X  X| $f214
    .byte %11001110 ; |XX  XXX | $f215
    .byte %01001010 ; | X  X X | $f216
    .byte %01001010 ; | X  X X | $f217
    .byte %10001100 ; |X   XX  | $f218
    .byte %00000000 ; |        | $f219
    .byte %01001011 ; | X  X XX| $f21a
    .byte %01001010 ; | X  X X | $f21b
    .byte %01001010 ; | X  X X | $f21c
    .byte %01111010 ; | XXXX X | $f21d
    .byte %01001010 ; | X  X X | $f21e
    .byte %01001010 ; | X  X X | $f21f
    .byte %01111011 ; | XXXX XX| $f220
    .byte %00000000 ; |        | $f221
    .byte %11011110 ; |XX XXXX | $f222
    .byte %01010000 ; | X X    | $f223
    .byte %01010000 ; | X X    | $f224
    .byte %11011100 ; |XX XXX  | $f225
    .byte %00010000 ; |   X    | $f226
    .byte %00010000 ; |   X    | $f227
    .byte %11011110 ; |XX XXXX | $f228
    .byte %00000000 ; |        | $f229
    .byte %00000000 ; |        | $f22a
    .byte %00000000 ; |        | $f22b
    .byte %00100101 ; |  X  X X| $f22c
    .byte %00100101 ; |  X  X X| $f22d
    .byte %00100101 ; |  X  X X| $f22e
    .byte %00100111 ; |  X  XXX| $f22f
    .byte %01110101 ; | XXX X X| $f230
    .byte %00000000 ; |        | $f231
    .byte %00000000 ; |        | $f232
    .byte %00000000 ; |        | $f233
    .byte %00000000 ; |        | $f234
    .byte %00000000 ; |        | $f235
    .byte %00000000 ; |        | $f236
    .byte %00000000 ; |        | $f237
    .byte %00000000 ; |        | $f238
    .byte %00000000 ; |        | $f239
    .byte %00000011 ; |      XX| $f23a  IN THE PARK
    .byte %00000001 ; |       X| $f23b
    .byte %00000001 ; |       X| $f23c
    .byte %00000001 ; |       X| $f23d
    .byte %00000001 ; |       X| $f23e
    .byte %00000001 ; |       X| $f23f
    .byte %00000011 ; |      XX| $f240
    .byte %00000000 ; |        | $f241
    .byte %10100100 ; |X X  X  | $f242
    .byte %00101100 ; |  X XX  | $f243
    .byte %00101100 ; |  X XX  | $f244
    .byte %00101100 ; |  X XX  | $f245
    .byte %00110100 ; |  XX X  | $f246
    .byte %00110100 ; |  XX X  | $f247
    .byte %10100100 ; |X X  X  | $f248
    .byte %00000000 ; |        | $f249
    .byte %01001010 ; | X  X X | $f24a
    .byte %01001010 ; | X  X X | $f24b
    .byte %01001010 ; | X  X X | $f24c
    .byte %01001110 ; | X  XXX | $f24d
    .byte %01001010 ; | X  X X | $f24e
    .byte %01001010 ; | X  X X | $f24f
    .byte %11101010 ; |XXX X X | $f250
    .byte %00000000 ; |        | $f251
    .byte %11100000 ; |XXX     | $f252
    .byte %10000000 ; |X       | $f253
    .byte %10000000 ; |X       | $f254
    .byte %11000000 ; |XX      | $f255
    .byte %10000000 ; |X       | $f256
    .byte %10000000 ; |X       | $f257
    .byte %11100000 ; |XXX     | $f258
    .byte %00000000 ; |        | $f259
    .byte %10001010 ; |X   X X | $f25a
    .byte %10001010 ; |X   X X | $f25b
    .byte %10001010 ; |X   X X | $f25c
    .byte %11101110 ; |XXX XXX | $f25d
    .byte %10101010 ; |X X X X | $f25e
    .byte %10101010 ; |X X X X | $f25f
    .byte %11101110 ; |XXX XXX | $f260
    .byte %00000000 ; |        | $f261
    .byte %10010100 ; |X  X X  | $f262
    .byte %10100100 ; |X X  X  | $f263
    .byte %10100101 ; |X X  X X| $f264
    .byte %11100110 ; |XXX  XX | $f265
    .byte %10010101 ; |X  X X X| $f266
    .byte %10010100 ; |X  X X  | $f267
    .byte %11100100 ; |XXX  X  | $f268
    .byte %00000000 ; |        | $f269
    .byte %10000000 ; |X       | $f26a
    .byte %10000000 ; |X       | $f26b
    .byte %00000000 ; |        | $f26c
    .byte %00000000 ; |        | $f26d
    .byte %00000000 ; |        | $f26e
    .byte %10000000 ; |X       | $f26f
    .byte %10000000 ; |X       | $f270
    .byte %00000001 ; |       X| $f271
    .byte %00000001 ; |       X| $f272
    .byte %00000001 ; |       X| $f273
    .byte %00000000 ; |        | $f274
    .byte %00000000 ; |        | $f275
    .byte %10000001 ; |X      X| $f276
    .byte %01000010 ; | X    X | $f277
    .byte %00100100 ; |  X  X  | $f278
    .byte %00011000 ; |   XX   | $f279
    .byte %00100100 ; |  X  X  | $f27a
    .byte %01000010 ; | X    X | $f27b
    .byte %11111111 ; |XXXXXXXX| $f27c
    .byte %11111111 ; |XXXXXXXX| $f27d
    .byte %00000000 ; |        | $f27e
    .byte %00000000 ; |        | $f27f
    .byte %00000000 ; |        | $f280
    .byte %00000000 ; |        | $f281
    .byte %00010000 ; |   X    | $f282
    .byte %00010000 ; |   X    | $f283
    .byte %00010000 ; |   X    | $f284
    .byte %00010000 ; |   X    | $f285
    .byte %00110000 ; |  XX    | $f286
    .byte %00110000 ; |  XX    | $f287
    .byte %00110000 ; |  XX    | $f288
    .byte %00110000 ; |  XX    | $f289
    .byte %00100000 ; |  X     | $f28a
    .byte %00100000 ; |  X     | $f28b
    .byte %00100000 ; |  X     | $f28c
    .byte %00100000 ; |  X     | $f28d
    .byte %00100000 ; |  X     | $f28e
    .byte %00100000 ; |  X     | $f28f
    .byte %01100000 ; | XX     | $f290
    .byte %01100000 ; | XX     | $f291
    .byte %01000000 ; | X      | $f292
    .byte %01000000 ; | X      | $f293
    .byte %01000000 ; | X      | $f294
    .byte %01000000 ; | X      | $f295
    .byte %01000000 ; | X      | $f296
    .byte %01000000 ; | X      | $f297
    .byte %01000000 ; | X      | $f298
    .byte %11000000 ; |XX      | $f299
    .byte %11000000 ; |XX      | $f29a
    .byte %10000000 ; |X       | $f29b
    .byte %10000000 ; |X       | $f29c
    .byte %10000000 ; |X       | $f29d
    .byte %10000000 ; |X       | $f29e
    .byte %10000000 ; |X       | $f29f
    .byte %10000000 ; |X       | $f2a0
    .byte %10000000 ; |X       | $f2a1
    .byte %00000000 ; |        | $f2a2
    .byte %00000000 ; |        | $f2a3
    .byte %00000000 ; |        | $f2a4
    .byte %00000000 ; |        | $f2a5
    .byte %00000000 ; |        | $f2a6
    .byte %00000000 ; |        | $f2a7
    .byte %00000100 ; |     X  | $f2a8
    .byte %00000100 ; |     X  | $f2a9
    .byte %00000100 ; |     X  | $f2aa
    .byte %00001100 ; |    XX  | $f2ab
    .byte %00001000 ; |    X   | $f2ac
    .byte %00001000 ; |    X   | $f2ad
    .byte %00011000 ; |   XX   | $f2ae
    .byte %00011000 ; |   XX   | $f2af
    .byte %00010000 ; |   X    | $f2b0
    .byte %00010000 ; |   X    | $f2b1
    .byte %00010000 ; |   X    | $f2b2
    .byte %00010000 ; |   X    | $f2b3
    .byte %00110000 ; |  XX    | $f2b4
    .byte %00110000 ; |  XX    | $f2b5
    .byte %00100000 ; |  X     | $f2b6
    .byte %00100000 ; |  X     | $f2b7
    .byte %00100000 ; |  X     | $f2b8
    .byte %00100000 ; |  X     | $f2b9
    .byte %01100000 ; | XX     | $f2ba
    .byte %01100000 ; | XX     | $f2bb
    .byte %01000000 ; | X      | $f2bc
    .byte %01000000 ; | X      | $f2bd
    .byte %01000000 ; | X      | $f2be
    .byte %01000000 ; | X      | $f2bf
    .byte %11000000 ; |XX      | $f2c0
    .byte %11000000 ; |XX      | $f2c1
    .byte %10000000 ; |X       | $f2c2
    .byte %10000000 ; |X       | $f2c3
    .byte %10000000 ; |X       | $f2c4
    .byte %10000000 ; |X       | $f2c5
    .byte %00000000 ; |        | $f2c6
    .byte %00000000 ; |        | $f2c7
    .byte %00000000 ; |        | $f2c8
    .byte %00000000 ; |        | $f2c9
    .byte %00000000 ; |        | $f2ca
    .byte %00000000 ; |        | $f2cb
    .byte %00000000 ; |        | $f2cc
    .byte %00000000 ; |        | $f2cd
    .byte %00000001 ; |       X| $f2ce
    .byte %00000011 ; |      XX| $f2cf
    .byte %00000110 ; |     XX | $f2d0
    .byte %00000100 ; |     X  | $f2d1
    .byte %00001100 ; |    XX  | $f2d2
    .byte %00001000 ; |    X   | $f2d3
    .byte %00011000 ; |   XX   | $f2d4
    .byte %00010000 ; |   X    | $f2d5
    .byte %00010000 ; |   X    | $f2d6
    .byte %00110000 ; |  XX    | $f2d7
    .byte %00100000 ; |  X     | $f2d8
    .byte %00100000 ; |  X     | $f2d9
    .byte %00100000 ; |  X     | $f2da
    .byte %01100000 ; | XX     | $f2db
    .byte %01000000 ; | X      | $f2dc
    .byte %01000000 ; | X      | $f2dd
    .byte %01000000 ; | X      | $f2de
    .byte %01000000 ; | X      | $f2df
    .byte %01000000 ; | X      | $f2e0
    .byte %11000000 ; |XX      | $f2e1
    .byte %10000000 ; |X       | $f2e2
    .byte %10000000 ; |X       | $f2e3
    .byte %10000000 ; |X       | $f2e4
    .byte %10000000 ; |X       | $f2e5
    .byte %10000000 ; |X       | $f2e6
    .byte %10000000 ; |X       | $f2e7
    .byte %10000000 ; |X       | $f2e8
    .byte %10000000 ; |X       | $f2e9
    .byte %00000000 ; |        | $f2ea
    .byte %00000000 ; |        | $f2eb
    .byte %01101100 ; | XX XX  | $f2ec
    .byte %11111110 ; |XXXXXXX | $f2ed
    .byte %11111110 ; |XXXXXXX | $f2ee
    .byte %10111111 ; |X XXXXXX| $f2ef
    .byte %01111110 ; | XXXXXX | $f2f0
    .byte %00011000 ; |   XX   | $f2f1
    .byte %00111110 ; |  XXXXX | $f2f2
    .byte %00000110 ; |     XX | $f2f3
    .byte %00000000 ; |        | $f2f4
    .byte %00000000 ; |        | $f2f5
    .byte %01101100 ; | XX XX  | $f2f6
    .byte %11111110 ; |XXXXXXX | $f2f7
    .byte %11111110 ; |XXXXXXX | $f2f8
    .byte %10111111 ; |X XXXXXX| $f2f9
    .byte %01111110 ; | XXXXXX | $f2fa
    .byte %00110000 ; |  XX    | $f2fb
    .byte %11111000 ; |XXXXX   | $f2fc
    .byte %01000000 ; | X      | $f2fd
    .byte %00000001 ; |       X| $f2fe
    .byte %00000001 ; |       X| $f2ff

Lf300:
    lda    $90              ; 3
    cmp    $b8              ; 3
    bne    Lf313            ; 2
    lda    $b4              ; 3
    sta    $93              ; 3
Lf30a:
    ldx    #$00             ; 2
    inc    frameCntLo       ; 5
    dec    frameCntLo       ; 5
    jmp    Lf338            ; 3

Lf313:
    nop                     ; 2
    bne    Lf30a            ; 2
Lf316:
    dec    $92              ; 5
    lda    ($a2),y          ; 5
    sta    COLUP0           ; 3
    lda    ($a0),y          ; 5
    sta    GRP0             ; 3
Lf320:
    lda    COLUBGTbl,x      ; 4
    sta    COLUBK           ; 3
    ldy    $93              ; 3
    beq    Lf300            ; 2+1
    lda    ($b0),y          ; 5
    sta    GRP1             ; 3
    lda    ($b2),y          ; 5
    sta    COLUP1           ; 3
    dey                     ; 2
    lda    ($b0),y          ; 5
    tax                     ; 2
    dey                     ; 2
    sty    $93              ; 3
Lf338:
    lda    $90              ; 3
    beq    Lf380            ; 2
    cmp    #$09             ; 2
    beq    Lf39b            ; 2
    ldy    $92              ; 3
    beq    Lf386            ; 2
    dec    $92              ; 5
    lda    ($a2),y          ; 5
    sta    COLUP0           ; 3
    lda    ($a0),y          ; 5
Lf34c:
    sta    GRP0             ; 3
    ldy    $91              ; 3
Lf350:
    lda    Lf900,y          ; 4
    sta    COLUPF           ; 3
    lda    Lfb00,y          ; 4
    sta    PF0              ; 3
    lda    Lfc00,y          ; 4
    sta    PF1              ; 3
    stx    GRP1             ; 3
    lda    Lfd00,y          ; 4
    sta    PF2              ; 3
    dec    $91              ; 5
    dec    $90              ; 5
    tya                     ; 2
    tax                     ; 2
Lf36c:
    ldy    $92              ; 3
    bne    Lf316            ; 2
    nop                     ; 2
    lda    $90              ; 3
    cmp    $a7              ; 3
    bne    Lf383            ; 2
    lda    $a4              ; 3
    sta    $92              ; 3
Lf37b:
    lda    weird            ; 3
    jmp    Lf320            ; 3

Lf380:
    jmp    Lf4bb            ; 3

Lf383:
    nop                     ; 2
    bne    Lf37b            ; 2
Lf386:
    inc    frameCntLo       ; 5
    dec    frameCntLo       ; 5
    nop                     ; 2
    lda    #$00             ; 2
    jmp    Lf34c            ; 3

Lf390:
    inc    frameCntLo       ; 5
    dec    frameCntLo       ; 5
    nop                     ; 2
    nop                     ; 2
    lda    weird            ; 3
    jmp    Lf3a9            ; 3

Lf39b:
    ldy    $92              ; 3
    beq    Lf390            ; 2
    dec    $92              ; 5
    lda    ($a2),y          ; 5
    sta    COLUP0           ; 3
    lda    ($a0),y          ; 5
    sta    GRP0             ; 3
Lf3a9:
    lda    $b9              ; 3
    beq    Lf3b0            ; 2
    jmp    Lf44d            ; 3

Lf3b0:
    lda    #$00             ; 2
    sta    REFP1            ; 3
    sta    $93              ; 3
    lda    $c4              ; 3
    sta    $b4              ; 3
    lda    $c0              ; 3
    sta    $b0              ; 3
    lda    $c1              ; 3
    sta    $b1              ; 3
    lda    $c2              ; 3
    sta    $b2              ; 3
    lda    $c5              ; 3
    sta    NUSIZ1           ; 3
    dec    $90              ; 5
    ldy    $92              ; 3
    beq    Lf40a            ; 2+1
    dec    $92              ; 5
    lda    ($a2),y          ; 5
    sta    COLUP0           ; 3
    lda    ($a0),y          ; 5
    sta    GRP0             ; 3
Lf3da:
    ldx    $c6              ; 3
    lda    HMTbl,x          ; 4
    sta    HMP1             ; 3
    and    #$0f             ; 2
    tay                     ; 2
Lf3e4:
    dey                     ; 2
    bne    Lf3e4            ; 2
    sta    RESP1            ; 3
    sta    WSYNC            ; 3
    sta    HMOVE            ; 3
    ldy    $92              ; 3
    beq    Lf41b            ; 2+1
    lda    ($a0),y          ; 5
    sta    GRP0             ; 3
    lda    ($a2),y          ; 5
    sta    COLUP0           ; 3
    dec    $92              ; 5
Lf3fb:
    nop                     ; 2
    lda    weird            ; 3
    ldx    $94              ; 3
    stx    $91              ; 3
    lda    $c7              ; 3
    sta    $b8              ; 3
    nop                     ; 2
    jmp    Lf36c            ; 3

Lf40a:
    lda    $90              ; 3
    cmp    $a7              ; 3
    bne    Lf418            ; 2
    lda    $a4              ; 3
    sta    $92              ; 3
Lf414:
    nop                     ; 2
    jmp    Lf3da            ; 3

Lf418:
    nop                     ; 2
    bne    Lf414            ; 2
Lf41b:
    inc    frameCntLo       ; 5
    dec    frameCntLo       ; 5
    nop                     ; 2
    nop                     ; 2
    nop                     ; 2
    jmp    Lf3fb            ; 3

Lf425:
    lda    $90              ; 3
    cmp    $a7              ; 3
    bne    Lf434            ; 2
    lda    $a4              ; 3
    sta    $92              ; 3
Lf42f:
    lda    weird            ; 3
    jmp    Lf470            ; 3

Lf434:
    nop                     ; 2
    bne    Lf42f            ; 2
Lf437:
    nop                     ; 2
    bne    Lf444            ; 2
Lf43a:
    lda    $90              ; 3
    cmp    $b8              ; 3
    bne    Lf437            ; 2
    lda    $b4              ; 3
    sta    $93              ; 3
Lf444:
    ldx    #$00             ; 2
    inc    frameCntLo       ; 5
    dec    frameCntLo       ; 5
    jmp    Lf483            ; 3

Lf44d:
    inc    frameCntLo       ; 5
    dec    frameCntLo       ; 5
    stx    GRP1             ; 3
    nop                     ; 2
    lda    weird            ; 3
    dec    $90              ; 5
    inc    frameCntLo       ; 5
    dec    frameCntLo       ; 5
    lda    #$00             ; 2
    sta.w  COLUBK           ; 4
    nop                     ; 2
    ldy    $92              ; 3
    beq    Lf425            ; 2
    dec    $92              ; 5
    lda    ($a2),y          ; 5
    sta    COLUP0           ; 3
    lda    ($a0),y          ; 5
    sta    GRP0             ; 3
Lf470:
    ldy    $93              ; 3
    beq    Lf43a            ; 2
    lda    ($b0),y          ; 5
    sta    GRP1             ; 3
    lda    ($b2),y          ; 5
    sta    COLUP1           ; 3
    dey                     ; 2
    lda    ($b0),y          ; 5
    tax                     ; 2
    dey                     ; 2
    sty    $93              ; 3
Lf483:
    nop                     ; 2
    lda    weird            ; 3
    inc    frameCntLo       ; 5
    dec    frameCntLo       ; 5
    ldy    $92              ; 3
    beq    Lf4b0            ; 2
    dec    $92              ; 5
    lda    ($a2),y          ; 5
    sta    COLUP0           ; 3
    lda    ($a0),y          ; 5
    sta    GRP0             ; 3
Lf498:
    stx    GRP1             ; 3
    inc    frameCntLo       ; 5
    dec    frameCntLo       ; 5
    inc    frameCntLo       ; 5
    dec    frameCntLo       ; 5
    inc    frameCntLo       ; 5
    dec    frameCntLo       ; 5
    nop                     ; 2
    nop                     ; 2
    nop                     ; 2
    ldx    $94              ; 3
    stx    $91              ; 3
    jmp    Lf36c            ; 3

Lf4b0:
    inc    frameCntLo       ; 5
    dec    frameCntLo       ; 5
    nop                     ; 2
    nop                     ; 2
    lda    weird            ; 3
    jmp    Lf498            ; 3

Lf4bb:
    ldy    $91              ; 3
    stx    $e9              ; 3
    ldx    #$02             ; 2
    lda    #$00             ; 2
    sta    COLUP0           ; 3
    lda    $f4              ; 3
Lf4c7:
    sta    WSYNC            ; 3
    sta    GRP0             ; 3
    lda    $e9              ; 3
    sta    GRP1             ; 3
    lda    Lf900,y          ; 4
    sta    COLUPF           ; 3
    lda    Lfb00,y          ; 4
    sta    PF0              ; 3
    lda    Lfc00,y          ; 4
    sta    PF1              ; 3
    lda    Lfd00,y          ; 4
    sta    PF2              ; 3
    dec    $91              ; 5
    dex                     ; 2
    bmi    Lf505            ; 2+1
    ldy    $93              ; 3
    beq    Lf4f2            ; 2
    lda    ($b0),y          ; 5
    sta    $e9              ; 3
    dec    $93              ; 5
Lf4f2:
    lda    #$00             ; 2
    sta    WSYNC            ; 3
    sta    GRP0             ; 3
    sta    $93              ; 3
    ldy    $e9              ; 3
    sty    GRP1             ; 3
    sta    $e9              ; 3
    ldy    $91              ; 3
    jmp    Lf4c7            ; 3

Lf505:
    ldx    #$05             ; 2
Lf507:
    lda    #$d2             ; 2
    sta    WSYNC            ; 3
    sta    COLUPF           ; 3
    lda    Lfbf2,x          ; 4
    sta    PF0              ; 3
    lda    Lfcf2,x          ; 4
    sta    PF1              ; 3
    lda    Lfdf2,x          ; 4
    sta    PF2              ; 3
    sta    WSYNC            ; 3
    dex                     ; 2
    bne    Lf507            ; 2
    stx    COLUPF           ; 3
    stx    COLUBK           ; 3
    stx    REFP0            ; 3
    sta    WSYNC            ; 3
    lda    player           ; 3
    and    #$01             ; 2
    tax                     ; 2
    ldy    livesLst,x       ; 4
    lda    Lf568,y          ; 4
    sta    NUSIZ0           ; 3
    lda    Lf567,y          ; 4
    sta    NUSIZ1           ; 3
    lda    #$10             ; 2
    sta    HMP0             ; 3
    asl                     ; 2
    sta.w  HMP1             ; 4
    sta    RESP0            ; 3
    sta    RESP1            ; 3
    ldx    #$08             ; 2
    sta    WSYNC            ; 3
    sta    HMOVE            ; 3
Lf54c:
    sta    WSYNC            ; 3
    lda    Lfe0d,x          ; 4
    and    Lf571,y          ; 4
    sta    GRP0             ; 3
    and    Lf570,y          ; 4
    sta    GRP1             ; 3
    lda    Lff0d,x          ; 4
    sta    COLUP0           ; 3
    sta    COLUP1           ; 3
    dex                     ; 2
    bpl    Lf54c            ; 2
    bmi    DrawScene        ; 3

Lf567:
    .byte $00
Lf568:
    .byte %00000000 ; $00 ; |        | $f568
    .byte %00000000 ; $00 ; |        | $f569
    .byte %00000000 ; $00 ; |        | $f56a
    .byte %00000000 ; $00 ; |        | $f56b
    .byte %00000001 ; $01 ; |       X| $f56c
    .byte %00000001 ; $01 ; |       X| $f56d
    .byte %00000011 ; $03 ; |      XX| $f56e
    .byte %00000011 ; $03 ; |      XX| $f56f
Lf570:
    .byte %00000000 ; $00 ; |        | $f570
Lf571:
    .byte %00000000 ; $00 ; |        | $f571
    .byte %00000000 ; $00 ; |        | $f572
    .byte %11111111 ; $ff ; |XXXXXXXX| $f573
    .byte %11111111 ; $ff ; |XXXXXXXX| $f574
    .byte %11111111 ; $ff ; |XXXXXXXX| $f575
    .byte %11111111 ; $ff ; |XXXXXXXX| $f576
    .byte %11111111 ; $ff ; |XXXXXXXX| $f577
    .byte %11111111 ; $ff ; |XXXXXXXX| $f578

Lf579:      ; $f579
    .word SceneGfx0
    .word SceneGfx1
    .word SceneGfx2
    .word SceneGfx3
    .word Zero
    .word Zero

DrawScene SUBROUTINE
    lda    #$00             ; 2
    sta    WSYNC            ; 3
    sta    GRP0             ; 3
    sta    GRP1             ; 3
    sta    GRP0             ; 3
    sta    GRP1             ; 3
    ldx    #$0b             ; 2
Lf593:
    lda    Lf579,x          ; 4
    sta    $f2,x            ; 4
    dex                     ; 2
    bpl    Lf593            ; 2
    lda    scene            ; 3
    lsr                     ; 2
    and    #$78             ; 2
    sta    $fa              ; 3
    lda    scene            ; 3
    asl                     ; 2
    asl                     ; 2
    asl                     ; 2
    and    #$78             ; 2
    sta    $fc              ; 3
    jsr    Lf61c            ; 6
Lf5ae:
    lda    INTIM            ; 4
    sta    weird            ; 3
    sta    WSYNC            ; 3
    ldy    #$9c             ; 2
    sty    TIM64T           ; 4
    lda    $8b              ; 3
    bpl    Lf5ce            ; 2
    and    #$20             ; 2
    bne    Lf5ce            ; 2
    lda    frameCntLo       ; 3
    and    #$ff             ; 2
    bne    Lf5ce            ; 2
    lda    time             ; 3
    beq    Lf5ce            ; 2
    dec    time             ; 5
Lf5ce:
    ldx    screen           ; 3
    lda    Lfb00,x          ; 4
    and    #$0f             ; 2
    tay                     ; 2     Y = 0..2
    sty    $ec              ; 3
    lda    Lf60f,y          ; 4
    sta    $91              ; 3
    lda    Lfb20,x          ; 4
    and    #$0f             ; 2
    tay                     ; 2     Y = 0..6
    lda    Lf612,y          ; 4
    sta    $94              ; 3
    sty    $f8              ; 3
    lda    Lfb60,x          ; 4
    and    #$0f             ; 2
    sta    $ed              ; 3
    lda    Lfb40,x          ; 4
    and    #$0f             ; 2
    sta    $ef              ; 3
    lda    Lfb80,x          ; 4
    asl                     ; 2
    asl                     ; 2
    asl                     ; 2
    asl                     ; 2
    and    #$f0             ; 2
    sta    $eb              ; 3
    lda    Lfba0,x          ; 4
    and    #$0f             ; 2
    ora    $eb              ; 3
    sta    $ee              ; 3
    jmp    Lf619            ; 3

Lf60f:
    .byte $34 ; $f60f
    .byte $69
    .byte $9e
Lf612:
    .byte $aa ; $f612
    .byte $b6
    .byte $c2
    .byte $ce
    .byte $da
    .byte $e6
    .byte $f2

Lf619:
    jmp    Lf006            ; 3

Lf61c:
    sta    WSYNC            ; 3
    ldx    #$00             ; 2
    stx    COLUBK           ; 3
    lda    #$03             ; 2
    sta    WSYNC            ; 3
    sta    NUSIZ0           ; 3
    sta    NUSIZ1           ; 3
    sta    VDELP0           ; 3
    sta    VDELP1           ; 3
    lda    #$10             ; 2
    sta    HMP0             ; 3
    asl                     ; 2
    sta    HMP1             ; 3
    nop                     ; 2
    nop                     ; 2
    nop                     ; 2
    nop                     ; 2
    nop                     ; 2
    nop                     ; 2
    nop                     ; 2
    sta    RESP0            ; 3
    sta    RESP1            ; 3
    sta    WSYNC            ; 3
    sta    HMOVE            ; 3
    lda    #$07             ; 2
    sta    $ea              ; 3
Lf648:
    ldy    $ea              ; 3
    lda    ($f2),y          ; 5
    sta    GRP0             ; 3
    sta    WSYNC            ; 3
    lda    ($f4),y          ; 5
    sta    GRP1             ; 3
    lda    ($f6),y          ; 5
    sta    GRP0             ; 3
    lda    ($f8),y          ; 5
    sta    $eb              ; 3
    lda    ($fa),y          ; 5
    tax                     ; 2
    lda    ($fc),y          ; 5
    tay                     ; 2
    lda    $eb              ; 3
    sta    GRP1             ; 3
    stx    GRP0             ; 3
    sty    GRP1             ; 3
    sty    GRP0             ; 3
    dec    $ea              ; 5
    bpl    Lf648            ; 2
    lda    #$00             ; 2
    sta    GRP0             ; 3
    sta    GRP1             ; 3
    sta    HMCLR            ; 3
    sta    VDELP0           ; 3
    sta    VDELP1           ; 3
    rts                     ; 6

Lf67d:
    sta    $ea              ; 3
    lda    #$f7             ; 2
    sta    $eb              ; 3
    stx    $e9              ; 3
    ldy    #$05             ; 2
    ldx    #$0b             ; 2
Lf689:
    lda    $e9              ; 3
    sta    $f2,x            ; 4
    dex                     ; 2
    lda    ($ea),y          ; 5
    sta    $f2,x            ; 4
    dex                     ; 2
    dey                     ; 2
    bpl    Lf689            ; 2
    rts                     ; 6

WaitLines SUBROUTINE
    sta    WSYNC            ; 3
    dex                     ; 2
    bne    WaitLines        ; 2
    rts                     ; 6

DrawTitle SUBROUTINE
    ldy    #$06             ; 2
    sty    $e8              ; 3
Lf6a1:
    ldy    $e8              ; 3
    lda    Lf6cc,y          ; 4
    sta    COLUP0           ; 3
    sta    COLUP1           ; 3
    ldx    Lf6d3,y          ; 4
    jsr    WaitLines        ; 6
    lda    Lf7f1,y          ; 4
    ldx    Lf7f8,y          ; 4
    jsr    Lf67d            ; 6
    jsr    Lf61c            ; 6
    dec    $e8              ; 5
    bpl    Lf6a1            ; 2
    ldx    #40              ; 2
    bne    Lf6c6            ; 3

BlankScreen:
    ldx    #192             ; 2
Lf6c6:
    jsr    WaitLines        ; 6
    jmp    Lf5ae            ; 3

Lf6cc:
    .byte $74 ; $f6cc
    .byte $74
    .byte $34
    .byte $34
    .byte $34
    .byte $d6
    .byte $d6
Lf6d3:
    .byte %00000001 ; |       X| $f6d3
    .byte %00001010 ; |    X X | $f6d4
    .byte %00000001 ; |       X| $f6d5
    .byte %00000001 ; |       X| $f6d6
    .byte %00001010 ; |    X X | $f6d7
    .byte %00000001 ; |       X| $f6d8
    .byte %00010010 ; |   X  X | $f6d9
    .byte %00000000 ; |        | $f6da
    .byte %00000000 ; |        | $f6db
    .byte %11010110 ; |XX X XX | $f6dc
    .byte %01111100 ; | XXXXX  | $f6dd
    .byte %00101000 ; |  X X   | $f6de
    .byte %00111000 ; |  XXX   | $f6df
    .byte %01010100 ; | X X X  | $f6e0
    .byte %01001100 ; | X  XX  | $f6e1
    .byte %00101010 ; |  X X X | $f6e2
    .byte %00000000 ; |        | $f6e3
    .byte %00000000 ; |        | $f6e4
    .byte %00000000 ; |        | $f6e5
    .byte %00111000 ; |  XXX   | $f6e6
    .byte %01111100 ; | XXXXX  | $f6e7
    .byte %01111100 ; | XXXXX  | $f6e8
    .byte %01110100 ; | XXX X  | $f6e9
    .byte %01101100 ; | XX XX  | $f6ea
    .byte %00111000 ; |  XXX   | $f6eb
    .byte %00000000 ; |        | $f6ec
    .byte %00000000 ; |        | $f6ed
    .byte %00000000 ; |        | $f6ee
    .byte %00111000 ; |  XXX   | $f6ef
    .byte %01111100 ; | XXXXX  | $f6f0
    .byte %01101100 ; | XX XX  | $f6f1
    .byte %01011100 ; | X XXX  | $f6f2
    .byte %01111100 ; | XXXXX  | $f6f3
    .byte %00111000 ; |  XXX   | $f6f4
    .byte %00000000 ; |        | $f6f5
    .byte %00000000 ; |        | $f6f6
    .byte %00000000 ; |        | $f6f7
    .byte %00111000 ; |  XXX   | $f6f8
    .byte %01101100 ; | XX XX  | $f6f9
    .byte %01110100 ; | XXX X  | $f6fa
    .byte %01111100 ; | XXXXX  | $f6fb
    .byte %01111100 ; | XXXXX  | $f6fc
    .byte %00111000 ; |  XXX   | $f6fd
    .byte %00000000 ; |        | $f6fe
    .byte %00000001 ; |       X| $f6ff

    .byte %00000001 ; $01 ; |       X| $f700
    .byte %00001001 ; $09 ; |    X  X| $f701
    .byte %00010001 ; $11 ; |   X   X| $f702
    .byte %00011001 ; $19 ; |   XX  X| $f703
    .byte %00100001 ; $21 ; |  X    X| $f704
    .byte %00101001 ; $29 ; |  X X  X| $f705
    .byte %01011010 ; $5a ; | X XX X | $f706
    .byte %01100010 ; $62 ; | XX   X | $f707
    .byte %01101010 ; $6a ; | XX X X | $f708
    .byte %01110010 ; $72 ; | XXX  X | $f709
    .byte %01111010 ; $7a ; | XXXX X | $f70a
    .byte %10000010 ; $82 ; |X     X | $f70b
    .byte %10001010 ; $8a ; |X   X X | $f70c
    .byte %10010010 ; $92 ; |X  X  X | $f70d
    .byte %10011001 ; $99 ; |X  XX  X| $f70e
    .byte %10100000 ; $a0 ; |X X     | $f70f
    .byte %10100111 ; $a7 ; |X X  XXX| $f710
    .byte %10101110 ; $ae ; |X X XXX | $f711
    .byte %10001010 ; $8a ; |X   X X | $f712
    .byte %10010010 ; $92 ; |X  X  X | $f713
    .byte %10110101 ; $b5 ; |X XX X X| $f714
    .byte %10111100 ; $bc ; |X XXXX  | $f715
    .byte %11000011 ; $c3 ; |XX    XX| $f716
    .byte %11001010 ; $ca ; |XX  X X | $f717
    .byte %00101010 ; $2a ; |  X X X | $f718
    .byte %00110010 ; $32 ; |  XX  X | $f719
    .byte %00111010 ; $3a ; |  XXX X | $f71a
    .byte %01000010 ; $42 ; | X    X | $f71b
    .byte %01001010 ; $4a ; | X  X X | $f71c
    .byte %01010010 ; $52 ; | X X  X | $f71d
    .byte %00110001 ; $31 ; |  XX   X| $f71e
    .byte %00111001 ; $39 ; |  XXX  X| $f71f
    .byte %01000001 ; $41 ; | X     X| $f720
    .byte %01001001 ; $49 ; | X  X  X| $f721
    .byte %01010001 ; $51 ; | X X   X| $f722
    .byte %00110001 ; $31 ; |  XX   X| $f723
    .byte %00110001 ; $31 ; |  XX   X| $f724
    .byte %00110001 ; $31 ; |  XX   X| $f725
    .byte %01011001 ; $59 ; | X XX  X| $f726
    .byte %01100001 ; $61 ; | XX    X| $f727
    .byte %01101001 ; $69 ; | XX X  X| $f728
    .byte %00110001 ; $31 ; |  XX   X| $f729

    .byte %00000000 ; |        | $f72a  ADVENTURES
    .byte %00010101 ; |   X X X| $f72b
    .byte %00010101 ; |   X X X| $f72c
    .byte %00010101 ; |   X X X| $f72d
    .byte %00011101 ; |   XXX X| $f72e
    .byte %00010101 ; |   X X X| $f72f
    .byte %00010101 ; |   X X X| $f730
    .byte %00011101 ; |   XXX X| $f731
    .byte %00000000 ; |        | $f732
    .byte %10000100 ; |X    X  | $f733
    .byte %01001010 ; | X  X X | $f734
    .byte %01001010 ; | X  X X | $f735
    .byte %01010001 ; | X X   X| $f736
    .byte %01010001 ; | X X   X| $f737
    .byte %01010001 ; | X X   X| $f738
    .byte %10010001 ; |X  X   X| $f739
    .byte %00000000 ; |        | $f73a
    .byte %01110100 ; | XXX X  | $f73b
    .byte %01000100 ; | X   X  | $f73c
    .byte %01000101 ; | X   X X| $f73d
    .byte %01100101 ; | XX  X X| $f73e
    .byte %01000110 ; | X   XX | $f73f
    .byte %01000110 ; | X   XX | $f740
    .byte %01110100 ; | XXX X  | $f741
    .byte %00000000 ; |        | $f742
    .byte %10010011 ; |X  X  XX| $f743
    .byte %10010010 ; |X  X  X | $f744
    .byte %10010010 ; |X  X  X | $f745
    .byte %10010010 ; |X  X  X | $f746
    .byte %10010010 ; |X  X  X | $f747
    .byte %10010010 ; |X  X  X | $f748
    .byte %10111010 ; |X XXX X | $f749
    .byte %00000000 ; |        | $f74a
    .byte %10100101 ; |X X  X X| $f74b
    .byte %10101001 ; |X X X  X| $f74c
    .byte %10101001 ; |X X X  X| $f74d
    .byte %10111001 ; |X XXX  X| $f74e
    .byte %10100101 ; |X X  X X| $f74f
    .byte %10100101 ; |X X  X X| $f750
    .byte %10111001 ; |X XXX  X| $f751
    .byte %00000000 ; |        | $f752
    .byte %11011100 ; |XX XXX  | $f753
    .byte %00000100 ; |     X  | $f754
    .byte %00000100 ; |     X  | $f755
    .byte %10011100 ; |X  XXX  | $f756
    .byte %00010000 ; |   X    | $f757
    .byte %00010000 ; |   X    | $f758
    .byte %11011100 ; |XX XXX  | $f759

    .byte %00000000 ; |        | $f75a  PATCH
    .byte %10000100 ; |X    X  | $f75b
    .byte %10000100 ; |X    X  | $f75c
    .byte %10000100 ; |X    X  | $f75d
    .byte %11110111 ; |XXXX XXX| $f75e
    .byte %10010100 ; |X  X X  | $f75f
    .byte %10010100 ; |X  X X  | $f760
    .byte %11110111 ; |XXXX XXX| $f761
    .byte %00000000 ; |        | $f762
    .byte %10010011 ; |X  X  XX| $f763
    .byte %10010010 ; |X  X  X | $f764
    .byte %10010010 ; |X  X  X | $f765
    .byte %10010010 ; |X  X  X | $f766
    .byte %10010010 ; |X  X  X | $f767
    .byte %10010010 ; |X  X  X | $f768
    .byte %10111011 ; |X XXX XX| $f769
    .byte %00000000 ; |        | $f76a
    .byte %11010010 ; |XX X  X | $f76b
    .byte %00010010 ; |   X  X | $f76c
    .byte %00010010 ; |   X  X | $f76d
    .byte %00011110 ; |   XXXX | $f76e
    .byte %00010010 ; |   X  X | $f76f
    .byte %00010010 ; |   X  X | $f770
    .byte %11010010 ; |XX X  X | $f771

    .byte %00000000 ; |        | $f772  KIDS
    .byte %00000010 ; |      X | $f773
    .byte %00000010 ; |      X | $f774
    .byte %00000010 ; |      X | $f775
    .byte %00000011 ; |      XX| $f776
    .byte %00000011 ; |      XX| $f777
    .byte %00000010 ; |      X | $f778
    .byte %00000010 ; |      X | $f779
    .byte %00000000 ; |        | $f77a
    .byte %01011101 ; | X XXX X| $f77b
    .byte %10001001 ; |X   X  X| $f77c
    .byte %10001001 ; |X   X  X| $f77d
    .byte %00001001 ; |    X  X| $f77e
    .byte %00001001 ; |    X  X| $f77f
    .byte %10001001 ; |X   X  X| $f780
    .byte %01011101 ; | X XXX X| $f781
    .byte %00000000 ; |        | $f782
    .byte %11001111 ; |XX  XXXX| $f783
    .byte %00100001 ; |  X    X| $f784
    .byte %00100001 ; |  X    X| $f785
    .byte %00101111 ; |  X XXXX| $f786
    .byte %00101000 ; |  X X   | $f787
    .byte %00101000 ; |  X X   | $f788
    .byte %11001111 ; |XX  XXXX| $f789

    .byte %00000000 ; |        | $f78a  (C) 1984
    .byte %01111000 ; | XXXX   | $f78b
    .byte %10000100 ; |X    X  | $f78c
    .byte %10110100 ; |X XX X  | $f78d
    .byte %10100100 ; |X X  X  | $f78e
    .byte %10110100 ; |X XX X  | $f78f
    .byte %10000100 ; |X    X  | $f790
    .byte %01111000 ; | XXXX   | $f791
    .byte %00000000 ; |        | $f792
    .byte %00000000 ; |        | $f793
    .byte %10001011 ; |X   X XX| $f794
    .byte %10001010 ; |X   X X | $f795
    .byte %10111011 ; |X XXX XX| $f796
    .byte %10101010 ; |X X X X | $f797
    .byte %10111011 ; |X XXX XX| $f798
    .byte %00000000 ; |        | $f799
    .byte %00000000 ; |        | $f79a
    .byte %10001000 ; |X   X   | $f79b
    .byte %10001000 ; |X   X   | $f79c
    .byte %10111000 ; |X XXX   | $f79d
    .byte %10101000 ; |X X X   | $f79e
    .byte %10101000 ; |X X X   | $f79f
    .byte %00000000 ; |        | $f7a0

    .byte %00000000 ; |        | $f7a1  KONAMI
    .byte %01010111 ; | X X XXX| $f7a2
    .byte %01010101 ; | X X X X| $f7a3
    .byte %01100101 ; | XX  X X| $f7a4
    .byte %01010101 ; | X X X X| $f7a5
    .byte %01000111 ; | X   XXX| $f7a6
    .byte %00000000 ; |        | $f7a7
    .byte %00000000 ; |        | $f7a8
    .byte %01011010 ; | X XX X | $f7a9
    .byte %01011010 ; | X XX X | $f7aa
    .byte %01101011 ; | XX X XX| $f7ab
    .byte %01101010 ; | XX X X | $f7ac
    .byte %01001011 ; | X  X XX| $f7ad
    .byte %00000000 ; |        | $f7ae
    .byte %00000000 ; |        | $f7af
    .byte %10100101 ; |X X  X X| $f7b0
    .byte %10100101 ; |X X  X X| $f7b1
    .byte %10100101 ; |X X  X X| $f7b2
    .byte %10111101 ; |X XXXX X| $f7b3
    .byte %10100101 ; |X X  X X| $f7b4
    .byte %00000000 ; |        | $f7b5
    .byte %00000000 ; |        | $f7b6
    .byte %10111001 ; |X XXX  X| $f7b7  3
    .byte %10001001 ; |X   X  X| $f7b8
    .byte %10011001 ; |X  XX  X| $f7b9
    .byte %10001001 ; |X   X  X| $f7ba
    .byte %10111001 ; |X XXX  X| $f7bb
    .byte %00000000 ; |        | $f7bc
    .byte %00000000 ; |        | $f7bd
    .byte %11010101 ; |XX X X X| $f7be
    .byte %01010101 ; | X X X X| $f7bf
    .byte %01011101 ; | X XXX X| $f7c0
    .byte %01010101 ; | X X X X| $f7c1
    .byte %11011101 ; |XX XXX X| $f7c2
    .byte %00000000 ; |        | $f7c3
    .byte %00000000 ; |        | $f7c4
    .byte %01001110 ; | X  XXX | $f7c5
    .byte %01000100 ; | X   X  | $f7c6
    .byte %11000100 ; |XX   X  | $f7c7
    .byte %01000100 ; | X   X  | $f7c8
    .byte %11001110 ; |XX  XXX | $f7c9
    .byte %00000000 ; |        | $f7ca
    .byte %00000000 ; |        | $f7cb
    .byte %10010111 ; |X  X XXX| $f7cc
    .byte %10110100 ; |X XX X  | $f7cd
    .byte %10110100 ; |X XX X  | $f7ce
    .byte %11010100 ; |XX X X  | $f7cf
    .byte %11010111 ; |XX X XXX| $f7d0

SceneGfx0:
    .byte %00000000 ; |        | $f7d1  SCENE
    .byte %11110001 ; |XXXX   X| $f7d2
    .byte %00001010 ; |    X X | $f7d3
    .byte %00001010 ; |    X X | $f7d4
    .byte %01110010 ; | XXX  X | $f7d5
    .byte %10000010 ; |X     X | $f7d6
    .byte %10000010 ; |X     X | $f7d7
    .byte %01111001 ; | XXXX  X| $f7d8
SceneGfx1:
    .byte %00000000 ; |        | $f7d9
    .byte %11101111 ; |XXX XXXX| $f7da
    .byte %00001000 ; |    X   | $f7db
    .byte %00001000 ; |    X   | $f7dc
    .byte %00001110 ; |    XXX | $f7dd
    .byte %00001000 ; |    X   | $f7de
    .byte %00001000 ; |    X   | $f7df
    .byte %11101111 ; |XXX XXXX| $f7e0
SceneGfx2:
    .byte %00000000 ; |        | $f7e1
    .byte %01000101 ; | X   X X| $f7e2
    .byte %01001101 ; | X  XX X| $f7e3
    .byte %01001101 ; | X  XX X| $f7e4
    .byte %01010101 ; | X X X X| $f7e5
    .byte %01100101 ; | XX  X X| $f7e6
    .byte %01100101 ; | XX  X X| $f7e7
    .byte %01000101 ; | X   X X| $f7e8
SceneGfx3:
    .byte %00000000 ; |        | $f7e9
    .byte %11100000 ; |XXX     | $f7ea
    .byte %00000000 ; |        | $f7eb
    .byte %00000000 ; |        | $f7ec
    .byte %11000000 ; |XX      | $f7ed
    .byte %00000000 ; |        | $f7ee
    .byte %00000000 ; |        | $f7ef
    .byte %11100000 ; |XXX     | $f7f0
Lf7f1:
    .byte %00001100 ; |    XX  | $f7f1
    .byte %00010010 ; |   X  X | $f7f2
    .byte %00100100 ; |  X  X  | $f7f3
    .byte %00011110 ; |   XXXX | $f7f4
    .byte %00011000 ; |   XX   | $f7f5
    .byte %00000110 ; |     XX | $f7f6
    .byte %00000000 ; |        | $f7f7
Lf7f8:
    .byte $f7 ; $f7f8
    .byte $f7
    .byte $f2
    .byte $f2
    .byte $f7
    .byte $f7
    .byte $f2

    .byte $01
Zero:
    .byte %00000000 ; |        | $f800
    .byte %00111100 ; |  XXXX  | $f801
    .byte %01100110 ; | XX  XX | $f802
    .byte %01100110 ; | XX  XX | $f803
    .byte %01100110 ; | XX  XX | $f804
    .byte %01100110 ; | XX  XX | $f805
    .byte %01100110 ; | XX  XX | $f806
    .byte %00111100 ; |  XXXX  | $f807
    .byte %00000000 ; |        | $f808
    .byte %01111110 ; | XXXXXX | $f809
    .byte %00011000 ; |   XX   | $f80a
    .byte %00011000 ; |   XX   | $f80b
    .byte %00011000 ; |   XX   | $f80c
    .byte %00111000 ; |  XXX   | $f80d
    .byte %00011000 ; |   XX   | $f80e
    .byte %00001000 ; |    X   | $f80f
    .byte %00000000 ; |        | $f810
    .byte %01111110 ; | XXXXXX | $f811
    .byte %01100010 ; | XX   X | $f812
    .byte %01100000 ; | XX     | $f813
    .byte %00111100 ; |  XXXX  | $f814
    .byte %00000110 ; |     XX | $f815
    .byte %01000110 ; | X   XX | $f816
    .byte %00111100 ; |  XXXX  | $f817
    .byte %00000000 ; |        | $f818
    .byte %00111100 ; |  XXXX  | $f819
    .byte %01000110 ; | X   XX | $f81a
    .byte %00000110 ; |     XX | $f81b
    .byte %00011100 ; |   XXX  | $f81c
    .byte %00000110 ; |     XX | $f81d
    .byte %01000110 ; | X   XX | $f81e
    .byte %00111100 ; |  XXXX  | $f81f
    .byte %00000000 ; |        | $f820
    .byte %00001100 ; |    XX  | $f821
    .byte %00001100 ; |    XX  | $f822
    .byte %01111110 ; | XXXXXX | $f823
    .byte %01001100 ; | X  XX  | $f824
    .byte %00101100 ; |  X XX  | $f825
    .byte %00011100 ; |   XXX  | $f826
    .byte %00001100 ; |    XX  | $f827
    .byte %00000000 ; |        | $f828
    .byte %00111100 ; |  XXXX  | $f829
    .byte %01000110 ; | X   XX | $f82a
    .byte %00000110 ; |     XX | $f82b
    .byte %01111100 ; | XXXXX  | $f82c
    .byte %01100000 ; | XX     | $f82d
    .byte %01100000 ; | XX     | $f82e
    .byte %01111110 ; | XXXXXX | $f82f
    .byte %00000000 ; |        | $f830
    .byte %00111100 ; |  XXXX  | $f831
    .byte %01100110 ; | XX  XX | $f832
    .byte %01100110 ; | XX  XX | $f833
    .byte %01111100 ; | XXXXX  | $f834
    .byte %01100000 ; | XX     | $f835
    .byte %01100010 ; | XX   X | $f836
    .byte %00111100 ; |  XXXX  | $f837
    .byte %00000000 ; |        | $f838
    .byte %00110000 ; |  XX    | $f839
    .byte %00110000 ; |  XX    | $f83a
    .byte %00011000 ; |   XX   | $f83b
    .byte %00001100 ; |    XX  | $f83c
    .byte %00000110 ; |     XX | $f83d
    .byte %01000010 ; | X    X | $f83e
    .byte %01111110 ; | XXXXXX | $f83f
    .byte %00000000 ; |        | $f840
    .byte %00111100 ; |  XXXX  | $f841
    .byte %01100110 ; | XX  XX | $f842
    .byte %01100110 ; | XX  XX | $f843
    .byte %00111100 ; |  XXXX  | $f844
    .byte %01100110 ; | XX  XX | $f845
    .byte %01100110 ; | XX  XX | $f846
    .byte %00111100 ; |  XXXX  | $f847
    .byte %00000000 ; |        | $f848
    .byte %00111100 ; |  XXXX  | $f849
    .byte %01000110 ; | X   XX | $f84a
    .byte %00000110 ; |     XX | $f84b
    .byte %00111110 ; |  XXXXX | $f84c
    .byte %01100110 ; | XX  XX | $f84d
    .byte %01100110 ; | XX  XX | $f84e
    .byte %00111100 ; |  XXXX  | $f84f
    .byte %00000000 ; |        | $f850
    .byte %00000000 ; $00 ; |        | $f851
    .byte %00000000 ; $00 ; |        | $f852
    .byte %00000000 ; $00 ; |        | $f853
    .byte %00000000 ; $00 ; |        | $f854
    .byte %00000000 ; $00 ; |        | $f855
    .byte %00000000 ; $00 ; |        | $f856
    .byte %00000000 ; $00 ; |        | $f857
    .byte %00000000 ; $00 ; |        | $f858
    .byte %00111000 ; $38 ; |  XXX   | $f859
    .byte %01111100 ; $7c ; | XXXXX  | $f85a
    .byte %01111100 ; $7c ; | XXXXX  | $f85b
    .byte %01101000 ; $68 ; | XX X   | $f85c
Lf85d:
    .byte %01111100 ; $7c ; | XXXXX  | $f85d
    .byte %01101100 ; $6c ; | XX XX  | $f85e
    .byte %01011000 ; $58 ; | X XX   | $f85f
HMTbl:
    .byte $61 ; $f860
    .byte $51
    .byte $41
    .byte $31
    .byte $21
    .byte $11
    .byte $01
    .byte $f1
    .byte $e1
    .byte $d1
    .byte $c1
    .byte $b1
    .byte $a1
    .byte $91
    .byte $72
    .byte $62
    .byte $52
    .byte $42
    .byte $32
    .byte $22
    .byte $12
    .byte $02
    .byte $f2
    .byte $e2
    .byte $d2
    .byte $c2
    .byte $b2
    .byte $a2
    .byte $92
    .byte $73
    .byte $63
    .byte $53
    .byte $43
    .byte $33
    .byte $23
    .byte $13
    .byte $03
    .byte $f3
    .byte $e3
    .byte $d3
    .byte $c3
    .byte $b3
    .byte $a3
    .byte $93
    .byte $74
    .byte $64
    .byte $54
    .byte $44
    .byte $34
    .byte $24
    .byte $14
    .byte $04
    .byte $f4
    .byte $e4
    .byte $d4
    .byte $c4
    .byte $b4
    .byte $a4
    .byte $94
    .byte $75
    .byte $65
    .byte $55
    .byte $45
    .byte $35
    .byte $25
    .byte $15
    .byte $05
    .byte $f5
    .byte $e5
    .byte $d5
    .byte $c5
    .byte $b5
    .byte $a5
    .byte $95
    .byte $76
    .byte $66
    .byte $56
    .byte $46
    .byte $36
    .byte $26
    .byte $16
    .byte $06
    .byte $f6
    .byte $e6
    .byte $d6
    .byte $c6
    .byte $b6
    .byte $a6
    .byte $96
    .byte $77
    .byte $67
    .byte $57
    .byte $47
    .byte $37
    .byte $27
    .byte $17
    .byte $07
    .byte $f7
    .byte $e7
    .byte $d7
    .byte $c7
    .byte $b7
    .byte $a7
    .byte $97
    .byte $78
    .byte $68
    .byte $58
    .byte $48
    .byte $38
    .byte $28
    .byte $18
    .byte $08
    .byte $f8
    .byte $e8
    .byte $d8
    .byte $c8
    .byte $b8
    .byte $a8
    .byte $98
    .byte $79
    .byte $69
    .byte $59
    .byte $49
    .byte $39
    .byte $29
    .byte $19
    .byte $09
    .byte $f9
    .byte $e9
    .byte $d9
    .byte $c9
    .byte $b9
    .byte $a9
    .byte $99
    .byte $7a
    .byte $6a
    .byte $5a
    .byte $4a
    .byte $3a
    .byte $2a
    .byte $1a
    .byte $0a
    .byte $fa
    .byte $ea
    .byte $da
    .byte $ca
    .byte $ba
    .byte $aa
    .byte $9a
    .byte $7b
    .byte $6b
    .byte $5b
    .byte $4b
    .byte $3b
    .byte $2b
    .byte $1b
    .byte $0b
    .byte $fb
    .byte $eb
    .byte $db
Lf900:
    .byte $24 ;  $f900
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $22
    .byte $22
    .byte $22
    .byte $22
    .byte $22
    .byte $22
    .byte $22
    .byte $22
    .byte $22
    .byte $22
    .byte $22
    .byte $22
    .byte $22
    .byte $22
    .byte $22
    .byte $22
    .byte $22
    .byte $22
    .byte $22
    .byte $22
    .byte $22
    .byte $22
    .byte $22
    .byte $22
    .byte $22
    .byte $c4
    .byte $c4
    .byte $c4
    .byte $c4
    .byte $c4
    .byte $c4
    .byte $c4
    .byte $c4
    .byte $c4
    .byte $c4
    .byte $c4
    .byte $c4
    .byte $c4
    .byte $c4
    .byte $c4
    .byte $c4
    .byte $c4
    .byte $c4
    .byte $c4
    .byte $c4
    .byte $c4
    .byte $c4
    .byte $c4

    .byte $34 ; $f935
    .byte $34
    .byte $34
    .byte $34
    .byte $36
    .byte $36
    .byte $36
    .byte $36
    .byte $36
    .byte $36
    .byte $36
    .byte $36
    .byte $36
    .byte $36
    .byte $36
    .byte $36
    .byte $36
    .byte $36
    .byte $36
    .byte $36
    .byte $36
    .byte $36
    .byte $36
    .byte $36
    .byte $36
    .byte $36
    .byte $36
    .byte $36
    .byte $36
    .byte $36
    .byte $36
    .byte $36
    .byte $36
    .byte $36
    .byte $36
    .byte $04
    .byte $04
    .byte $04
    .byte $04
    .byte $04
    .byte $04
    .byte $04
    .byte $04
    .byte $04
    .byte $04
    .byte $04
    .byte $04
    .byte $04
    .byte $04
    .byte $04
    .byte $04
    .byte $04
    .byte $04

    .byte $26 ; $f96a
    .byte $26
    .byte $26
    .byte $26
    .byte $26
    .byte $20
    .byte $20
    .byte $20
    .byte $20
    .byte $20
    .byte $20
    .byte $20
    .byte $20
    .byte $20
    .byte $20
    .byte $20
    .byte $d2
    .byte $d2
    .byte $d2
    .byte $70
    .byte $70
    .byte $70
    .byte $70
    .byte $70
    .byte $70
    .byte $70
    .byte $70
    .byte $70
    .byte $70
    .byte $70
    .byte $70
    .byte $70
    .byte $70
    .byte $70
    .byte $70
    .byte $70
    .byte $70
    .byte $70
    .byte $70
    .byte $70
    .byte $70
    .byte $70
    .byte $70
    .byte $70
    .byte $70
    .byte $70
    .byte $70
    .byte $70
    .byte $70
    .byte $70
    .byte $70
    .byte $70
    .byte $70

    .byte $7a ; | XXXX X | $f99f
    .byte $7a ; | XXXX X | $f9a0
    .byte $78 ; | XXXX   | $f9a1
    .byte $78 ; | XXXX   | $f9a2
    .byte $76 ; | XXX XX | $f9a3
    .byte $76 ; | XXX XX | $f9a4
    .byte $74 ; | XXX X  | $f9a5
    .byte $74 ; | XXX X  | $f9a6
    .byte $72 ; | XXX  X | $f9a7
    .byte $72 ; | XXX  X | $f9a8
    .byte $70 ; | XXX    | $f9a9
    .byte $70 ; | XXX    | $f9aa

    .byte $d2 ; |XX X  X | $f9ab
    .byte $d2 ; |XX X  X | $f9ac
    .byte $d2 ; |XX X  X | $f9ad
    .byte $d2 ; |XX X  X | $f9ae
    .byte $d2 ; |XX X  X | $f9af
    .byte $d2 ; |XX X  X | $f9b0
    .byte $d2 ; |XX X  X | $f9b1
    .byte $d2 ; |XX X  X | $f9b2
    .byte $d2 ; |XX X  X | $f9b3
    .byte $d2 ; |XX X  X | $f9b4
    .byte $d2 ; |XX X  X | $f9b5
    .byte $d2 ; |XX X  X | $f9b6

    .byte $00 ; |        | $f9b7
    .byte $00 ; |        | $f9b8
    .byte $d6 ; |XX X XX | $f9b9
    .byte $7c ; | XXXXX  | $f9ba
    .byte $28 ; |  X X   | $f9bb
    .byte $10 ; |   X    | $f9bc
    .byte $5a ; | X XX X | $f9bd
    .byte $28 ; |  X X   | $f9be
    .byte $24 ; |  X  X  | $f9bf
    .byte $00 ; |        | $f9c0
    .byte $34 ; |  XX X  | $f9c1
    .byte $34 ; |  XX X  | $f9c2

    .byte $a2 ; |X X   X | $f9c3
    .byte $a2 ; |X X   X | $f9c4
    .byte $a2 ; |X X   X | $f9c5
    .byte $a2 ; |X X   X | $f9c6
    .byte $a2 ; |X X   X | $f9c7
    .byte $a2 ; |X X   X | $f9c8
    .byte $a2 ; |X X   X | $f9c9
    .byte $a2 ; |X X   X | $f9ca
    .byte $a2 ; |X X   X | $f9cb
    .byte $a2 ; |X X   X | $f9cc
    .byte $a2 ; |X X   X | $f9cd
    .byte $a2 ; |X X   X | $f9ce

    .byte $52 ; | X X  X | $f9cf
    .byte $52 ; | X X  X | $f9d0
    .byte $52 ; | X X  X | $f9d1
    .byte $52 ; | X X  X | $f9d2
    .byte $52 ; | X X  X | $f9d3
    .byte $52 ; | X X  X | $f9d4
    .byte $52 ; | X X  X | $f9d5
    .byte $52 ; | X X  X | $f9d6
    .byte $24 ; |  X  X  | $f9d7
    .byte $08 ; |    X   | $f9d8
    .byte $08 ; |    X   | $f9d9
    .byte $08 ; |    X   | $f9da

    .byte %00000000 ; $00 ; |        | $f9db
    .byte %00000000 ; $00 ; |        | $f9dc
    .byte %01111000 ; $78 ; | XXXX   | $f9dd
    .byte %01110110 ; $76 ; | XXX XX | $f9de
    .byte %01110100 ; $74 ; | XXX X  | $f9df
    .byte %01110010 ; $72 ; | XXX  X | $f9e0
    .byte %00100100 ; $24 ; |  X  X  | $f9e1
    .byte %00100100 ; $24 ; |  X  X  | $f9e2
    .byte %00100100 ; $24 ; |  X  X  | $f9e3
    .byte %00000000 ; $00 ; |        | $f9e4
    .byte %00000000 ; $00 ; |        | $f9e5
    .byte %00000000 ; $00 ; |        | $f9e6

    .byte %00000000 ; $00 ; |        | $f9e7
    .byte %00000000 ; $00 ; |        | $f9e8
    .byte %01111000 ; $78 ; | XXXX   | $f9e9
    .byte %01110110 ; $76 ; | XXX XX | $f9ea
    .byte %01110100 ; $74 ; | XXX X  | $f9eb
    .byte %01110010 ; $72 ; | XXX  X | $f9ec
    .byte %00100100 ; $24 ; |  X  X  | $f9ed
    .byte %00100100 ; $24 ; |  X  X  | $f9ee
    .byte %00100100 ; $24 ; |  X  X  | $f9ef
    .byte %00000000 ; $00 ; |        | $f9f0
    .byte %00000000 ; $00 ; |        | $f9f1
    .byte %00000000 ; $00 ; |        | $f9f2

    .byte %00000000 ; $00 ; |        | $f9f3
    .byte %00000000 ; $00 ; |        | $f9f4
    .byte %00001000 ; $08 ; |    X   | $f9f5
    .byte %00001000 ; $08 ; |    X   | $f9f6
    .byte %00101010 ; $2a ; |  X X X | $f9f7
    .byte %00010100 ; $14 ; |   X X  | $f9f8
    .byte %00001000 ; $08 ; |    X   | $f9f9
    .byte %00010100 ; $14 ; |   X X  | $f9fa
    .byte %00101010 ; $2a ; |  X X X | $f9fb
    .byte %00001000 ; $08 ; |    X   | $f9fc
    .byte %00001000 ; $08 ; |    X   | $f9fd
    .byte %00000001 ; $01 ; |       X| $f9fe
    .byte %00000001 ; $01 ; |       X| $f9ff
COLUBGTbl:
    .byte $24 ; $fa00
    .byte $24
    .byte $d2
    .byte $d2
    .byte $d2
    .byte $d2
    .byte $d2
    .byte $82
    .byte $9c
    .byte $8c
    .byte $9c
    .byte $8c
    .byte $9c
    .byte $8c
    .byte $9c
    .byte $8c
    .byte $9c
    .byte $8c
    .byte $9c
    .byte $8c
    .byte $9a
    .byte $8a
    .byte $9a
    .byte $8a
    .byte $9a
    .byte $8a
    .byte $9a
    .byte $8a
    .byte $98
    .byte $88
    .byte $98
    .byte $88
    .byte $98
    .byte $88
    .byte $98
    .byte $98
    .byte $96
    .byte $86
    .byte $96
    .byte $86
    .byte $96
    .byte $86
    .byte $96
    .byte $84
    .byte $94
    .byte $84
    .byte $94
    .byte $84
    .byte $94
    .byte $94
    .byte $94
    .byte $84
    .byte $94
    .byte $d2
    .byte $d2
    .byte $d2
    .byte $d2
    .byte $d2
    .byte $82
    .byte $9c
    .byte $8c
    .byte $9c
    .byte $8c
    .byte $9c
    .byte $8c
    .byte $9c
    .byte $8c
    .byte $9c
    .byte $8c
    .byte $9c
    .byte $8c
    .byte $9a
    .byte $8a
    .byte $9a
    .byte $8a
    .byte $9a
    .byte $8a
    .byte $9a
    .byte $8a
    .byte $98
    .byte $88
    .byte $98
    .byte $88
    .byte $98
    .byte $88
    .byte $98
    .byte $88
    .byte $96
    .byte $86
    .byte $96
    .byte $86
    .byte $96
    .byte $96
    .byte $96
    .byte $84
    .byte $94
    .byte $84
    .byte $94
    .byte $84
    .byte $94
    .byte $84
    .byte $94
    .byte $84
    .byte $94
    .byte $84
    .byte $94
    .byte $24
    .byte $24
    .byte $d8
    .byte $d8
    .byte $d8
    .byte $d8
    .byte $d8
    .byte $d8
    .byte $d8
    .byte $d8
    .byte $d8
    .byte $d8
    .byte $d8
    .byte $d8
    .byte $d8
    .byte $d8
    .byte $d8
    .byte $d8
    .byte $d2
    .byte $d2
    .byte $d2
    .byte $d2
    .byte $d2
    .byte $d2
    .byte $d2
    .byte $d2
    .byte $d2
    .byte $d2
    .byte $78
    .byte $88
    .byte $78
    .byte $88
    .byte $78
    .byte $88
    .byte $76
    .byte $86
    .byte $76
    .byte $86
    .byte $76
    .byte $86
    .byte $76
    .byte $86
    .byte $76
    .byte $86
    .byte $76
    .byte $84
    .byte $74
    .byte $84
    .byte $74
    .byte $84
    .byte $74
    .byte $84
    .byte $94
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $d2
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $24
    .byte $24

    .byte %00000000 ; |        | $faf3
    .byte %00000000 ; |        | $faf4
    .byte %00000000 ; |        | $faf5
    .byte %00101010 ; |  X X X | $faf6
    .byte %00010100 ; |   X X  | $faf7
    .byte %00010100 ; |   X X  | $faf8
    .byte %01101011 ; | XX X XX| $faf9
    .byte %00010100 ; |   X X  | $fafa
    .byte %00010100 ; |   X X  | $fafb
    .byte %00101010 ; |  X X X | $fafc
    .byte %00000000 ; |        | $fafd
    .byte %00000001 ; |       X| $fafe
    .byte %00000001 ; |       X| $faff
Lfb00:
    .byte %00000001 ; |       X| $fb00
    .byte %11110000 ; |XXXX    | $fb01
    .byte %10010010 ; |X  X  X | $fb02
    .byte %11110000 ; |XXXX    | $fb03
    .byte %00000000 ; |        | $fb04
    .byte %00000000 ; |        | $fb05
    .byte %00000010 ; |      X | $fb06
    .byte %00000000 ; |        | $fb07
    .byte %00000000 ; |        | $fb08
    .byte %00000010 ; |      X | $fb09
    .byte %00000001 ; |       X| $fb0a
    .byte %00000000 ; |        | $fb0b
    .byte %00000000 ; |        | $fb0c
    .byte %00000000 ; |        | $fb0d
    .byte %00000010 ; |      X | $fb0e
    .byte %00000010 ; |      X | $fb0f
    .byte %00000000 ; |        | $fb10
    .byte %00000000 ; |        | $fb11
    .byte %00000010 ; |      X | $fb12
    .byte %00000010 ; |      X | $fb13
    .byte %00000001 ; |       X| $fb14
    .byte %00000000 ; |        | $fb15
    .byte %00000000 ; |        | $fb16
    .byte %00000000 ; |        | $fb17
    .byte %00000010 ; |      X | $fb18
    .byte %00000010 ; |      X | $fb19
    .byte %00000000 ; |        | $fb1a
    .byte %00000000 ; |        | $fb1b
    .byte %00000010 ; |      X | $fb1c
    .byte %00000000 ; |        | $fb1d
    .byte %01010001 ; | X X   X| $fb1e
    .byte %01010010 ; | X X  X | $fb1f
Lfb20:
    .byte %01110001 ; | XXX   X| $fb20
    .byte %01110010 ; | XXX  X | $fb21
    .byte %10110101 ; |X XX X X| $fb22
    .byte %10110100 ; |X XX X  | $fb23
    .byte %11110110 ; |XXXX XX | $fb24
    .byte %11110000 ; |XXXX    | $fb25
    .byte %11110010 ; |XXXX  X | $fb26
    .byte %11110011 ; |XXXX  XX| $fb27
    .byte %11110010 ; |XXXX  X | $fb28
    .byte %11110010 ; |XXXX  X | $fb29
    .byte %11110001 ; |XXXX   X| $fb2a
    .byte %01010010 ; | X X  X | $fb2b
    .byte %01010000 ; | X X    | $fb2c
    .byte %00110010 ; |  XX  X | $fb2d
    .byte %00110000 ; |  XX    | $fb2e
    .byte %00000000 ; |        | $fb2f
    .byte %00000101 ; |     X X| $fb30
    .byte %00000100 ; |     X  | $fb31
    .byte %00000000 ; |        | $fb32
    .byte %00000000 ; |        | $fb33
    .byte %00000001 ; |       X| $fb34
    .byte %00000000 ; |        | $fb35
    .byte %00000011 ; |      XX| $fb36
    .byte %00000101 ; |     X X| $fb37
    .byte %11110011 ; |XXXX  XX| $fb38
    .byte %00000011 ; |      XX| $fb39
    .byte %11110100 ; |XXXX X  | $fb3a
    .byte %00000011 ; |      XX| $fb3b
    .byte %11110110 ; |XXXX XX | $fb3c
    .byte %00000000 ; |        | $fb3d
    .byte %00000001 ; |       X| $fb3e
    .byte %00000011 ; |      XX| $fb3f
Lfb40:
    .byte %00000100 ; |     X  | $fb40
    .byte %00000000 ; |        | $fb41
    .byte %00000000 ; |        | $fb42
    .byte %00000000 ; |        | $fb43
    .byte %00000000 ; |        | $fb44
    .byte %00000000 ; |        | $fb45
    .byte %00000000 ; |        | $fb46
    .byte %00000000 ; |        | $fb47
    .byte %00000000 ; |        | $fb48
    .byte %00000010 ; |      X | $fb49
    .byte %00000100 ; |     X  | $fb4a
    .byte %00000000 ; |        | $fb4b
    .byte %00000000 ; |        | $fb4c
    .byte %00000001 ; |       X| $fb4d
    .byte %00000000 ; |        | $fb4e
    .byte %00000000 ; |        | $fb4f
    .byte %00001000 ; |    X   | $fb50
    .byte %00000000 ; |        | $fb51
    .byte %00000000 ; |        | $fb52
    .byte %00000000 ; |        | $fb53
    .byte %00000100 ; |     X  | $fb54
    .byte %00000000 ; |        | $fb55
    .byte %00000000 ; |        | $fb56
    .byte %00000000 ; |        | $fb57
    .byte %00000000 ; |        | $fb58
    .byte %00000001 ; |       X| $fb59
    .byte %00000000 ; |        | $fb5a
    .byte %00000000 ; |        | $fb5b
    .byte %00000000 ; |        | $fb5c
    .byte %00000000 ; |        | $fb5d
    .byte %00000100 ; |     X  | $fb5e
    .byte %00000000 ; |        | $fb5f
Lfb60:
    .byte %00000000 ; |        | $fb60
    .byte %00000000 ; |        | $fb61
    .byte %00000000 ; |        | $fb62
    .byte %00000000 ; |        | $fb63
    .byte %00000000 ; |        | $fb64
    .byte %00000001 ; |       X| $fb65
    .byte %00000000 ; |        | $fb66
    .byte %00000000 ; |        | $fb67
    .byte %00001000 ; |    X   | $fb68
    .byte %00000000 ; |        | $fb69
    .byte %00000000 ; |        | $fb6a
    .byte %11110100 ; |XXXX X  | $fb6b
    .byte %10010000 ; |X  X    | $fb6c
    .byte %11110000 ; |XXXX    | $fb6d
    .byte %00000000 ; |        | $fb6e
    .byte %00000000 ; |        | $fb6f
    .byte %00000000 ; |        | $fb70
    .byte %11110100 ; |XXXX X  | $fb71
    .byte %00000100 ; |     X  | $fb72
    .byte %11110100 ; |XXXX X  | $fb73
    .byte %00000000 ; |        | $fb74
    .byte %11110001 ; |XXXX   X| $fb75
    .byte %00000100 ; |     X  | $fb76
    .byte %00000100 ; |     X  | $fb77
    .byte %00001000 ; |    X   | $fb78
    .byte %00000000 ; |        | $fb79
    .byte %11110010 ; |XXXX  X | $fb7a
    .byte %11110010 ; |XXXX  X | $fb7b
    .byte %11111010 ; |XXXXX X | $fb7c
    .byte %00110010 ; |  XX  X | $fb7d
    .byte %11110000 ; |XXXX    | $fb7e
    .byte %11110000 ; |XXXX    | $fb7f
Lfb80:
    .byte %11110000 ; |XXXX    | $fb80
    .byte %11110010 ; |XXXX  X | $fb81
    .byte %11110000 ; |XXXX    | $fb82
    .byte %11110000 ; |XXXX    | $fb83
    .byte %11110000 ; |XXXX    | $fb84
    .byte %11110000 ; |XXXX    | $fb85
    .byte %11110010 ; |XXXX  X | $fb86
    .byte %11110000 ; |XXXX    | $fb87
    .byte %11110000 ; |XXXX    | $fb88
    .byte %11110000 ; |XXXX    | $fb89
    .byte %11110000 ; |XXXX    | $fb8a
    .byte %11110000 ; |XXXX    | $fb8b
    .byte %11110000 ; |XXXX    | $fb8c
    .byte %11100000 ; |XXX     | $fb8d
    .byte %01000001 ; | X     X| $fb8e
    .byte %00000000 ; |        | $fb8f
    .byte %00000000 ; |        | $fb90
    .byte %00000000 ; |        | $fb91
    .byte %00000001 ; |       X| $fb92
    .byte %00000000 ; |        | $fb93
    .byte %00000000 ; |        | $fb94
    .byte %00000000 ; |        | $fb95
    .byte %00000000 ; |        | $fb96
    .byte %00000000 ; |        | $fb97
    .byte %00000000 ; |        | $fb98
    .byte %00000000 ; |        | $fb99
    .byte %00000000 ; |        | $fb9a
    .byte %00000000 ; |        | $fb9b
    .byte %00000000 ; |        | $fb9c
    .byte %00000000 ; |        | $fb9d
    .byte %00000000 ; |        | $fb9e
    .byte %00000000 ; |        | $fb9f
Lfba0:
    .byte %00000000 ; |        | $fba0
    .byte %00000000 ; |        | $fba1
    .byte %00000000 ; |        | $fba2
    .byte %00000001 ; |       X| $fba3
    .byte %00000000 ; |        | $fba4
    .byte %00000100 ; |     X  | $fba5
    .byte %00000000 ; |        | $fba6
    .byte %00000000 ; |        | $fba7
    .byte %00000000 ; |        | $fba8
    .byte %00000000 ; |        | $fba9
    .byte %00000000 ; |        | $fbaa
    .byte %00000000 ; |        | $fbab
    .byte %00001000 ; |    X   | $fbac
    .byte %00000010 ; |      X | $fbad
    .byte %00001000 ; |    X   | $fbae
    .byte %00000100 ; |     X  | $fbaf
    .byte %00000000 ; |        | $fbb0
    .byte %00000001 ; |       X| $fbb1
    .byte %00001000 ; |    X   | $fbb2
    .byte %00000100 ; |     X  | $fbb3
    .byte %00000000 ; |        | $fbb4
    .byte %11110010 ; |XXXX  X | $fbb5
    .byte %11110000 ; |XXXX    | $fbb6
    .byte %00000000 ; |        | $fbb7
    .byte %00000000 ; |        | $fbb8
    .byte %00000010 ; |      X | $fbb9
    .byte %00000001 ; |       X| $fbba
    .byte %00000010 ; |      X | $fbbb
    .byte %00000000 ; |        | $fbbc
    .byte %00001000 ; |    X   | $fbbd
    .byte %00000000 ; |        | $fbbe
    .byte %00000000 ; |        | $fbbf
    .byte %00000000 ; |        | $fbc0
    .byte %00000000 ; |        | $fbc1
    .byte %00000000 ; |        | $fbc2
    .byte %00000000 ; |        | $fbc3
    .byte %00000000 ; |        | $fbc4
    .byte %00000000 ; |        | $fbc5
    .byte %00000000 ; |        | $fbc6
    .byte %00000000 ; |        | $fbc7
    .byte %00000000 ; |        | $fbc8
    .byte %00000000 ; |        | $fbc9
    .byte %00000000 ; |        | $fbca
    .byte %00000000 ; |        | $fbcb
    .byte %00000000 ; |        | $fbcc
    .byte %00000000 ; |        | $fbcd
    .byte %00000000 ; |        | $fbce
    .byte %00000000 ; |        | $fbcf
    .byte %00000000 ; |        | $fbd0
    .byte %00000000 ; |        | $fbd1
    .byte %00000000 ; |        | $fbd2
    .byte %00000000 ; |        | $fbd3
    .byte %00000000 ; |        | $fbd4
    .byte %00000000 ; |        | $fbd5
    .byte %00000000 ; |        | $fbd6
    .byte %00000000 ; |        | $fbd7
    .byte %00000000 ; |        | $fbd8
    .byte %00000000 ; |        | $fbd9
    .byte %00000000 ; |        | $fbda
    .byte %00000000 ; |        | $fbdb
    .byte %00000000 ; |        | $fbdc
    .byte %00000000 ; |        | $fbdd
    .byte %00000000 ; |        | $fbde
    .byte %00000000 ; |        | $fbdf
    .byte %00000000 ; |        | $fbe0
    .byte %00000000 ; |        | $fbe1
    .byte %00000000 ; |        | $fbe2
    .byte %00000000 ; |        | $fbe3
    .byte %00000000 ; |        | $fbe4
    .byte %00000000 ; |        | $fbe5
    .byte %00000000 ; |        | $fbe6
    .byte %00000000 ; |        | $fbe7
    .byte %00000000 ; |        | $fbe8
    .byte %00000000 ; |        | $fbe9
    .byte %00000000 ; |        | $fbea
    .byte %00000000 ; |        | $fbeb
    .byte %00000000 ; |        | $fbec
    .byte %00000000 ; |        | $fbed
    .byte %00000000 ; |        | $fbee
    .byte %00000000 ; |        | $fbef
    .byte %00000000 ; |        | $fbf0
    .byte %00000000 ; |        | $fbf1
Lfbf2:
    .byte %00000000 ; |        | $fbf2
    .byte %11110000 ; |XXXX    | $fbf3
    .byte %11110000 ; |XXXX    | $fbf4
    .byte %10010000 ; |X  X    | $fbf5
    .byte %11110000 ; |XXXX    | $fbf6
    .byte %00000000 ; |        | $fbf7
    .byte %00000000 ; |        | $fbf8
    .byte %00000010 ; |      X | $fbf9
    .byte %00000010 ; |      X | $fbfa
    .byte %00011110 ; |   XXXX | $fbfb
    .byte %00111010 ; |  XXX X | $fbfc
    .byte %01110010 ; | XXX  X | $fbfd
    .byte %01101000 ; | XX X   | $fbfe
    .byte %00000000 ; |        | $fbff
Lfc00:
    .byte %00000000 ; |        | $fc00
    .byte %11111111 ; |XXXXXXXX| $fc01
    .byte %00100001 ; |  X    X| $fc02
    .byte %11111111 ; |XXXXXXXX| $fc03
    .byte %11110000 ; |XXXX    | $fc04
    .byte %00000011 ; |      XX| $fc05
    .byte %00000011 ; |      XX| $fc06
    .byte %00000011 ; |      XX| $fc07
    .byte %00000011 ; |      XX| $fc08
    .byte %00000011 ; |      XX| $fc09
    .byte %00000011 ; |      XX| $fc0a
    .byte %00000011 ; |      XX| $fc0b
    .byte %00000011 ; |      XX| $fc0c
    .byte %00000011 ; |      XX| $fc0d
    .byte %00000011 ; |      XX| $fc0e
    .byte %00000011 ; |      XX| $fc0f
    .byte %00000011 ; |      XX| $fc10
    .byte %00000011 ; |      XX| $fc11
    .byte %00000011 ; |      XX| $fc12
    .byte %00000011 ; |      XX| $fc13
    .byte %00000001 ; |       X| $fc14
    .byte %00000001 ; |       X| $fc15
    .byte %00000001 ; |       X| $fc16
    .byte %00000001 ; |       X| $fc17
    .byte %00000001 ; |       X| $fc18
    .byte %00000001 ; |       X| $fc19
    .byte %00000111 ; |     XXX| $fc1a
    .byte %00000111 ; |     XXX| $fc1b
    .byte %00001001 ; |    X  X| $fc1c
    .byte %00001001 ; |    X  X| $fc1d
    .byte %00011101 ; |   XXX X| $fc1e
    .byte %00011101 ; |   XXX X| $fc1f
    .byte %00111011 ; |  XXX XX| $fc20
    .byte %00111011 ; |  XXX XX| $fc21
    .byte %00111111 ; |  XXXXXX| $fc22
    .byte %00111111 ; |  XXXXXX| $fc23
    .byte %00111111 ; |  XXXXXX| $fc24
    .byte %00111111 ; |  XXXXXX| $fc25
    .byte %00111111 ; |  XXXXXX| $fc26
    .byte %00111111 ; |  XXXXXX| $fc27
    .byte %00111111 ; |  XXXXXX| $fc28
    .byte %00111111 ; |  XXXXXX| $fc29
    .byte %00111111 ; |  XXXXXX| $fc2a
    .byte %00111111 ; |  XXXXXX| $fc2b
    .byte %00101111 ; |  X XXXX| $fc2c
    .byte %00101111 ; |  X XXXX| $fc2d
    .byte %00011111 ; |   XXXXX| $fc2e
    .byte %00011111 ; |   XXXXX| $fc2f
    .byte %00001111 ; |    XXXX| $fc30
    .byte %00001111 ; |    XXXX| $fc31
    .byte %00000111 ; |     XXX| $fc32
    .byte %00000111 ; |     XXX| $fc33
    .byte %00000001 ; |       X| $fc34
    .byte %00000000 ; |        | $fc35
    .byte %10000000 ; |X       | $fc36
    .byte %10010000 ; |X  X    | $fc37
    .byte %10010000 ; |X  X    | $fc38
    .byte %11110000 ; |XXXX    | $fc39
    .byte %10010000 ; |X  X    | $fc3a
    .byte %11110000 ; |XXXX    | $fc3b
    .byte %10010000 ; |X  X    | $fc3c
    .byte %11110000 ; |XXXX    | $fc3d
    .byte %10010000 ; |X  X    | $fc3e
    .byte %00010000 ; |   X    | $fc3f
    .byte %00000000 ; |        | $fc40
    .byte %00000000 ; |        | $fc41
    .byte %00000000 ; |        | $fc42
    .byte %00000000 ; |        | $fc43
    .byte %00000000 ; |        | $fc44
    .byte %00000000 ; |        | $fc45
    .byte %00000000 ; |        | $fc46
    .byte %00000000 ; |        | $fc47
    .byte %00000000 ; |        | $fc48
    .byte %00000000 ; |        | $fc49
    .byte %00000000 ; |        | $fc4a
    .byte %00000000 ; |        | $fc4b
    .byte %00000000 ; |        | $fc4c
    .byte %00000000 ; |        | $fc4d
    .byte %00000000 ; |        | $fc4e
    .byte %00000000 ; |        | $fc4f
    .byte %00000000 ; |        | $fc50
    .byte %00000000 ; |        | $fc51
    .byte %00000000 ; |        | $fc52
    .byte %00000000 ; |        | $fc53
    .byte %00000000 ; |        | $fc54
    .byte %00000000 ; |        | $fc55
    .byte %00000000 ; |        | $fc56
    .byte %00000000 ; |        | $fc57
    .byte %00000000 ; |        | $fc58
    .byte %00000000 ; |        | $fc59
    .byte %00000000 ; |        | $fc5a
    .byte %00000000 ; |        | $fc5b
    .byte %00000000 ; |        | $fc5c
    .byte %00000000 ; |        | $fc5d
    .byte %00000000 ; |        | $fc5e
    .byte %00000000 ; |        | $fc5f
    .byte %00000000 ; |        | $fc60
    .byte %00000000 ; |        | $fc61
    .byte %00000000 ; |        | $fc62
    .byte %00000000 ; |        | $fc63
    .byte %00000000 ; |        | $fc64
    .byte %00000000 ; |        | $fc65
    .byte %00000000 ; |        | $fc66
    .byte %00000000 ; |        | $fc67
    .byte %00000000 ; |        | $fc68
    .byte %00000000 ; |        | $fc69
    .byte %00000000 ; |        | $fc6a
    .byte %11111111 ; |XXXXXXXX| $fc6b
    .byte %01001000 ; | X  X   | $fc6c
    .byte %11111111 ; |XXXXXXXX| $fc6d
    .byte %11110000 ; |XXXX    | $fc6e
    .byte %00000000 ; |        | $fc6f
    .byte %01000000 ; | X      | $fc70
    .byte %11000010 ; |XX    X | $fc71
    .byte %01111110 ; | XXXXXX | $fc72
    .byte %11000010 ; |XX    X | $fc73
    .byte %01111110 ; | XXXXXX | $fc74
    .byte %11000010 ; |XX    X | $fc75
    .byte %01111110 ; | XXXXXX | $fc76
    .byte %01000010 ; | X    X | $fc77
    .byte %00000010 ; |      X | $fc78
    .byte %00000000 ; |        | $fc79
    .byte %00000000 ; |        | $fc7a
    .byte %00000000 ; |        | $fc7b
    .byte %00000000 ; |        | $fc7c
    .byte %00000000 ; |        | $fc7d
    .byte %11000000 ; |XX      | $fc7e
    .byte %11110000 ; |XXXX    | $fc7f
    .byte %11111111 ; |XXXXXXXX| $fc80
    .byte %11111111 ; |XXXXXXXX| $fc81
    .byte %11111111 ; |XXXXXXXX| $fc82
    .byte %11111111 ; |XXXXXXXX| $fc83
    .byte %11111111 ; |XXXXXXXX| $fc84
    .byte %11111111 ; |XXXXXXXX| $fc85
    .byte %11111111 ; |XXXXXXXX| $fc86
    .byte %11111101 ; |XXXXXX X| $fc87
    .byte %11111000 ; |XXXXX   | $fc88
    .byte %11110000 ; |XXXX    | $fc89
    .byte %11100000 ; |XXX     | $fc8a
    .byte %11000000 ; |XX      | $fc8b
    .byte %10000000 ; |X       | $fc8c
    .byte %00000000 ; |        | $fc8d
    .byte %00000000 ; |        | $fc8e
    .byte %00000000 ; |        | $fc8f
    .byte %00000000 ; |        | $fc90
    .byte %00000000 ; |        | $fc91
    .byte %00000000 ; |        | $fc92
    .byte %00000000 ; |        | $fc93
    .byte %00000000 ; |        | $fc94
    .byte %00000000 ; |        | $fc95
    .byte %00000000 ; |        | $fc96
    .byte %00000000 ; |        | $fc97
    .byte %00000000 ; |        | $fc98
    .byte %00000000 ; |        | $fc99
    .byte %00000000 ; |        | $fc9a
    .byte %00000000 ; |        | $fc9b
    .byte %00000000 ; |        | $fc9c
    .byte %00000000 ; |        | $fc9d
    .byte %00000000 ; |        | $fc9e
    .byte %00000000 ; |        | $fc9f
    .byte %00000000 ; |        | $fca0
    .byte %00000000 ; |        | $fca1
    .byte %00000000 ; |        | $fca2
    .byte %00000000 ; |        | $fca3
    .byte %00000000 ; |        | $fca4
    .byte %00000000 ; |        | $fca5
    .byte %00000000 ; |        | $fca6
    .byte %00000000 ; |        | $fca7
    .byte %00000000 ; |        | $fca8
    .byte %00000000 ; |        | $fca9
    .byte %00000000 ; |        | $fcaa
    .byte %00000000 ; |        | $fcab
    .byte %00000000 ; |        | $fcac
    .byte %00000000 ; |        | $fcad
    .byte %00000000 ; |        | $fcae
    .byte %00000000 ; |        | $fcaf
    .byte %00000000 ; |        | $fcb0
    .byte %00000000 ; |        | $fcb1
    .byte %00000000 ; |        | $fcb2
    .byte %00000000 ; |        | $fcb3
    .byte %01111001 ; | XXXX  X| $fcb4
    .byte %00000000 ; |        | $fcb5
    .byte %11111111 ; |XXXXXXXX| $fcb6
    .byte %00000000 ; |        | $fcb7
    .byte %00000000 ; |        | $fcb8
    .byte %00000000 ; |        | $fcb9
    .byte %00000000 ; |        | $fcba
    .byte %00000000 ; |        | $fcbb
    .byte %00000000 ; |        | $fcbc
    .byte %00000000 ; |        | $fcbd
    .byte %00000000 ; |        | $fcbe
    .byte %00000000 ; |        | $fcbf
    .byte %00000000 ; |        | $fcc0
    .byte %00000000 ; |        | $fcc1
    .byte %00000000 ; |        | $fcc2
    .byte %00000000 ; |        | $fcc3
    .byte %00000000 ; |        | $fcc4
    .byte %00000000 ; |        | $fcc5
    .byte %00000000 ; |        | $fcc6
    .byte %00000001 ; |       X| $fcc7
    .byte %00000001 ; |       X| $fcc8
    .byte %00000001 ; |       X| $fcc9
    .byte %00000001 ; |       X| $fcca
    .byte %00000000 ; |        | $fccb
    .byte %00000000 ; |        | $fccc
    .byte %00000000 ; |        | $fccd
    .byte %00000000 ; |        | $fcce
    .byte %00000000 ; |        | $fccf
    .byte %00000000 ; |        | $fcd0
    .byte %00000000 ; |        | $fcd1
    .byte %00000000 ; |        | $fcd2
    .byte %00000000 ; |        | $fcd3
    .byte %00000000 ; |        | $fcd4
    .byte %00000000 ; |        | $fcd5
    .byte %00000000 ; |        | $fcd6
    .byte %00000000 ; |        | $fcd7
    .byte %00000000 ; |        | $fcd8
    .byte %00000000 ; |        | $fcd9
    .byte %00000000 ; |        | $fcda
    .byte %00000000 ; |        | $fcdb
    .byte %00000000 ; |        | $fcdc
    .byte %00000000 ; |        | $fcdd
    .byte %00000000 ; |        | $fcde
    .byte %00000000 ; |        | $fcdf
    .byte %00000000 ; |        | $fce0
    .byte %00000000 ; |        | $fce1
    .byte %00000000 ; |        | $fce2
    .byte %00000000 ; |        | $fce3
    .byte %00000000 ; |        | $fce4
    .byte %00000000 ; |        | $fce5
    .byte %00000000 ; |        | $fce6
    .byte %00000000 ; |        | $fce7
    .byte %00000000 ; |        | $fce8
    .byte %00000001 ; |       X| $fce9
    .byte %00000001 ; |       X| $fcea
    .byte %00000001 ; |       X| $fceb
    .byte %00000000 ; |        | $fcec
    .byte %00000000 ; |        | $fced
    .byte %00000000 ; |        | $fcee
    .byte %00000000 ; |        | $fcef
    .byte %00000000 ; |        | $fcf0
    .byte %00000000 ; |        | $fcf1
Lfcf2:
    .byte %00000000 ; |        | $fcf2
    .byte %11111111 ; |XXXXXXXX| $fcf3
    .byte %11111111 ; |XXXXXXXX| $fcf4
    .byte %00100001 ; |  X    X| $fcf5
    .byte %11111111 ; |XXXXXXXX| $fcf6
    .byte %11110000 ; |XXXX    | $fcf7
    .byte %00000000 ; |        | $fcf8
    .byte %00000000 ; |        | $fcf9
    .byte %00000100 ; |     X  | $fcfa
    .byte %00011100 ; |   XXX  | $fcfb
    .byte %00000000 ; |        | $fcfc
    .byte %00000001 ; |       X| $fcfd
    .byte %00000001 ; |       X| $fcfe
    .byte %00000001 ; |       X| $fcff
Lfd00:
    .byte %00000000 ; |        | $fd00
    .byte %11111111 ; |XXXXXXXX| $fd01
    .byte %11111101 ; |XXXXXX X| $fd02
    .byte %00001111 ; |    XXXX| $fd03
    .byte %00000000 ; |        | $fd04
    .byte %00000000 ; |        | $fd05
    .byte %00000000 ; |        | $fd06
    .byte %00000000 ; |        | $fd07
    .byte %00000000 ; |        | $fd08
    .byte %00000000 ; |        | $fd09
    .byte %00000000 ; |        | $fd0a
    .byte %00000000 ; |        | $fd0b
    .byte %00000000 ; |        | $fd0c
    .byte %00000000 ; |        | $fd0d
    .byte %00000000 ; |        | $fd0e
    .byte %00000000 ; |        | $fd0f
    .byte %00000000 ; |        | $fd10
    .byte %00000000 ; |        | $fd11
    .byte %00000001 ; |       X| $fd12
    .byte %00000001 ; |       X| $fd13
    .byte %00000001 ; |       X| $fd14
    .byte %00000001 ; |       X| $fd15
    .byte %00000011 ; |      XX| $fd16
    .byte %00000011 ; |      XX| $fd17
    .byte %00001111 ; |    XXXX| $fd18
    .byte %00001111 ; |    XXXX| $fd19
    .byte %00010001 ; |   X   X| $fd1a
    .byte %00010001 ; |   X   X| $fd1b
    .byte %00010011 ; |   X  XX| $fd1c
    .byte %00010011 ; |   X  XX| $fd1d
    .byte %00110111 ; |  XX XXX| $fd1e
    .byte %00110111 ; |  XX XXX| $fd1f
    .byte %01111111 ; | XXXXXXX| $fd20
    .byte %01111111 ; | XXXXXXX| $fd21
    .byte %01111111 ; | XXXXXXX| $fd22
    .byte %01111111 ; | XXXXXXX| $fd23
    .byte %01111111 ; | XXXXXXX| $fd24
    .byte %01111111 ; | XXXXXXX| $fd25
    .byte %01011111 ; | X XXXXX| $fd26
    .byte %01011111 ; | X XXXXX| $fd27
    .byte %01111111 ; | XXXXXXX| $fd28
    .byte %01111111 ; | XXXXXXX| $fd29
    .byte %01111111 ; | XXXXXXX| $fd2a
    .byte %01111111 ; | XXXXXXX| $fd2b
    .byte %01111111 ; | XXXXXXX| $fd2c
    .byte %00111111 ; |  XXXXXX| $fd2d
    .byte %00011111 ; |   XXXXX| $fd2e
    .byte %00011111 ; |   XXXXX| $fd2f
    .byte %00001011 ; |    X XX| $fd30
    .byte %00001011 ; |    X XX| $fd31
    .byte %00000111 ; |     XXX| $fd32
    .byte %00000111 ; |     XXX| $fd33
    .byte %00000111 ; |     XXX| $fd34
    .byte %00000000 ; |        | $fd35
    .byte %11111110 ; |XXXXXXX | $fd36
    .byte %11111110 ; |XXXXXXX | $fd37
    .byte %11111110 ; |XXXXXXX | $fd38
    .byte %11111110 ; |XXXXXXX | $fd39
    .byte %11111110 ; |XXXXXXX | $fd3a
    .byte %11111110 ; |XXXXXXX | $fd3b
    .byte %11111110 ; |XXXXXXX | $fd3c
    .byte %11111110 ; |XXXXXXX | $fd3d
    .byte %01100110 ; | XX  XX | $fd3e
    .byte %01100110 ; | XX  XX | $fd3f
    .byte %01100110 ; | XX  XX | $fd40
    .byte %01100110 ; | XX  XX | $fd41
    .byte %01100110 ; | XX  XX | $fd42
    .byte %01100110 ; | XX  XX | $fd43
    .byte %01100110 ; | XX  XX | $fd44
    .byte %01100110 ; | XX  XX | $fd45
    .byte %11111110 ; |XXXXXXX | $fd46
    .byte %11111110 ; |XXXXXXX | $fd47
    .byte %11111110 ; |XXXXXXX | $fd48
    .byte %11111110 ; |XXXXXXX | $fd49
    .byte %11111110 ; |XXXXXXX | $fd4a
    .byte %11111110 ; |XXXXXXX | $fd4b
    .byte %11111110 ; |XXXXXXX | $fd4c
    .byte %01100110 ; | XX  XX | $fd4d
    .byte %01100110 ; | XX  XX | $fd4e
    .byte %01100110 ; | XX  XX | $fd4f
    .byte %01100110 ; | XX  XX | $fd50
    .byte %01100110 ; | XX  XX | $fd51
    .byte %01100110 ; | XX  XX | $fd52
    .byte %01100110 ; | XX  XX | $fd53
    .byte %01100110 ; | XX  XX | $fd54
    .byte %11111110 ; |XXXXXXX | $fd55
    .byte %11111110 ; |XXXXXXX | $fd56
    .byte %11111110 ; |XXXXXXX | $fd57
    .byte %11111110 ; |XXXXXXX | $fd58
    .byte %11111100 ; |XXXXXX  | $fd59
    .byte %11111100 ; |XXXXXX  | $fd5a
    .byte %11111000 ; |XXXXX   | $fd5b
    .byte %11111000 ; |XXXXX   | $fd5c
    .byte %11110000 ; |XXXX    | $fd5d
    .byte %11110000 ; |XXXX    | $fd5e
    .byte %11100000 ; |XXX     | $fd5f
    .byte %11100000 ; |XXX     | $fd60
    .byte %11000000 ; |XX      | $fd61
    .byte %11000000 ; |XX      | $fd62
    .byte %10000000 ; |X       | $fd63
    .byte %10000000 ; |X       | $fd64
    .byte %00000000 ; |        | $fd65
    .byte %00000000 ; |        | $fd66
    .byte %00000000 ; |        | $fd67
    .byte %00000000 ; |        | $fd68
    .byte %00000000 ; |        | $fd69
    .byte %00000000 ; |        | $fd6a
    .byte %11111111 ; |XXXXXXXX| $fd6b
    .byte %11111101 ; |XXXXXX X| $fd6c
    .byte %00001111 ; |    XXXX| $fd6d
    .byte %00000000 ; |        | $fd6e
    .byte %00000000 ; |        | $fd6f
    .byte %00000000 ; |        | $fd70
    .byte %00000000 ; |        | $fd71
    .byte %00000000 ; |        | $fd72
    .byte %00000000 ; |        | $fd73
    .byte %00000000 ; |        | $fd74
    .byte %00000000 ; |        | $fd75
    .byte %00000000 ; |        | $fd76
    .byte %00000000 ; |        | $fd77
    .byte %00000000 ; |        | $fd78
    .byte %00000000 ; |        | $fd79
    .byte %00000000 ; |        | $fd7a
    .byte %00000000 ; |        | $fd7b
    .byte %00000000 ; |        | $fd7c
    .byte %11000000 ; |XX      | $fd7d
    .byte %11110000 ; |XXXX    | $fd7e
    .byte %11111111 ; |XXXXXXXX| $fd7f
    .byte %11111111 ; |XXXXXXXX| $fd80
    .byte %11111111 ; |XXXXXXXX| $fd81
    .byte %11111111 ; |XXXXXXXX| $fd82
    .byte %11111111 ; |XXXXXXXX| $fd83
    .byte %11111111 ; |XXXXXXXX| $fd84
    .byte %11111111 ; |XXXXXXXX| $fd85
    .byte %11111111 ; |XXXXXXXX| $fd86
    .byte %11111111 ; |XXXXXXXX| $fd87
    .byte %11111111 ; |XXXXXXXX| $fd88
    .byte %11111110 ; |XXXXXXX | $fd89
    .byte %01111100 ; | XXXXX  | $fd8a
    .byte %00111000 ; |  XXX   | $fd8b
    .byte %00010000 ; |   X    | $fd8c
    .byte %00000000 ; |        | $fd8d
    .byte %00000000 ; |        | $fd8e
    .byte %00000000 ; |        | $fd8f
    .byte %00000000 ; |        | $fd90
    .byte %00000000 ; |        | $fd91
    .byte %00000000 ; |        | $fd92
    .byte %00000000 ; |        | $fd93
    .byte %00000000 ; |        | $fd94
    .byte %00000000 ; |        | $fd95
    .byte %00000000 ; |        | $fd96
    .byte %00000000 ; |        | $fd97
    .byte %00000000 ; |        | $fd98
    .byte %00000000 ; |        | $fd99
    .byte %00000000 ; |        | $fd9a
    .byte %00000000 ; |        | $fd9b
    .byte %00000000 ; |        | $fd9c
    .byte %00000000 ; |        | $fd9d
    .byte %00000000 ; |        | $fd9e
    .byte %00000000 ; |        | $fd9f
    .byte %00000000 ; |        | $fda0
    .byte %11111100 ; |XXXXXX  | $fda1
    .byte %11111100 ; |XXXXXX  | $fda2
    .byte %11111110 ; |XXXXXXX | $fda3
    .byte %11111110 ; |XXXXXXX | $fda4
    .byte %11111111 ; |XXXXXXXX| $fda5
    .byte %11111111 ; |XXXXXXXX| $fda6
    .byte %11111110 ; |XXXXXXX | $fda7
    .byte %11111000 ; |XXXXX   | $fda8
    .byte %11100000 ; |XXX     | $fda9
    .byte %00000000 ; |        | $fdaa
    .byte %00000000 ; |        | $fdab
    .byte %00000000 ; |        | $fdac
    .byte %00000000 ; |        | $fdad
    .byte %00000000 ; |        | $fdae
    .byte %00000000 ; |        | $fdaf
    .byte %00000000 ; |        | $fdb0
    .byte %00000000 ; |        | $fdb1
    .byte %00000000 ; |        | $fdb2
    .byte %00000000 ; |        | $fdb3
    .byte %10001000 ; |X   X   | $fdb4
    .byte %00110011 ; |  XX  XX| $fdb5
    .byte %11111111 ; |XXXXXXXX| $fdb6
    .byte %00000000 ; |        | $fdb7
    .byte %00000000 ; |        | $fdb8
    .byte %00000000 ; |        | $fdb9
    .byte %00000000 ; |        | $fdba
    .byte %00000000 ; |        | $fdbb
    .byte %00000000 ; |        | $fdbc
    .byte %00000000 ; |        | $fdbd
    .byte %00000000 ; |        | $fdbe
    .byte %00000000 ; |        | $fdbf
    .byte %00000000 ; |        | $fdc0
    .byte %00000000 ; |        | $fdc1
    .byte %00000000 ; |        | $fdc2
    .byte %00000000 ; |        | $fdc3
    .byte %00000000 ; |        | $fdc4
    .byte %00000000 ; |        | $fdc5
    .byte %00000000 ; |        | $fdc6
    .byte %10011001 ; |X  XX  X| $fdc7
    .byte %10011001 ; |X  XX  X| $fdc8
    .byte %10011001 ; |X  XX  X| $fdc9
    .byte %10011001 ; |X  XX  X| $fdca
    .byte %10011000 ; |X  XX   | $fdcb
    .byte %10011000 ; |X  XX   | $fdcc
    .byte %10000000 ; |X       | $fdcd
    .byte %10000000 ; |X       | $fdce
    .byte %00000000 ; |        | $fdcf
    .byte %00000000 ; |        | $fdd0
    .byte %00000000 ; |        | $fdd1
    .byte %00000000 ; |        | $fdd2
    .byte %10011000 ; |X  XX   | $fdd3
    .byte %10011000 ; |X  XX   | $fdd4
    .byte %10011000 ; |X  XX   | $fdd5
    .byte %10011000 ; |X  XX   | $fdd6
    .byte %00000000 ; |        | $fdd7
    .byte %00000000 ; |        | $fdd8
    .byte %00000000 ; |        | $fdd9
    .byte %00000000 ; |        | $fdda
    .byte %00000000 ; |        | $fddb
    .byte %00000000 ; |        | $fddc
    .byte %01100110 ; | XX  XX | $fddd
    .byte %01100110 ; | XX  XX | $fdde
    .byte %01100110 ; | XX  XX | $fddf
    .byte %00000000 ; |        | $fde0
    .byte %00000000 ; |        | $fde1
    .byte %00000000 ; |        | $fde2
    .byte %00000000 ; |        | $fde3
    .byte %00000000 ; |        | $fde4
    .byte %00000000 ; |        | $fde5
    .byte %00000000 ; |        | $fde6
    .byte %00000000 ; |        | $fde7
    .byte %00000000 ; |        | $fde8
    .byte %10011001 ; |X  XX  X| $fde9
    .byte %10011001 ; |X  XX  X| $fdea
    .byte %10011001 ; |X  XX  X| $fdeb
    .byte %00000000 ; |        | $fdec
    .byte %00000000 ; |        | $fded
    .byte %00000000 ; |        | $fdee
    .byte %00000000 ; |        | $fdef
    .byte %00000000 ; |        | $fdf0
    .byte %00000000 ; |        | $fdf1
Lfdf2:
    .byte %00000000 ; |        | $fdf2
    .byte %11111111 ; |XXXXXXXX| $fdf3
    .byte %11111111 ; |XXXXXXXX| $fdf4
    .byte %11111101 ; |XXXXXX X| $fdf5
    .byte %00001111 ; |    XXXX| $fdf6
    .byte %00000000 ; |        | $fdf7
    .byte %00000000 ; |        | $fdf8
    .byte %00000000 ; |        | $fdf9
    .byte %00010000 ; |   X    | $fdfa
    .byte %01011000 ; | X XX   | $fdfb
    .byte %00011000 ; |   XX   | $fdfc
    .byte %00011000 ; |   XX   | $fdfd
    .byte %00110100 ; |  XX X  | $fdfe
    .byte %00010000 ; |   X    | $fdff
    .byte %00000000 ; |        | $fe00
    .byte %00000000 ; |        | $fe01
    .byte %11000000 ; |XX      | $fe02
    .byte %11001100 ; |XX  XX  | $fe03
    .byte %11101100 ; |XXX XX  | $fe04
    .byte %01111100 ; | XXXXX  | $fe05
    .byte %11111100 ; |XXXXXX  | $fe06
    .byte %01111100 ; | XXXXX  | $fe07
    .byte %00111100 ; |  XXXX  | $fe08
    .byte %00111110 ; |  XXXXX | $fe09
    .byte %00111110 ; |  XXXXX | $fe0a
    .byte %11111100 ; |XXXXXX  | $fe0b
    .byte %11111000 ; |XXXXX   | $fe0c
Lfe0d:
    .byte %00011000 ; |   XX   | $fe0d
    .byte %00111100 ; |  XXXX  | $fe0e
    .byte %01111100 ; | XXXXX  | $fe0f
    .byte %01101000 ; | XX X   | $fe10
    .byte %01111100 ; | XXXXX  | $fe11
    .byte %00111000 ; |  XXX   | $fe12
    .byte %01101000 ; | XX X   | $fe13
    .byte %11011000 ; |XX XX   | $fe14
    .byte %11011000 ; |XX XX   | $fe15
    .byte %00000000 ; |        | $fe16
    .byte %00000000 ; |        | $fe17
    .byte %00011000 ; |   XX   | $fe18
    .byte %00111000 ; |  XXX   | $fe19
    .byte %00111000 ; |  XXX   | $fe1a
    .byte %00011100 ; |   XXX  | $fe1b
    .byte %01111110 ; | XXXXXX | $fe1c
    .byte %01111110 ; | XXXXXX | $fe1d
    .byte %00111100 ; |  XXXX  | $fe1e
    .byte %00111100 ; |  XXXX  | $fe1f
    .byte %01111111 ; | XXXXXXX| $fe20
    .byte %01111111 ; | XXXXXXX| $fe21
    .byte %00111100 ; |  XXXX  | $fe22
    .byte %00011000 ; |   XX   | $fe23
    .byte %00111100 ; |  XXXX  | $fe24
    .byte %01111100 ; | XXXXX  | $fe25
    .byte %01101000 ; | XX X   | $fe26
    .byte %01111100 ; | XXXXX  | $fe27
    .byte %00111000 ; |  XXX   | $fe28
    .byte %01101000 ; | XX X   | $fe29
    .byte %11011000 ; |XX XX   | $fe2a
    .byte %11011000 ; |XX XX   | $fe2b
    .byte %00000000 ; |        | $fe2c
    .byte %00000000 ; |        | $fe2d
    .byte %00110000 ; |  XX    | $fe2e
    .byte %00111000 ; |  XXX   | $fe2f
    .byte %00111000 ; |  XXX   | $fe30
    .byte %00111000 ; |  XXX   | $fe31
    .byte %00111111 ; |  XXXXXX| $fe32
    .byte %00111110 ; |  XXXXX | $fe33
    .byte %00111110 ; |  XXXXX | $fe34
    .byte %11011100 ; |XX XXX  | $fe35
    .byte %11111100 ; |XXXXXX  | $fe36
    .byte %01111110 ; | XXXXXX | $fe37
    .byte %00111110 ; |  XXXXX | $fe38
    .byte %00011000 ; |   XX   | $fe39
    .byte %00111100 ; |  XXXX  | $fe3a
    .byte %01111100 ; | XXXXX  | $fe3b
    .byte %01101000 ; | XX X   | $fe3c
    .byte %01111100 ; | XXXXX  | $fe3d
    .byte %00111000 ; |  XXX   | $fe3e
    .byte %01101000 ; | XX X   | $fe3f
    .byte %11011000 ; |XX XX   | $fe40
    .byte %11011000 ; |XX XX   | $fe41
    .byte %00000000 ; |        | $fe42
    .byte %00000000 ; |        | $fe43
    .byte %00111000 ; |  XXX   | $fe44
    .byte %00111000 ; |  XXX   | $fe45
    .byte %00111000 ; |  XXX   | $fe46
    .byte %00111000 ; |  XXX   | $fe47
    .byte %11111110 ; |XXXXXXX | $fe48
    .byte %01111110 ; | XXXXXX | $fe49
    .byte %00111100 ; |  XXXX  | $fe4a
    .byte %11011011 ; |XX XX XX| $fe4b
    .byte %11111111 ; |XXXXXXXX| $fe4c
    .byte %01111110 ; | XXXXXX | $fe4d
    .byte %00111100 ; |  XXXX  | $fe4e
    .byte %00111000 ; |  XXX   | $fe4f
    .byte %01111100 ; | XXXXX  | $fe50
    .byte %01111100 ; | XXXXX  | $fe51
    .byte %01101000 ; | XX X   | $fe52
    .byte %01111100 ; | XXXXX  | $fe53
    .byte %00111000 ; |  XXX   | $fe54
    .byte %01101000 ; | XX X   | $fe55
    .byte %11011000 ; |XX XX   | $fe56
    .byte %11011000 ; |XX XX   | $fe57
    .byte %00000000 ; |        | $fe58
    .byte %00000000 ; |        | $fe59
    .byte %00000000 ; |        | $fe5a
    .byte %00000000 ; |        | $fe5b
    .byte %00000000 ; |        | $fe5c
    .byte %00000000 ; |        | $fe5d
    .byte %00001111 ; |    XXXX| $fe5e
    .byte %11111111 ; |XXXXXXXX| $fe5f
    .byte %01111111 ; | XXXXXXX| $fe60
    .byte %01111110 ; | XXXXXX | $fe61
    .byte %00111100 ; |  XXXX  | $fe62
    .byte %11111110 ; |XXXXXXX | $fe63
    .byte %11111110 ; |XXXXXXX | $fe64
    .byte %00011000 ; |   XX   | $fe65
    .byte %00111100 ; |  XXXX  | $fe66
    .byte %01111100 ; | XXXXX  | $fe67
    .byte %01101000 ; | XX X   | $fe68
    .byte %01111100 ; | XXXXX  | $fe69
    .byte %00111000 ; |  XXX   | $fe6a
    .byte %01101000 ; | XX X   | $fe6b
    .byte %11011000 ; |XX XX   | $fe6c
    .byte %11011000 ; |XX XX   | $fe6d
    .byte %00000000 ; |        | $fe6e
    .byte %00000000 ; |        | $fe6f
    .byte %00000000 ; |        | $fe70
    .byte %00000000 ; |        | $fe71
    .byte %00000000 ; |        | $fe72
    .byte %00000000 ; |        | $fe73
    .byte %00001111 ; |    XXXX| $fe74
    .byte %11111111 ; |XXXXXXXX| $fe75
    .byte %01111111 ; | XXXXXXX| $fe76
    .byte %01111110 ; | XXXXXX | $fe77
    .byte %00111100 ; |  XXXX  | $fe78
    .byte %11111110 ; |XXXXXXX | $fe79
    .byte %11111110 ; |XXXXXXX | $fe7a
    .byte %00011000 ; |   XX   | $fe7b
    .byte %00111100 ; |  XXXX  | $fe7c
    .byte %01111100 ; | XXXXX  | $fe7d
    .byte %01101000 ; | XX X   | $fe7e
    .byte %01111100 ; | XXXXX  | $fe7f
    .byte %00111000 ; |  XXX   | $fe80
    .byte %01101000 ; | XX X   | $fe81
    .byte %11011000 ; |XX XX   | $fe82
    .byte %11011000 ; |XX XX   | $fe83
    .byte %00011000 ; |   XX   | $fe84
    .byte %00111100 ; |  XXXX  | $fe85
    .byte %11111111 ; |XXXXXXXX| $fe86
    .byte %11111111 ; |XXXXXXXX| $fe87
    .byte %10001001 ; |X   X  X| $fe88
    .byte %10001001 ; |X   X  X| $fe89
    .byte %10001001 ; |X   X  X| $fe8a
    .byte %10001001 ; |X   X  X| $fe8b
    .byte %10001001 ; |X   X  X| $fe8c
    .byte %10001001 ; |X   X  X| $fe8d
    .byte %10001001 ; |X   X  X| $fe8e
    .byte %11111111 ; |XXXXXXXX| $fe8f
    .byte %10001001 ; |X   X  X| $fe90
    .byte %10001001 ; |X   X  X| $fe91
    .byte %10001001 ; |X   X  X| $fe92
    .byte %10001001 ; |X   X  X| $fe93
    .byte %10001001 ; |X   X  X| $fe94
    .byte %10001001 ; |X   X  X| $fe95
    .byte %10001001 ; |X   X  X| $fe96
    .byte %11111111 ; |XXXXXXXX| $fe97
    .byte %11111111 ; |XXXXXXXX| $fe98
    .byte %01111110 ; | XXXXXX | $fe99
    .byte %01111110 ; | XXXXXX | $fe9a
    .byte %11100111 ; |XXX  XXX| $fe9b
    .byte %00000000 ; |        | $fe9c
    .byte %00000000 ; |        | $fe9d
    .byte %00000000 ; |        | $fe9e
    .byte %00000000 ; |        | $fe9f
    .byte %00000000 ; |        | $fea0
    .byte %00011000 ; |   XX   | $fea1
    .byte %00111100 ; |  XXXX  | $fea2
    .byte %11111111 ; |XXXXXXXX| $fea3
    .byte %11111111 ; |XXXXXXXX| $fea4
    .byte %10001001 ; |X   X  X| $fea5
    .byte %10001001 ; |X   X  X| $fea6
    .byte %10001001 ; |X   X  X| $fea7
    .byte %10001001 ; |X   X  X| $fea8
    .byte %10001001 ; |X   X  X| $fea9
    .byte %10001001 ; |X   X  X| $feaa
    .byte %10001001 ; |X   X  X| $feab
    .byte %11111111 ; |XXXXXXXX| $feac
    .byte %10001001 ; |X   X  X| $fead
    .byte %10001001 ; |X   X  X| $feae
    .byte %10001001 ; |X   X  X| $feaf
    .byte %10001001 ; |X   X  X| $feb0
    .byte %10001001 ; |X   X  X| $feb1
    .byte %10001001 ; |X   X  X| $feb2
    .byte %10001001 ; |X   X  X| $feb3
    .byte %11111111 ; |XXXXXXXX| $feb4
    .byte %11111111 ; |XXXXXXXX| $feb5
    .byte %01111110 ; | XXXXXX | $feb6
    .byte %01111110 ; | XXXXXX | $feb7
    .byte %11100111 ; |XXX  XXX| $feb8
    .byte %00000000 ; |        | $feb9
    .byte %00000000 ; |        | $feba
    .byte %00000000 ; |        | $febb
    .byte %00011100 ; |   XXX  | $febc
    .byte %01111111 ; | XXXXXXX| $febd
    .byte %11111111 ; |XXXXXXXX| $febe
    .byte %11111111 ; |XXXXXXXX| $febf
    .byte %11111111 ; |XXXXXXXX| $fec0
    .byte %01111110 ; | XXXXXX | $fec1
    .byte %01111100 ; | XXXXX  | $fec2
    .byte %00111000 ; |  XXX   | $fec3
    .byte %00000000 ; |        | $fec4
    .byte %00000000 ; |        | $fec5
    .byte %00000000 ; |        | $fec6
    .byte %10000000 ; |X       | $fec7
    .byte %10000000 ; |X       | $fec8
    .byte %10000000 ; |X       | $fec9
    .byte %10000000 ; |X       | $feca
    .byte %10000000 ; |X       | $fecb
    .byte %10000000 ; |X       | $fecc
    .byte %10000000 ; |X       | $fecd
    .byte %10000000 ; |X       | $fece
    .byte %10000000 ; |X       | $fecf
    .byte %10000000 ; |X       | $fed0
    .byte %10000000 ; |X       | $fed1
    .byte %10000000 ; |X       | $fed2
    .byte %10000000 ; |X       | $fed3
    .byte %10000000 ; |X       | $fed4
    .byte %10000000 ; |X       | $fed5
    .byte %10000000 ; |X       | $fed6
    .byte %10000000 ; |X       | $fed7
    .byte %10000000 ; |X       | $fed8
    .byte %10000000 ; |X       | $fed9
    .byte %10000000 ; |X       | $feda
    .byte %10000000 ; |X       | $fedb
    .byte %10000000 ; |X       | $fedc
    .byte %10000000 ; |X       | $fedd
    .byte %10000000 ; |X       | $fede
    .byte %10000000 ; |X       | $fedf
    .byte %10000000 ; |X       | $fee0
    .byte %10000000 ; |X       | $fee1
    .byte %10000000 ; |X       | $fee2
    .byte %10000000 ; |X       | $fee3
    .byte %10000000 ; |X       | $fee4
    .byte %10000000 ; |X       | $fee5
    .byte %10000000 ; |X       | $fee6
    .byte %10000000 ; |X       | $fee7
    .byte %10000000 ; |X       | $fee8
    .byte %00000000 ; |        | $fee9
    .byte %00000000 ; |        | $feea
    .byte %11010110 ; |XX X XX | $feeb
    .byte %01111100 ; | XXXXX  | $feec
    .byte %00011000 ; |   XX   | $feed
    .byte %00010000 ; |   X    | $feee
    .byte %00010000 ; |   X    | $feef
    .byte %01011000 ; | X XX   | $fef0
    .byte %00110010 ; |  XX  X | $fef1
    .byte %00000000 ; |        | $fef2
    .byte %00000000 ; |        | $fef3
    .byte %00000000 ; |        | $fef4
    .byte %00000000 ; |        | $fef5
    .byte %00000000 ; |        | $fef6
    .byte %00000000 ; |        | $fef7
    .byte %01100010 ; | XX   X | $fef8
    .byte %01110010 ; | XXX  X | $fef9
    .byte %00111110 ; |  XXXXX | $fefa
    .byte %00011010 ; |   XX X | $fefb
    .byte %00010010 ; |   X  X | $fefc
    .byte %00000000 ; |        | $fefd
    .byte %00000001 ; |       X| $fefe
    .byte %00000001 ; |       X| $feff
    .byte %00000000 ; |        | $ff00
    .byte %00000000 ; |        | $ff01
    .byte %00001000 ; |    X   | $ff02
    .byte %00001000 ; |    X   | $ff03
    .byte %00111000 ; |  XXX   | $ff04
    .byte %00111000 ; |  XXX   | $ff05
    .byte %00111010 ; |  XXX X | $ff06
    .byte %00111010 ; |  XXX X | $ff07
    .byte %00111010 ; |  XXX X | $ff08
    .byte %00111010 ; |  XXX X | $ff09
    .byte %00111010 ; |  XXX X | $ff0a
    .byte %00111010 ; |  XXX X | $ff0b
    .byte %00111010 ; |  XXX X | $ff0c
Lff0d:
    .byte %00111000 ; |  XXX   | $ff0d
    .byte %00111000 ; |  XXX   | $ff0e
    .byte %00111000 ; |  XXX   | $ff0f
    .byte %00111000 ; |  XXX   | $ff10
    .byte %00011010 ; |   XX X | $ff11
    .byte %00011010 ; |   XX X | $ff12
    .byte %00001010 ; |    X X | $ff13
    .byte %00011010 ; |   XX X | $ff14
    .byte %00011010 ; |   XX X | $ff15
    .byte %00011110 ; |   XXXX | $ff16
    .byte %00011110 ; |   XXXX | $ff17
    .byte %00011110 ; |   XXXX | $ff18
    .byte %00011110 ; |   XXXX | $ff19
    .byte %00011110 ; |   XXXX | $ff1a
    .byte %00011110 ; |   XXXX | $ff1b
    .byte %00011110 ; |   XXXX | $ff1c
    .byte %00011110 ; |   XXXX | $ff1d
    .byte %00011110 ; |   XXXX | $ff1e
    .byte %00011110 ; |   XXXX | $ff1f
    .byte %00011110 ; |   XXXX | $ff20
    .byte %00011110 ; |   XXXX | $ff21
    .byte %00011110 ; |   XXXX | $ff22
    .byte %00011110 ; |   XXXX | $ff23
    .byte %00011110 ; |   XXXX | $ff24
    .byte %00011110 ; |   XXXX | $ff25
    .byte %00011110 ; |   XXXX | $ff26
    .byte %00011110 ; |   XXXX | $ff27
    .byte %00011110 ; |   XXXX | $ff28
    .byte %00011110 ; |   XXXX | $ff29
    .byte %00011110 ; |   XXXX | $ff2a
    .byte %00011110 ; |   XXXX | $ff2b
    .byte %00011110 ; |   XXXX | $ff2c
    .byte %00011110 ; |   XXXX | $ff2d
    .byte %00011110 ; |   XXXX | $ff2e
    .byte %00011110 ; |   XXXX | $ff2f
    .byte %00011110 ; |   XXXX | $ff30
    .byte %00011110 ; |   XXXX | $ff31
    .byte %00011110 ; |   XXXX | $ff32
    .byte %00011110 ; |   XXXX | $ff33
    .byte %00011110 ; |   XXXX | $ff34
    .byte %00011110 ; |   XXXX | $ff35
    .byte %00011110 ; |   XXXX | $ff36
    .byte %00011110 ; |   XXXX | $ff37
    .byte %00011110 ; |   XXXX | $ff38
    .byte %00011110 ; |   XXXX | $ff39
    .byte %00011110 ; |   XXXX | $ff3a
    .byte %00011110 ; |   XXXX | $ff3b
    .byte %00011110 ; |   XXXX | $ff3c
    .byte %00011110 ; |   XXXX | $ff3d
    .byte %00011110 ; |   XXXX | $ff3e
    .byte %00011110 ; |   XXXX | $ff3f
    .byte %00011110 ; |   XXXX | $ff40
    .byte %00011110 ; |   XXXX | $ff41
    .byte %00011110 ; |   XXXX | $ff42
    .byte %00011110 ; |   XXXX | $ff43
    .byte %00011110 ; |   XXXX | $ff44
    .byte %00011110 ; |   XXXX | $ff45
    .byte %00011110 ; |   XXXX | $ff46
    .byte %00011110 ; |   XXXX | $ff47
    .byte %00011110 ; |   XXXX | $ff48
    .byte %00011110 ; |   XXXX | $ff49
    .byte %00011110 ; |   XXXX | $ff4a
    .byte %00011110 ; |   XXXX | $ff4b
    .byte %00011110 ; |   XXXX | $ff4c
    .byte %00011110 ; |   XXXX | $ff4d
    .byte %00011110 ; |   XXXX | $ff4e
    .byte %00011110 ; |   XXXX | $ff4f
    .byte %00011110 ; |   XXXX | $ff50
    .byte %00011110 ; |   XXXX | $ff51
    .byte %00011110 ; |   XXXX | $ff52
    .byte %00011110 ; |   XXXX | $ff53
    .byte %00011110 ; |   XXXX | $ff54
    .byte %00011110 ; |   XXXX | $ff55
    .byte %11010100 ; |XX X X  | $ff56
    .byte %11010100 ; |XX X X  | $ff57
    .byte %11010100 ; |XX X X  | $ff58
    .byte %11010100 ; |XX X X  | $ff59
    .byte %11010100 ; |XX X X  | $ff5a
    .byte %11010100 ; |XX X X  | $ff5b
    .byte %11010100 ; |XX X X  | $ff5c
    .byte %11010100 ; |XX X X  | $ff5d
    .byte %11010100 ; |XX X X  | $ff5e
    .byte %11010100 ; |XX X X  | $ff5f
    .byte %00000110 ; |     XX | $ff60
    .byte %00000110 ; |     XX | $ff61
    .byte %00000110 ; |     XX | $ff62
    .byte %00000110 ; |     XX | $ff63
    .byte %00000110 ; |     XX | $ff64
    .byte %01110010 ; | XXX  X | $ff65
    .byte %01110010 ; | XXX  X | $ff66
    .byte %00000110 ; |     XX | $ff67
    .byte %00000110 ; |     XX | $ff68
    .byte %01110010 ; | XXX  X | $ff69
    .byte %01110010 ; | XXX  X | $ff6a
    .byte %00011110 ; |   XXXX | $ff6b
    .byte %00011110 ; |   XXXX | $ff6c
    .byte %00011110 ; |   XXXX | $ff6d
    .byte %00011110 ; |   XXXX | $ff6e
    .byte %00000000 ; |        | $ff6f
    .byte %00000000 ; |        | $ff70
    .byte %00011110 ; |   XXXX | $ff71
    .byte %00011110 ; |   XXXX | $ff72
    .byte %00000110 ; |     XX | $ff73
    .byte %00000110 ; |     XX | $ff74
    .byte %00000110 ; |     XX | $ff75
    .byte %00001000 ; |    X   | $ff76
    .byte %00001000 ; |    X   | $ff77
    .byte %00000000 ; |        | $ff78
    .byte %00001000 ; |    X   | $ff79
    .byte %00001000 ; |    X   | $ff7a
    .byte %00000000 ; |        | $ff7b
    .byte %00001000 ; |    X   | $ff7c
    .byte %00000000 ; |        | $ff7d
    .byte %00001000 ; |    X   | $ff7e
    .byte %00001000 ; |    X   | $ff7f
    .byte %01000001 ; | X     X| $ff80
    .byte %00001000 ; |    X   | $ff81
    .byte %00001000 ; |    X   | $ff82
    .byte %01010101 ; | X X X X| $ff83
    .byte %00100010 ; |  X   X | $ff84
    .byte %11111111 ; |XXXXXXXX| $ff85
    .byte %11111111 ; |XXXXXXXX| $ff86
    .byte %00001000 ; |    X   | $ff87
    .byte %00001000 ; |    X   | $ff88
    .byte %00001000 ; |    X   | $ff89
    .byte %00000000 ; |        | $ff8a
    .byte %00001000 ; |    X   | $ff8b
    .byte %00001000 ; |    X   | $ff8c
    .byte %00000000 ; |        | $ff8d
    .byte %00001000 ; |    X   | $ff8e
    .byte %00000000 ; |        | $ff8f
    .byte %00001000 ; |    X   | $ff90
    .byte %00001000 ; |    X   | $ff91
    .byte %00100010 ; |  X   X | $ff92
    .byte %00001000 ; |    X   | $ff93
    .byte %00101010 ; |  X X X | $ff94
    .byte %00010100 ; |   X X  | $ff95
    .byte %11111111 ; |XXXXXXXX| $ff96
    .byte %11111111 ; |XXXXXXXX| $ff97
    .byte %00001010 ; |    X X | $ff98
    .byte %00001010 ; |    X X | $ff99
    .byte %00001010 ; |    X X | $ff9a
    .byte %00001010 ; |    X X | $ff9b
    .byte %00001010 ; |    X X | $ff9c
    .byte %00001010 ; |    X X | $ff9d
    .byte %00001010 ; |    X X | $ff9e
    .byte %00001010 ; |    X X | $ff9f
    .byte %00001010 ; |    X X | $ffa0
    .byte %00001010 ; |    X X | $ffa1
    .byte %00001010 ; |    X X | $ffa2
    .byte %00001010 ; |    X X | $ffa3
    .byte %00001010 ; |    X X | $ffa4
    .byte %00001010 ; |    X X | $ffa5
    .byte %00001010 ; |    X X | $ffa6
    .byte %00110010 ; |  XX  X | $ffa7
    .byte %00110010 ; |  XX  X | $ffa8
    .byte %01110010 ; | XXX  X | $ffa9
    .byte %01110010 ; | XXX  X | $ffaa
    .byte %01110010 ; | XXX  X | $ffab
    .byte %01110010 ; | XXX  X | $ffac
    .byte %01110010 ; | XXX  X | $ffad
    .byte %01110010 ; | XXX  X | $ffae
    .byte %01110010 ; | XXX  X | $ffaf
    .byte %01110010 ; | XXX  X | $ffb0
    .byte %01110010 ; | XXX  X | $ffb1
    .byte %01110010 ; | XXX  X | $ffb2
    .byte %01110010 ; | XXX  X | $ffb3
    .byte %01110010 ; | XXX  X | $ffb4
    .byte %01110010 ; | XXX  X | $ffb5
    .byte %01110010 ; | XXX  X | $ffb6
    .byte %01110010 ; | XXX  X | $ffb7
    .byte %01110010 ; | XXX  X | $ffb8
    .byte %01110010 ; | XXX  X | $ffb9
    .byte %01110010 ; | XXX  X | $ffba
    .byte %01110010 ; | XXX  X | $ffbb
    .byte %01110010 ; | XXX  X | $ffbc
    .byte %01110010 ; | XXX  X | $ffbd
    .byte %01110010 ; | XXX  X | $ffbe
    .byte %01110010 ; | XXX  X | $ffbf
    .byte %01110010 ; | XXX  X | $ffc0
    .byte %01110010 ; | XXX  X | $ffc1
    .byte %01110010 ; | XXX  X | $ffc2
    .byte %01110010 ; | XXX  X | $ffc3
    .byte %01110010 ; | XXX  X | $ffc4
    .byte %01110010 ; | XXX  X | $ffc5
    .byte %01110010 ; | XXX  X | $ffc6
    .byte %01110010 ; | XXX  X | $ffc7
    .byte %01110010 ; | XXX  X | $ffc8
    .byte %01110010 ; | XXX  X | $ffc9
    .byte %01110010 ; | XXX  X | $ffca
    .byte %00110000 ; |  XX    | $ffcb
    .byte %00110000 ; |  XX    | $ffcc
    .byte %00110000 ; |  XX    | $ffcd
    .byte %00110000 ; |  XX    | $ffce
    .byte %00110000 ; |  XX    | $ffcf
    .byte %00110000 ; |  XX    | $ffd0
    .byte %00110000 ; |  XX    | $ffd1
    .byte %00110000 ; |  XX    | $ffd2
    .byte %00110000 ; |  XX    | $ffd3
    .byte %00100000 ; |  X     | $ffd4
    .byte %00100000 ; |  X     | $ffd5
    .byte %00100000 ; |  X     | $ffd6
    .byte %00100000 ; |  X     | $ffd7
    .byte %00100000 ; |  X     | $ffd8
    .byte %00100000 ; |  X     | $ffd9
    .byte %00011110 ; |   XXXX | $ffda
    .byte %00011110 ; |   XXXX | $ffdb
    .byte %00011110 ; |   XXXX | $ffdc
    .byte %00011110 ; |   XXXX | $ffdd
    .byte %00011110 ; |   XXXX | $ffde
    .byte %00110100 ; |  XX X  | $ffdf
    .byte %00110100 ; |  XX X  | $ffe0
    .byte %00011110 ; |   XXXX | $ffe1
    .byte %00011110 ; |   XXXX | $ffe2
    .byte %00011110 ; |   XXXX | $ffe3
    .byte %00111000 ; |  XXX   | $ffe4
    .byte %00111000 ; |  XXX   | $ffe5
    .byte %00111000 ; |  XXX   | $ffe6
    .byte %00111000 ; |  XXX   | $ffe7
    .byte %00111000 ; |  XXX   | $ffe8
    .byte %00111000 ; |  XXX   | $ffe9
    .byte %00111000 ; |  XXX   | $ffea
    .byte %00111000 ; |  XXX   | $ffeb
    .byte %00111000 ; |  XXX   | $ffec
    .byte %00111000 ; |  XXX   | $ffed
    .byte %00000000 ; |        | $ffee
    .byte %00000000 ; |        | $ffef
    .byte %00000100 ; |     X  | $fff0
    .byte %00110000 ; |  XX    | $fff1
    .byte %00011000 ; |   XX   | $fff2
    .byte %00011000 ; |   XX   | $fff3
    .byte %00100100 ; |  X  X  | $fff4
    .byte %00001000 ; |    X   | $fff5

    .byte %11111111 ; $ff ; |XXXXXXXX| $fff6
    .byte %11111111 ; $ff ; |XXXXXXXX| $fff7
Lfff8:
    .byte %11111111 ; $ff ; |XXXXXXXX| $fff8
    .byte %11111111 ; $ff ; |XXXXXXXX| $fff9
Lfffa:
    .byte $ff,$ff,$0d,$f0,$0d,$f0
